II1<-function(data, variables, group=NULL, trim=0.05, quantile=c(0.025,0.05,0.95,0.975),
variablesWM=NULL, variablesW=NULL, groupWM=NULL, file1="Output1.csv", file2="Output2.csv",
na="NA", dec=",", row.names=FALSE){


########################################################
# Seccion que realiza el procedimiento
########################################################

datos<-data


estadisticos<-function(datos){
 # Biblioteca requerida para la funcion 
 # Funciones auxiliares para el calculo de los estadisticos
 numTot<-function(x) length(x)
 numNA<-function(x) sum(!is.na(x))
 geometric.mean2<-function(x) psych::geometric.mean(x[!is.na(x)])
 harmonic.mean2<-function(x) psych::harmonic.mean(x[!is.na(x)])
 Cmoda<-function(x){
  x<-x[!is.na(x)]
  t<-table(x)
  modas<-as.numeric(names(t[t==max(t)]))
  if (length(modas)==1) return(modas) else return(NA) 
 }
 Tmoda<-function(x){
   x<-x[!is.na(x)]
   t<-table(x)
   modas<-as.numeric(names(t[t==max(t)]))
   if (length(modas)==1) return("Single mode") else {
      if (length(modas)==length(x)) return("There is no mode") else return("Multiples modes")
   }
 }
 dma<-function(x){
   x<-x[!is.na(x)]
   return(mean(abs(x-mean(x))))
 }
 dmeda<-function(x){
   x<-x[!is.na(x)]
   return(mean(abs(x-median(x))))
 }
 famplitud<-function(x) diff(range(x,na.rm=TRUE))
 eestd<-function(x) sd(x,na.rm=TRUE)/sqrt(length(x[!is.na(x)]))
 coefvar<-function(x) (sd(x,na.rm=TRUE)*100)/mean(x,na.rm=TRUE)
 Var<-function(X){
   X<-X[!is.na(X)]
   return(sum(((X-mean(X))^2)/length(X)))
 }
 Sd<-function(X){
   X<-X[!is.na(X)]
   return(sqrt(sum(((X-mean(X))^2)/length(X))))
 }
 if (is.vector(datos)){
  datos<-data.frame(datos)
 }
 # Aplicacion de los estadisticos por filas
N<-apply(datos,2,numTot)
noNA<-apply(datos,2,numNA)
minimum<-apply(datos,2,min,na.rm=TRUE)
maximum<-apply(datos,2,max,na.rm=TRUE)
sum<-apply(datos,2,sum,na.rm=TRUE)
mean<-apply(datos,2,mean,na.rm=T)
trimmed.mean<-apply(datos,2,mean,na.rm=T,trim=trim)
Geometric.mean<-apply(datos,2,geometric.mean2)
Harmonic.mean<-apply(datos,2,harmonic.mean2)
Median<-apply(datos,2,median,na.rm=TRUE)
Mode<-apply(datos,2,Cmoda)
Mode.type<-apply(datos,2,Tmoda)
Amplitude<-apply(datos,2,famplitud)
Quasi.variance<-apply(datos,2,var,na.rm=TRUE)
Variance<-apply(datos,2,Var)
Quasi.standard.deviation<-apply(datos,2,sd,na.rm=TRUE)
Standard.deviation<-apply(datos,2,Sd)
Absolute.deviation.mean<-apply(datos,2,dma)
Absolute.deviation.median<-apply(datos,2,mad,na.rm=TRUE)
Standard.error<-apply(datos,2,eestd)
CV<-apply(datos,2,coefvar)
Interquartile.range<-apply(datos,2,IQR,na.rm=T)
Asymmetry<-apply(datos,2,e1071::skewness,na.rm=TRUE)
Kurtosis<-apply(datos,2,e1071::kurtosis,na.rm=TRUE)
ctiles<-apply(datos,2,quantile,na.rm=TRUE,probs=quantile)
 # Concatenacion de los estadisticos en varias columnas
 resultado<-rbind(N,noNA,minimum,maximum,sum, mean,trimmed.mean,
                  Geometric.mean,Harmonic.mean,
                  Mode,Mode.type,Median,
                  Amplitude,Quasi.variance,Variance,
                  Quasi.standard.deviation,Standard.deviation,
                  Absolute.deviation.mean,
                  Absolute.deviation.median,
                  Standard.error,
                  CV, Interquartile.range,
                  Asymmetry,Kurtosis)
 ctiles<-data.frame(ctiles)
 row.names(ctiles)<-paste("Quantile",quantile,sep="_")
 resultado<-data.frame(t(data.frame(resultado)),t(data.frame(ctiles)))
 return(resultado)
}

if (length(group)>=2 & !is.null(group) ){
datos$grupos<-factor(apply(apply(datos[,group],2,as.character),1,paste,collapse="-"))
}else {if (is.null(group)) datos$grupos<-NULL else datos$grupos<-factor(datos[,group])}

resultados<-NULL
if (is.null(group)){
 resultados<-estadisticos(datos[,variables])
}else
{
 for (i in levels(datos$grupos)){
   r1<-estadisticos(subset(datos[,variables],datos$grupos==i))
   r2<-data.frame(Group=rep(i,nrow(r1)),r1)
   resultados<-rbind(resultados,r2)
  }
}

vars<-factor(rep(variables,nrow(resultados)/length(variables)))
resultados<-data.frame(variables=vars,resultados)

for (i in names(resultados)){
 if (i!="variables" & i!="Group" & i!="Mode.type") resultados[,i]<-as.numeric(as.character(resultados[,i]))
}

# Procedimiento para las medias ponderadas

resultadosp<-NULL
if (!is.null(variablesW) & !is.null(variablesWM) & length(variablesW)>=1){
  if (length(groupWM)>=1){
    # Seccion para cuando existe variables de agrupacion para la ponderacion
    datosp<-na.omit(datos[,c(variablesWM,variablesW,groupWM)])
    # Crear una variable de grupos de acuerdo si es una o varias las
    # variables de agrupacion.
    if (length(groupWM)>=2){
      datosp$grupos<-factor(apply(apply(datosp[,groupWM],2,as.character),1,paste,collapse="-"))
      }else datosp$grupos<-factor(datosp[,groupWM])
    # Ciclo que reocorre todos los grupos
    for (i in levels(datosp$grupos)){
        if (length(variablesWM)>=2){
            #Para cuando existen mas de dos variables de ponderacion
            if (length(variablesW)==1){
            resultadosp<-rbind(resultadosp,
                        apply(datosp[datosp$grupos==i,variablesWM],2,weighted.mean,datosp[datosp$grupos==i,variablesW]))
            }else{
            r1<-NULL
            for (j in 1:length(variablesW)){
                r1<-rbind(r1,
                        apply(datosp[datosp$grupos==i,variablesWM],2,weighted.mean,datosp[datosp$grupos==i,variablesW[j]]))
             }
            r1<-data.frame(r1,poderada.por=variablesW)
            resultadosp<-rbind(resultadosp,r1)
            }
          }else{
           # Para cuando existe una sola variable de ponderacion
           if (length(variablesW)==1){
           resultadosp<-rbind(resultadosp,
                        weighted.mean(datosp[datosp$grupos==i,variablesWM],datosp[datosp$grupos==i,variablesW]))     
           }else{
           r1<-NULL
           for (j in 1:length(variablesW)){
                r1<-rbind(r1,
                        apply(data.frame(datosp[datosp$grupos==i,variablesWM]),2,weighted.mean,datosp[datosp$grupos==i,variablesW[j]]))
           }
           r1<-data.frame(r1,poderada.por=variablesW)
           resultadosp<-rbind(resultadosp,r1)
           }
          }
      }
     if (length(variablesW)==1){
          IDgrupos=levels(datosp$grupos)
     }else{
         IDgrupos=rep(levels(datosp$grupos),each=length(variablesW))
     }
     resultadosp<-data.frame(IDgrupos,resultadosp)
     if (length(variablesWM)==1) names(resultadosp)[2]<-variablesWM
    }
   else
   {
    # Seccion para cuando no existe variables de agrupacion
    datosp<-na.omit(datos[,c(variablesWM,variablesW)])
    if (length(variablesWM)==1){
    # Seccion para cuando la variable de ponderacion es una sola
	if (length(variablesW)==1){        
	resultadosp<-weighted.mean(datosp[,variablesWM],datosp[,variablesW])
	resultadosp<-data.frame(resultadosp)
	names(resultadosp)<-variablesWM
        }else{
        r1<-NULL
        for (j in 1:length(variablesW)){
           r1<-rbind(r1,weighted.mean(datosp[,variablesWM],datosp[,variablesW[j]]))
        }
        r1<-data.frame(r1,Weighted.by=variablesW)
        names(r1)[1]<-variablesWM
        resultadosp<-rbind(resultadosp,r1)        
      }
    }else{
    # Seccion para varias variables de ponderacion
    if (length(variablesW)==1){
      resultadosp<-apply(datosp[,variablesWM],2,weighted.mean,datosp[,variablesW])
    }else{
      r1<-NULL
      for (j in 1:length(variablesW)){
	  r1<-rbind(r1,
		  apply(data.frame(datosp[,variablesWM]),2,weighted.mean,datosp[,variablesW[j]]))
      }
      r1<-data.frame(r1,poderada.por=variablesW)
      resultadosp<-rbind(resultadosp,r1)        
    }
    }
   }
}else
{
 mensaje<-c("\nWeighted average estimation is not performed\n")
}





########################################################
# Seccion que muestra los resultados
########################################################

print(resultados)

if(dec=="."){
write.csv(x=resultados,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = resultados,file = file1, fileEncoding = "", row.names=row.names,na=na)
}



if(!is.null(variablesW) & !is.null(variablesWM)){
 print(resultadosp)
if(dec=="."){
write.csv(x=resultadosp,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = resultadosp,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}else
{
 print(cat(mensaje))
}

}




