IV1<-function(data, variables, group=NULL, alfa=0.05, total=FALSE, file="Output.csv",
na="NA", dec=",", row.names=FALSE){


########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data

valores<-unlist(datos[,variables])
variables1<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),group])
names(agrupaciones)<-group

datos2<-data.frame(agrupaciones,Variable=variables1,valor=valores)

group<-c(group,"Variable")

# Funcin que devuelve slo el intervalo de confianza
# De acuerdo a las especifiaciones dadas.
IC<-function(x,sup=TRUE,alfa=0.05,total=TRUE){
   if (length(x[!is.na(x)])>=2){
    if (toupper(total)==TRUE){
       x<-x[!is.na(x)]
       n<-length(x)
       m<-mean(x, na.rm = TRUE)
       desv.tipica<-sqrt(sum((x-m)^2)/n)
       zalfa<-qnorm(1-alfa/2)
       v<-ifelse(sup,round(m+zalfa*desv.tipica/sqrt(n),7),round(m-zalfa*desv.tipica/sqrt(n),7))     
    }else{
      if (length(x[!is.na(x)])>=30){
         x<-x[!is.na(x)]
	 n<-length(x)
	 m<-mean(x, na.rm = TRUE)
	 desv.tipica<-sd(x, na.rm = TRUE)
	 zalfa<-qnorm(1-alfa/2)
	 v<-ifelse(sup,round(m+zalfa*desv.tipica/sqrt(n),7),round(m-zalfa*desv.tipica/sqrt(n),7))     
      }else{
         pruebaT<-t.test(x[!is.na(x)],conf.level=1-alfa)
         v<-ifelse(sup,round(pruebaT$conf.int[2],7),round(pruebaT$conf.int[1],7))
        }
    }
    return(v)
   } else return(NA)
  # else {if(length(x)==0) return(NULL) else return(c(NA,NA)) }
}

agrupa<-data.frame(datos2[,group])
if(length(group)==1) names(agrupa)<-group
media<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),mean,na.rm=TRUE),responseName="Mean")
ICs1<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),IC,alfa=alfa,total=total),responseName="UpperLim")
ICs2<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),IC,sup=FALSE,alfa=alfa,total=total),responseName="LowerLim")

ICs<-na.omit(data.frame(ICs2,Mean=media[,"Mean"],UpperLim=ICs1[,"UpperLim"]))

########################################################
# Seccin que muestra los resultados
########################################################

print(ICs)

if (!is.null(file)){

if(dec=="."){
write.csv(x=ICs,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = ICs,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}


}
