IV2<-function(data, variables, varSel, group=NULL, alfa=0.05, file = "Output.csv",
na="NA", dec=",", row.names=FALSE){


########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data

# Creacin de nuevas variables con los niveles propuestos.
w<-data.frame(row.names=1:dim(datos)[1])
varBin<-as.character()
for (i in 1:length(varSel)){
  nom<-varSel[[i]][1]
  x<-factor(datos[,nom])
  if (length(varSel[[i]])>1){
     sufijo<-paste(varSel[[i]][2:3],collapse="_")
     nom<-paste(nom,".",sufijo,sep="")
     x1<-factor(ifelse(x %in% varSel[[i]][2:3],as.character(x),NA))
     x1<-data.frame(factor(x1))
  }else{
     x1<-x
     x1<-data.frame(x)
  }
  names(x1)<-nom
  varBin<-c(varBin,nom)
  w<-data.frame(w,x1)
}

datos<-data.frame(datos,w)


# Verificacin de las variables de agrupacion binarias
# realmente lo son.
if (length(varBin)<1){
 stop("It should at least indicate a binary variable")
 }else{
 sonbinarios<-sapply(1:length(varBin),function(i) if(length(table(datos[,varBin[i]]))!=2) return(1) else return(0))
}
if (sum(sonbinarios)!=0)  stop("Some variable is not binary")

valores<-unlist(datos[,c(variables)])
variables<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),c(group,varBin)])
names(agrupaciones)<-c(group,varBin)

datos2<-data.frame(agrupaciones,variable=variables,valor=valores)


# Funcin que recibe dos vectores y calcula el intervalo
# de confianza para la diferencia de medias y muestra
# si hay diferencia probando primero si las varianzas
# son iguales y utilizando el estadstico de acuerdo
# a este resultado.

difMedias<-function(l,alfa=0.05){
 x<-l[[1]][!is.na(l[[1]])]
 y<-l[[2]][!is.na(l[[2]])]
 n1<-length(x)
 n2<-length(y)
 m1<-mean(x, na.rm = TRUE)
 m2<-mean(y, na.rm = TRUE)
 Difference<-m1-m2
 if ( n1< 2 | n2 < 2){
    r<-data.frame(n1=n1,n2=n2,
              mean1=m1,mean2=m2,
              LowerLim=NA,
              Difference=m1-m2,
              UpperLim=NA,
              ValuePMean=NA,
              ValuePVar=NA,
              VarEqual=NA)
 }else{ 
 r1<-var.test(x,y,conf.level=1-alfa)
 VarEqual<-(r1$p.value>=alfa)
 r2<-t.test(x,y,conf.level=1-alfa,var.equal=VarEqual)
 r<-data.frame(n1=n1,n2=n2,
              mean1=m1,mean2=m2,
              LowerLim=r2$conf.int[1],
              Difference=-diff(r2$estimate),
              UpperLim=r2$conf.int[2],
              ValuePMean=r2$p.value,
              ValuePVar=r1$p.value,
              VarEqual=VarEqual)
 }
 return(r)
}


# Funcin para dividir en grupos binarios la lista de variables
dividegrupos<-function(i,l,vB) split(l[[i]]$valor,l[[i]][,vB])
listdiv<-function(i,l,vB) {
    nombres<-names(l[[i]])
    l2<-lapply(1:length(l[[i]]),dividegrupos,l[[i]],vB[i])
    names(l2)<-nombres
    return(l2)
}

if(!is.null(group)) lista1<-as.list(datos2[,c(group,"variable")]) else lista1<-datos2$variable
listaG<-lapply(1:length(varBin),function(i) split(datos2[,c(varBin[i],"valor")],lista1,drop=TRUE))
listaG1<-lapply(1:length(listaG),listdiv,listaG,varBin)
r<-lapply(1:length(listaG1),function(i) t(sapply(listaG1[[i]],difMedias)))
names(r)<-varBin



rFin<-r[[1]]
f1<-function(i){ rFin<<-rbind(rFin,r[[i]]) }
if (length(r)>=2) invisible(lapply(2:length(r),f1) )
t1<-as.data.frame.table(table(datos2[,c(group,"variable")]))
identif<-t1[t1$Freq>0,]
d<-dim(rFin)
n<-colnames(rFin)
rFin<-data.frame(matrix(unlist(rFin),d))
names(rFin)<-n
rFin<-data.frame(Group=rep(names(r),each=dim(r[[1]])[1]),identif[rep(1:dim(identif)[1],length(r)),],rFin)
rFin<-rFin[with(rFin,n1!=0 | n2!=0),]
rFin$Result<-ifelse(rFin$ValuePMean>=alfa,"No signif dif means","Signif dif means")
rFin$Result[is.na(rFin$Result)]<-"Few data"
rFin$VarEqual<-ifelse(rFin$VarEqual==1,"Var not different","Var different")


########################################################
# Seccin que muestra los resultados
########################################################

print(rFin)

if (!is.null(file)){

if(dec=="."){
write.csv(x=rFin,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = rFin,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}


}



