IV4<-function(data, variables, varSel, group=NULL, alfa=0.05, file="Output.csv",
na="NA", dec=",", row.names=FALSE){


########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data


# Creacin de nuevas variables con los niveles propuestos.
w<-data.frame(row.names=1:dim(datos)[1])
varBin<-as.character()
for (i in 1:length(varSel)){
  nom<-varSel[[i]][1]
  x<-factor(datos[,nom])
  if (length(varSel[[i]])>1){
     sufijo<-paste(varSel[[i]][2:3],collapse="_")
     nom<-paste(nom,".",sufijo,sep="")
     x1<-factor(ifelse(x %in% varSel[[i]][2:3],as.character(x),NA))
     x1<-data.frame(factor(x1))
  }else{
     x1<-x
     x1<-data.frame(x)
  }
  names(x1)<-nom
  varBin<-c(varBin,nom)
  w<-data.frame(w,x1)
}

datos<-data.frame(datos,w)

# Verificacin de las variables de agrupacion binarias
# realmente lo son.
if (length(varBin)<1){
 stop("It should at least indicate a binary variable")
 }else{
 sonbinarios<-sapply(1:length(varBin),function(i) if(length(table(datos[,varBin[i]]))!=2) return(1) else return(0))
}
if (sum(sonbinarios)!=0)  stop("Some variable is not binary")

valores<-unlist(datos[,c(variables)])
variables1<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),c(group,varBin)])
names(agrupaciones)<-c(group,varBin)

datos2<-data.frame(agrupaciones,Variable=variables1,valor=valores)


# Funcin que recibe dos vectores y calcula el intervalo
# de confianza para razn de varianzas y
# muestra si hay o no diferencia estadstica

razonVar<-function(l,alfa=0.05){
 if(length(l)>1){
 x<-l[[1]][!is.na(l[[1]])]
 y<-l[[2]][!is.na(l[[2]])]
 n1<-length(x)
 n2<-length(y)
 if ( n1< 2 | n2 < 2){
    r<-data.frame(n1=n1,n2=n2,
                 SD1=NA,SD2=NA,
                 LowerLim=NA,Ratio=NA,UpperLim=NA,
                 valorPVar=NA,
                 LeveneStat=NA,
                 PvaluePLevene=NA,
                 Bm_ForsStat=NA,
                 PvalueBm_Fors=NA)
 }else{ 
 ds1<-sd(x, na.rm = TRUE)
 ds2<-sd(y, na.rm = TRUE)
 r1<-var.test(x,y,conf.level=1-alfa)
 x1<-c(x,y)
 g<-factor(c(rep(1,length(x)),rep(2,length(y))))
 r2<-lawstat::levene.test(x1,g,location="mean")
 r3<-lawstat::levene.test(x1,g,location="median")
 r<-data.frame(n1=n1,n2=n2,
               SD1=ds1,SD2=ds2,
               LowerLim=r1$conf.int[1],
               Ratio=r1$estimate,
               UpperLim=r1$conf.int[2],
               valorPVar=r1$p.value,
               LeveneStat=r2$statistic,
               PvaluePLevene=r2$p.value,
               Bm_ForsStat=r3$statistic,
               PvalueBm_Fors=r3$p.value)
 }
 }else{
      r<-data.frame(n1=0,n2=0,
                 SD1=NA,SD2=NA,
                 LowerLim=NA,Ratio=NA,UpperLim=NA,
                 valorP=NA,
                 LeveneStat=NA,
                 PvaluePLevene=NA,
                 Bm_ForsStat=NA,
                 PvalueBm_Fors=NA)
 }
 return(r)
}
# Funcin para dividir en grupos binarios la lista de variables
dividegrupos<-function(i,l,vB) split(l[[i]]$valor,l[[i]][,vB])
listdiv<-function(i,l,vB) {
    nombres<-names(l[[i]])
    l2<-lapply(1:length(l[[i]]),dividegrupos,l[[i]],vB[i])
    names(l2)<-nombres
    return(l2)
}

if(!is.null(group)) lista1<-as.list(datos2[,c(group,"Variable")]) else lista1<-datos2$Variable
listaG<-lapply(1:length(varBin),function(i) split(datos2[,c(varBin[i],"valor")],lista1,drop=TRUE))
listaG1<-lapply(1:length(listaG),listdiv,listaG,varBin)
r<-lapply(1:length(listaG1),function(i) t(sapply(listaG1[[i]],razonVar)))
names(r)<-varBin

rFin<-r[[1]]
f1<-function(i){ rFin<<-rbind(rFin,r[[i]]) }
if (length(r)>=2) invisible(lapply(2:length(r),f1) )
t1<-as.data.frame.table(table(datos2[,c(group,"Variable")]))
identif<-t1[t1$Freq>0,]
d<-dim(rFin)
n<-colnames(rFin)
rFin<-data.frame(matrix(unlist(rFin),d))
names(rFin)<-n
rFin<-data.frame(Group=rep(names(r),each=dim(r[[1]])[1]),identif[rep(1:dim(identif)[1],length(r)),],rFin)
rFin<-rFin[with(rFin,n1!=0 | n2!=0),]
rFin$Result<-ifelse(rFin$valorPVar>=alfa,"Var not different","Var different")
rFin$Result[is.na(rFin$Result)]<-"Few data"



########################################################
# Seccin que muestra los resultados
########################################################

print(rFin)

if (!is.null(file)){

if(dec=="."){
write.csv(x=rFin,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = rFin,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}

}

