IX1<-function(data, variables, factor, pop1,
pop2, trans=NULL, graph="Boxplot", PAR=NULL,
ResetPAR=TRUE, YLAB=NULL, XLAB=NULL,
OrderCat=NULL, LabelCat=NULL,
COLOR=NULL, BOXPLOT=NULL, BEANPLOT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=variables), subset(datos, select=factor))
datos<-na.exclude(datosT)

if (missing(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat

varSeleccion1<-NULL
varSeleccion2<-NULL


#Seleccin de un tipo de transformacin para las variables de inters. Si no se transforma la variable debe mantenerse la opcin "NULL".

if(!is.null(trans)){
 if(trans=="1/x2") varInteres1X2<-c(1,1) else varInteres1X2<-NULL
 if(trans=="1/x") varInteres1X<-c(1,1) else varInteres1X<-NULL
 if(trans=="LN") varInteresLN<-c(1,1) else varInteresLN<-NULL
 if(trans=="LOG") varInteresLOG10<-c(1,1) else varInteresLOG10<-NULL
 if(trans=="SQR") varInteresSQR<-c(1,1) else varInteresSQR<-NULL
 if(trans=="x2") varInteresX2<-c(1,1) else varInteresX2<-NULL
 if(trans=="x3") varInteresX3<-c(1,1) else varInteresX3<-NULL
 if(trans=="EXP") varInteresEX<-c(1,1) else varInteresEX<-NULL
 if(trans=="ASN") varInteresASN<-c(1,1) else varInteresASN<-NULL
}
else{
varInteres1X2<-NULL
varInteres1X<-NULL
varInteresLN<-NULL
varInteresLOG10<-NULL
varInteresSQR<-NULL
varInteresX2<-NULL
varInteresX3<-NULL
varInteresEX<-NULL
varInteresASN<-NULL
}



##Organizacin de los datos.
datos1<-na.omit(datos)
valores<-(datos1[,variables])
if (length(varInteres1X2)==2) valores<-1/((datos1[,variables])^2)
if (length(varInteres1X)==2) valores<-1/(datos1[,variables])
if (length(varInteresLN)==2) valores<-log(datos1[,variables])
if (length(varInteresLOG10)==2) valores<-log10(datos1[,variables])
if (length(varInteresSQR)==2) valores<-sqrt((datos1[,variables]))
if (length(varInteresX2)==2) valores<-(datos1[,variables])^2
if (length(varInteresX3)==2) valores<-(datos1[,variables])^3
if (length(varInteresEX)==2) valores<-exp(datos1[,variables])
if (length(varInteresASN)==2) valores<-asin((datos1[,variables]))
populations<-(datos1[,factor])

#Selecciones
if (length(varSeleccion1)!=0){
 w1<-data.frame(row.names=1:dim(datos1)[1])
 varBin1<-as.character()
 for (i in 1:length(varSeleccion1)){
   nom1<-varSeleccion1[[i]][1]
   x1<-factor(datos1[,nom1])
   if (length(varSeleccion1[[i]])>1){
      sufijo1<-paste(varSeleccion1[[i]][2:3],collapse="_")
      nom1<-paste(nom1,".",sufijo1,sep="")
      x11<-factor(ifelse(x1 %in% varSeleccion1[[i]][2:3],as.character(x1),NA))
      x11<-data.frame(factor(x11))
   }else{
      x11<-x1
      x11<-data.frame(x1)
   }
   names(x11)<-nom1
   varBin1<-c(varBin1,nom1)
   w1<-data.frame(w1,x11)
 }
}

if (length(varSeleccion2)!=0){
 w2<-data.frame(row.names=1:dim(datos1)[1])
 varBin2<-as.character()
 for (i in 1:length(varSeleccion2)){
   nom2<-varSeleccion2[[i]][1]
   x2<-factor(datos1[,nom2])
   if (length(varSeleccion2[[i]])>1){
      sufijo2<-paste(varSeleccion2[[i]][2:3],collapse="_")
      nom2<-paste(nom2,".",sufijo2,sep="")
      x12<-factor(ifelse(x2 %in% varSeleccion2[[i]][2:3],as.character(x2),NA))
      x12<-data.frame(factor(x12))
   }else{
      x12<-x2
      x12<-data.frame(x2)
   }
   names(x12)<-nom2
   varBin2<-c(varBin2,nom2)
   w2<-data.frame(w2,x12)
 }
}

if ((length(varSeleccion1)!=0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w1,w2)
if ((length(varSeleccion1)!=0)&(length(varSeleccion2)==0)) seleccion<-data.frame(w1)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w2)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)==0)) seleccion<-NULL

#Preparacin de los conjuntos de datos para el anlisis
if (length(seleccion)==0) datos2<-data.frame(populations,valores)
if (length(seleccion)!=0) datos2<-data.frame(seleccion,populations,valores)
datos2<-na.omit(datos2)
if (length(pop1)==1) {datos3a<-data.frame(datos2[(datos2$populations==pop1),])
                             datos3b<-data.frame(datos2[(datos2$populations==pop2),])
                             datos3<-data.frame(rbind(datos3a,datos3b))
}
if (length(pop1)==0) datos3<-data.frame(datos2)

##Pruebas
#Prueba de normalidad (test de Shapiro-Wilks).
residshapiro<-length(datos3[,"valores"])
if(3 < residshapiro & residshapiro <5000){
PruebaNormalidad<-by(datos3[,"valores"],datos3[,"populations"],shapiro.test)
}
else{
PruebaNormalidad<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}
 
#Prueba de heterocedasticidad (test de Levene).
PruebaHeterocedasticidadMedia<-lawstat::levene.test(datos3$valores,datos3$populations,location="mean")
PruebaHeterocedasticidadMediana<-lawstat::levene.test(datos3$valores,datos3$populations,location="median")

#Estudio del sesgo y curtosis.
Skewnessdatos<-c("Skewness",by(datos3[,"valores"],datos3[,"populations"],e1071::skewness))
Curtosisdatos<-c("Kurtosis", by(datos3[,"valores"],datos3[,"populations"],e1071::kurtosis,type=2))

#Test de la "t".
TestT<-t.test(datos3$valores~datos3$populations)

###############################################
#Seccin que muestra los resultados
###############################################

Resultados<-list(PruebaNormalidad,PruebaHeterocedasticidadMedia,PruebaHeterocedasticidadMediana,Skewnessdatos,Curtosisdatos,TestT)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(graph)){

dati<-subset(datos, datos[,factor]==pop1  |  datos[,factor]==pop2)


if(!is.null(COLOR)){
color<-COLOR
color1<-as.list(COLOR)
}
else{
color<-rainbow(2)
color1<-as.list(color)
}

dati[,factor]<-factor(dati[,factor], levels = c(pop1,pop2), labels = c(pop1,pop2))

if(!is.null(OrderCat)){
dati[,factor]<-factor(dati[,factor], levels = OrderCat, labels = LabelCat)
}
else{
if(!is.null(LabelCat)) dati[,factor]<-factor(dati[,factor], levels = c(pop1,pop2), labels = LabelCat) else dati<-dati
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-factor
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-variables

if(graph=="Boxplot"){

if(!is.null(BOXPLOT)){
boxplotexe<-paste("boxplot(","dati[,variables]~dati[,factor],",toString(x=BOXPLOT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","dati[,variables]~dati[,factor],","xlim=c(0.5,2.5),",
"ylab=Ylab,", "xlab=Xlab,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT)){
beanplotexe<-paste("beanplot::beanplot(","dati[,variables]~dati[,factor],",toString(x=BEANPLOT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","dati[,variables]~dati[,factor],","xlim=c(0.5,2.5),",
"ylab=Ylab,", "xlab=Xlab,","col=color1",")")
eval(parse(text=beanplotexe))
}


}

if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


}#Final graph
else{
}

rm(dati)





}
