IX10<-function(data, variables,  Factor, ResetPAR=TRUE, 
graph="Boxplot", PAR=NULL,YLAB=NULL, XLAB=NULL,
OrderCat=NULL, LabelCat=NULL,
COLOR=NULL, BOXPLOT=NULL, BEANPLOT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data


datosT<-data.frame(subset(datos, select=variables), subset(datos, select=Factor))
datos<-na.exclude(datosT)


if (missing(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat


varSeleccion1<-NULL
varSeleccion2<-NULL

FF1<-Factor


##Organizacin de los datos.
datos1<-na.omit(datos)
valores<-(datos1[,variables])
factores<-(datos1[,Factor])

#Selecciones
if (length(varSeleccion1)!=0){
 w1<-data.frame(row.names=1:dim(datos1)[1])
 varBin1<-as.character()
 for (i in 1:length(varSeleccion1)){
   nom1<-varSeleccion1[[i]][1]
   x1<-factor(datos1[,nom1])
   if (length(varSeleccion1[[i]])>1){
      sufijo1<-paste(varSeleccion1[[i]][2:3],collapse="_")
      nom1<-paste(nom1,".",sufijo1,sep="")
      x11<-factor(ifelse(x1 %in% varSeleccion1[[i]][2:3],as.character(x1),NA))
      x11<-data.frame(factor(x11))
   }else{
      x11<-x1
      x11<-data.frame(x1)
   }
   names(x11)<-nom1
   varBin1<-c(varBin1,nom1)
   w1<-data.frame(w1,x11)
 }
}

if (length(varSeleccion2)!=0){
 w2<-data.frame(row.names=1:dim(datos1)[1])
 varBin2<-as.character()
 for (i in 1:length(varSeleccion2)){
   nom2<-varSeleccion2[[i]][1]
   x2<-factor(datos1[,nom2])
   if (length(varSeleccion2[[i]])>1){
      sufijo2<-paste(varSeleccion2[[i]][2:3],collapse="_")
      nom2<-paste(nom2,".",sufijo2,sep="")
      x12<-factor(ifelse(x2 %in% varSeleccion2[[i]][2:3],as.character(x2),NA))
      x12<-data.frame(factor(x12))
   }else{
      x12<-x2
      x12<-data.frame(x2)
   }
   names(x12)<-nom2
   varBin2<-c(varBin2,nom2)
   w2<-data.frame(w2,x12)
 }
}

if ((length(varSeleccion1)!=0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w1,w2)
if ((length(varSeleccion1)!=0)&(length(varSeleccion2)==0)) seleccion<-data.frame(w1)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w2)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)==0)) seleccion<-NULL

#Preparacin de los conjuntos de datos para el anlisis
if (length(seleccion)==0) datos2<-data.frame(factores,valores)
if (length(seleccion)!=0) datos2<-data.frame(seleccion,factores,valores)
datos2<-na.omit(datos2)

#Prueba de Kruskal-Wallis.
Kruskal.Wallis<-kruskal.test(datos2$valores,datos2$factores)

###############################################
#Seccin que muestra los resultados
###############################################

Resultados<-list(Kruskal.Wallis)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(graph)){

if(!is.null(COLOR)){
color<-COLOR
color1<-as.list(COLOR)
}
else{
color<-terrain.colors(length(unique(datos[,FF1])))
color1<-as.list(color)
}

datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = unique(datos[,FF1]))

if(!is.null(OrderCat)){
datos[,FF1]<-factor(datos[,FF1], levels = OrderCat, labels = LabelCat)
}
else{
if(!is.null(LabelCat)) datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = LabelCat) else datos<-datos
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-FF1
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-variables

if(graph=="Boxplot"){

if(!is.null(BOXPLOT)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",toString(x=BOXPLOT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",
"ylab=Ylab,", "xlab=Xlab,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",toString(x=BEANPLOT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",
"ylab=Ylab,", "xlab=Xlab,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}




}
