IX11<-function(data, varTime, graph="Boxplot", PAR=NULL,
ResetPAR=TRUE, YLAB="Dependent variable", XLAB="Time",
LabelCat=NULL, COLOR=NULL, BOXPLOT=NULL, BEANPLOT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varTime))
datos<-na.exclude(datosT)


if (missing(LabelCat)) LabelCat=varTime else LabelCat=LabelCat


varSeleccion1<-NULL
varSeleccion2<-NULL

##Organizacin de los datos.
datos1<-na.omit(datos)
valores<-(datos1[,varTime])
names(valores)<-c("var1","var2")

#Selecciones
if (length(varSeleccion1)!=0){
 w1<-data.frame(row.names=1:dim(datos1)[1])
 varBin1<-as.character()
 for (i in 1:length(varSeleccion1)){
   nom1<-varSeleccion1[[i]][1]
   x1<-factor(datos1[,nom1])
   if (length(varSeleccion1[[i]])>1){
      sufijo1<-paste(varSeleccion1[[i]][2:3],collapse="_")
      nom1<-paste(nom1,".",sufijo1,sep="")
      x11<-factor(ifelse(x1 %in% varSeleccion1[[i]][2:3],as.character(x1),NA))
      x11<-data.frame(factor(x11))
   }else{
      x11<-x1
      x11<-data.frame(x1)
   }
   names(x11)<-nom1
   varBin1<-c(varBin1,nom1)
   w1<-data.frame(w1,x11)
 }
}

if (length(varSeleccion2)!=0){
 w2<-data.frame(row.names=1:dim(datos1)[1])
 varBin2<-as.character()
 for (i in 1:length(varSeleccion2)){
   nom2<-varSeleccion2[[i]][1]
   x2<-factor(datos1[,nom2])
   if (length(varSeleccion2[[i]])>1){
      sufijo2<-paste(varSeleccion2[[i]][2:3],collapse="_")
      nom2<-paste(nom2,".",sufijo2,sep="")
      x12<-factor(ifelse(x2 %in% varSeleccion2[[i]][2:3],as.character(x2),NA))
      x12<-data.frame(factor(x12))
   }else{
      x12<-x2
      x12<-data.frame(x2)
   }
   names(x12)<-nom2
   varBin2<-c(varBin2,nom2)
   w2<-data.frame(w2,x12)
 }
}

if ((length(varSeleccion1)!=0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w1,w2)
if ((length(varSeleccion1)!=0)&(length(varSeleccion2)==0)) seleccion<-data.frame(w1)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w2)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)==0)) seleccion<-NULL

#Preparacin de los conjuntos de datos para el anlisis
if (length(seleccion)==0) datos2<-data.frame(valores)
if (length(seleccion)!=0) datos2<-data.frame(seleccion,valores)
datos2<-na.omit(datos2)

#Test de Wilcoxon.
Wilcoxon<-wilcox.test(datos2$var1,datos2$var2,paired=TRUE)

###############################################
#Seccin que muestra los resultados
###############################################

Resultados<-list(Wilcoxon)



print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



datos1<-as.matrix(datos[,varTime])
num<-length(varTime)

d<-dim(datos1)
list<-d[1]

for (i in 1:(num-1)){
list<-append(list,d[1])
}

zz<-rep(varTime,list)

#Se convierte en una matrix de una columna
m<-matrix(datos1, ncol=1)

datos2<-data.frame(zz,m)




if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}




if(!is.null(graph)){

if(!is.null(COLOR)){
color<-COLOR
color1<-as.list(COLOR)
}
else{
color<-terrain.colors(length(unique(datos2[,1])))
color1<-as.list(color)
}



if(!is.null(LabelCat)) datos2[,1]<-factor(datos2[,1], levels = varTime, labels = LabelCat) else datos2[,1]<-factor(datos2[,1], levels = varTime, labels = varTime)


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph=="Boxplot"){



if(!is.null(BOXPLOT)){
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",toString(x=BOXPLOT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],","xlim=c(0.5,2.5),",
"ylab=YLAB,", "xlab=XLAB,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT)){
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",toString(x=BEANPLOT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],","xlim=c(0.5,2.5),",
"ylab=YLAB,", "xlab=XLAB,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}





}