IX12<-function(data, varTime, Case, graph="Boxplot", PAR=NULL,
ResetPAR=TRUE, YLAB="Dependent variable", XLAB="Time",
LabelCat=NULL, COLOR=NULL, BOXPLOT=NULL, BEANPLOT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varTime), subset(datos, select=Case))
datos<-na.exclude(datosT)


if (missing(LabelCat)) LabelCat=varTime else LabelCat=LabelCat



varSeleccion1<-NULL
varSeleccion2<-NULL

##Organizacin de los datos.
datos1<-na.omit(datos)
valores<-unlist(datos1[,varTime])
bloque<-unlist(datos1[,Case])
bloquetot<-rep(bloque,length(varTime))
variables<-unlist(varTime)
cont<-unlist(datos1[,1])
variablestot<-rep(variables,each=length(cont),1)
datos1<-data.frame(valores,bloquetot,variablestot)

#Test de Friedman.
Friedman<-friedman.test(datos1$valores,datos1$variablestot,datos1$bloquetot)

###############################################
#Seccin que muestra los resultados
###############################################

Resultados<-list(Friedman)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



datos1<-as.matrix(datos[,varTime])
num<-length(varTime)

d<-dim(datos1)
list<-d[1]

for (i in 1:(num-1)){
list<-append(list,d[1])
}

zz<-rep(varTime,list)

#Se convierte en una matrix de una columna
m<-matrix(datos1, ncol=1)

datos2<-data.frame(zz,m)




if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}




if(!is.null(graph)){

if(!is.null(COLOR)){
color<-COLOR
color1<-as.list(COLOR)
}
else{
color<-terrain.colors(length(unique(datos2[,1])))
color1<-as.list(color)
}



if(!is.null(LabelCat)) datos2[,1]<-factor(datos2[,1], levels = varTime, labels = LabelCat) else datos2[,1]<-factor(datos2[,1], levels = varTime, labels = varTime)


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph=="Boxplot"){



if(!is.null(BOXPLOT)){
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",toString(x=BOXPLOT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT)){
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",toString(x=BEANPLOT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}





}