IX13<-function(data, variables,  Factor, Covariable, T.AOV=NULL,
ResetPAR=TRUE, graph=TRUE, PAR=NULL, YLAB=NULL,
XLAB=NULL, MAIN=NULL, CEXPCH=1.3,  COLOR=NULL,
PCH=NULL, LEGEND=NULL, AXIS=NULL, MTEXT= NULL,
TEXT=NULL, file="Output.txt"){



###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=variables), subset(datos, select=Factor), subset(datos, select=Covariable))
datos<-na.exclude(datosT)

if (missing(T.AOV)) T.AOV=NULL else T.AOV=T.AOV
if (missing(ResetPAR)) ResetPAR=TRUE else ResetPAR=ResetPAR
if (missing(YLAB)) YLAB=NULL else YLAB=YLAB
if (missing(XLAB)) XLAB=NULL else XLAB=XLAB
if (missing(MAIN)) MAIN=NULL else MAIN=MAIN
if (missing(CEXPCH)) CEXPCH=1.3 else CEXPCH=CEXPCH
if (missing(graph)) graph=TRUE else graph=graph
if (missing(PAR)) PAR=NULL else PAR=PAR
if (missing(COLOR)) COLOR=NULL else COLOR=COLOR
if (missing(PCH)) PCH=NULL else PCH=PCH
if (missing(LEGEND)) LEGEND=NULL else LEGEND=LEGEND
if (missing(AXIS)) AXIS=NULL else AXIS=AXIS
if (missing(MTEXT)) MTEXT=NULL else MTEXT=MTEXT
if (missing(TEXT)) TEXT=NULL else TEXT=TEXT
if (missing(file)) file="Output.txt" else file=file


FF1<-Factor
CV1<-Covariable

texto<-"          
Test the equality of curves based on an ANOVA-type statistic........"
write.table(texto,"Inf.txt", row.names=FALSE,col.names=FALSE)

if(!is.null(T.AOV)){
aovexe<-paste("fANCOVA::T.aov(datos[, Covariable], datos[, variables], datos[, Factor],",toString(x=T.AOV), ")")
R1<-eval(parse(text=aovexe))
}
else{
aovexe<-"fANCOVA::T.aov(datos[, Covariable], datos[, variables], datos[, Factor])"
R1<-eval(parse(text=aovexe))
}



###############################################
#Seccin que muestra los resultados
###############################################

#Lista de resultados
Resultados<-list(R1)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(graph==TRUE){

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

dati<-aggregate(datos[,variables],by=list(datos[,FF1]),mean)
d1<-dim(dati)

if(!is.null(COLOR)) color<-COLOR else color<-rainbow(d1[1])

pcht<-14+1
for (t in 1:d1[1]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
legendt<-paste("' ",dati[t,1],"'")
ltyT<-t
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",dati[t,1],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1

legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

ymax<-max(datos[,variables], na.rm = TRUE)
ymin<-min(datos[,variables], na.rm = TRUE)

xmax<-max(datos[,CV1], na.rm = TRUE)
xmin<-min(datos[,CV1], na.rm = TRUE)



for (t in 1:d1[1]){#Bucle 2

datas<-subset(datos,datos[,FF1]==dati[t,1])


if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-Covariable
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-variables


if(!is.null(PCH)) pch<-PCH[t] else pch<-14+t

if(!is.null(MAIN)) main<-MAIN else main<-paste('Factor',FF1)

if(t==1){
plotexe<-paste("plot.default(","datas[,variables]~datas[,CV1],","xlab=Xlab,", "ylab=Ylab,","col=color[t],","pch=pch,",
"main=main,","cex.main=2,","xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH", ")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}
else{
plotexe<-paste("points(","datas[,variables]~datas[,CV1],","col=color[t],","pch=pch,",
"xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH",")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}




}#Fin del bucle 2

if(!is.null(PCH)) pcht<-PCH else pcht<-pcht

if(!is.null(LEGEND)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))

if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}





}
