IX3<-function(data, variables,  Factor1, Factor2=NULL, Factor3=NULL,
Factor4=NULL, SS=3, trans=NULL, ResetPAR=TRUE, mfrow=NULL,
graph1="Boxplot", PAR1=NULL,  OrderCat1=NULL, LabelCat1=NULL,
COLOR1=NULL, BOXPLOT1=NULL, BEANPLOT1=NULL,
LEGEND1=NULL, AXIS1=NULL, MTEXT1= NULL, TEXT1=NULL,
graph2="Boxplot", PAR2=NULL, OrderCat2=NULL, LabelCat2=NULL,
COLOR2=NULL, BOXPLOT2=NULL, BEANPLOT2=NULL,
LEGEND2=NULL, AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL,
graph3="Boxplot", PAR3=NULL, OrderCat3=NULL, LabelCat3=NULL,
COLOR3=NULL, BOXPLOT3=NULL, BEANPLOT3=NULL,
LEGEND3=NULL, AXIS3=NULL, MTEXT3= NULL, TEXT3=NULL,
graph4="Boxplot", PAR4=NULL, OrderCat4=NULL, LabelCat4=NULL,
COLOR4=NULL, BOXPLOT4=NULL, BEANPLOT4=NULL,
LEGEND4=NULL, AXIS4=NULL, MTEXT4= NULL, TEXT4=NULL,
INTPLOT1.2=TRUE, INTPLOT1.3=TRUE, INTPLOT1.4=TRUE,
INTPLOT2.3=TRUE, INTPLOT2.4=TRUE, INTPLOT3.4=TRUE,
INTERPLOT1.2=NULL, INTERPLOT1.3=NULL, INTERPLOT1.4=NULL,
INTERPLOT2.3=NULL, INTERPLOT2.4=NULL, INTERPLOT3.4=NULL,
file="Output.txt"){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=variables), subset(datos, select=Factor1))

if(!is.null(Factor2)){
datosT<-data.frame(datosT, subset(datos, select=Factor2))
}


if(!is.null(Factor3)){
datosT<-data.frame(datosT, subset(datos, select=Factor3))
}

if(!is.null(Factor4)){
datosT<-data.frame(datosT, subset(datos, select=Factor4))
}


datos<-na.exclude(datosT)

if (missing(LabelCat1)) LabelCat1=OrderCat1 else LabelCat1=LabelCat1
if (missing(LabelCat2)) LabelCat2=OrderCat2 else LabelCat2=LabelCat2
if (missing(LabelCat3)) LabelCat3=OrderCat3 else LabelCat3=LabelCat3
if (missing(LabelCat4)) LabelCat4=OrderCat4 else LabelCat4=LabelCat4

varSeleccion1<-NULL
varSeleccion2<-NULL

FF1<-Factor1
FF2<-Factor2
FF3<-Factor3
FF4<-Factor4

#Seleccion de un tipo de transformacion para las variables de interes. Si no se transforma la variable debe mantenerse la opcion "NULL".

if(!is.null(trans)){
 if(trans=="1/x2") varInteres1X2<-c(1,1) else varInteres1X2<-NULL
 if(trans=="1/x") varInteres1X<-c(1,1) else varInteres1X<-NULL
 if(trans=="LN") varInteresLN<-c(1,1) else varInteresLN<-NULL
 if(trans=="LOG") varInteresLOG10<-c(1,1) else varInteresLOG10<-NULL
 if(trans=="SQR") varInteresSQR<-c(1,1) else varInteresSQR<-NULL
 if(trans=="x2") varInteresX2<-c(1,1) else varInteresX2<-NULL
 if(trans=="x3") varInteresX3<-c(1,1) else varInteresX3<-NULL
 if(trans=="EXP") varInteresEX<-c(1,1) else varInteresEX<-NULL
 if(trans=="ASN") varInteresASN<-c(1,1) else varInteresASN<-NULL
}
else{
varInteres1X2<-NULL
varInteres1X<-NULL
varInteresLN<-NULL
varInteresLOG10<-NULL
varInteresSQR<-NULL
varInteresX2<-NULL
varInteresX3<-NULL
varInteresEX<-NULL
varInteresASN<-NULL
}

##Organizacion de los datos.
valores<-(datos[,variables])
if (length(varInteres1X2)==2) valores<-1/((datos[,variables])^2)
if (length(varInteres1X)==2) valores<-1/(datos[,variables])
if (length(varInteresLN)==2) valores<-log(datos[,variables])
if (length(varInteresLOG10)==2) valores<-log10(datos[,variables])
if (length(varInteresSQR)==2) valores<-sqrt((datos[,variables]))
if (length(varInteresX2)==2) valores<-(datos[,variables])^2
if (length(varInteresX3)==2) valores<-(datos[,variables])^3
if (length(varInteresEX)==2) valores<-exp(datos[,variables])
if (length(varInteresASN)==2) valores<-asin((datos[,variables]))

#Factores
factores<-data.frame(datos[,c(Factor1,Factor2,Factor3,Factor4)])
if (ncol(factores)==1) names(factores)<-c("Factor1")
if (ncol(factores)==2) names(factores)<-c("Factor1","Factor2")
if (ncol(factores)==3) names(factores)<-c("Factor1","Factor2","Factor3")
if (ncol(factores)==4) names(factores)<-c("Factor1","Factor2","Factor3","Factor4")
if (ncol(factores)==1) F1<-as.factor(factores[,"Factor1"])
if (ncol(factores)==2) {F1<-as.factor(factores[,"Factor1"])
                        F2<-as.factor(factores[,"Factor2"])
}
if (ncol(factores)==3) {F1<-as.factor(factores[,"Factor1"])
                        F2<-as.factor(factores[,"Factor2"])
                        F3<-as.factor(factores[,"Factor3"])
}
if (ncol(factores)==4) {F1<-as.factor(factores[,"Factor1"])
                        F2<-as.factor(factores[,"Factor2"])
                        F3<-as.factor(factores[,"Factor3"])
                        F4<-as.factor(factores[,"Factor4"])
}

if (ncol(factores)==1) factores2<-data.frame(F1)
if (ncol(factores)==2) factores2<-data.frame(F1,F2)
if (ncol(factores)==3) factores2<-data.frame(F1,F2,F3)
if (ncol(factores)==4) factores2<-data.frame(F1,F2,F3,F4)

#Seleccion
if (length(varSeleccion1)!=0){
 w1<-data.frame(row.names=1:dim(datos)[1])
 varBin1<-as.character()
 for (i in 1:length(varSeleccion1)){
   nom1<-varSeleccion1[[i]][1]
   x1<-factor(datos[,nom1])
   if (length(varSeleccion1[[i]])>1){
      sufijo1<-paste(varSeleccion1[[i]][2:3],collapse="_")
      nom1<-paste(nom1,".",sufijo1,sep="")
      x11<-factor(ifelse(x1 %in% varSeleccion1[[i]][2:3],as.character(x1),NA))
      x11<-data.frame(factor(x11))
   }else{
      x11<-x1
      x11<-data.frame(x1)
   }
   names(x11)<-nom1
   varBin1<-c(varBin1,nom1)
   w1<-data.frame(w1,x11)
 }
}

if (length(varSeleccion2)!=0){
 w2<-data.frame(row.names=1:dim(datos)[1])
 varBin2<-as.character()
 for (i in 1:length(varSeleccion2)){
   nom2<-varSeleccion2[[i]][1]
   x2<-factor(datos[,nom2])
   if (length(varSeleccion2[[i]])>1){
      sufijo2<-paste(varSeleccion2[[i]][2:3],collapse="_")
      nom2<-paste(nom2,".",sufijo2,sep="")
      x12<-factor(ifelse(x2 %in% varSeleccion2[[i]][2:3],as.character(x2),NA))
      x12<-data.frame(factor(x12))
   }else{
      x12<-x2
      x12<-data.frame(x2)
   }
   names(x12)<-nom2
   varBin2<-c(varBin2,nom2)
   w2<-data.frame(w2,x12)
 }
}

if ((length(varSeleccion1)!=0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w1,w2)
if ((length(varSeleccion1)!=0)&(length(varSeleccion2)==0)) seleccion<-data.frame(w1)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w2)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)==0)) seleccion<-NULL

#Conjunto de datos
if (length(seleccion)==0) datos2<-data.frame(valores,factores2)
if (length(seleccion)!=0) datos2<-data.frame(seleccion,valores,factores2)
datos2<-na.omit(datos2)

#Modelo lineal univariante y extraccion de residuos.
options(contrasts=c("contr.sum", "contr.poly"))
if (ncol(factores)==1) modelo<-lm(datos2$valores~datos2$F1)
if (ncol(factores)==2) modelo<-lm(datos2$valores~datos2$F1*datos2$F2)
if (ncol(factores)==3) modelo<-lm(datos2$valores~datos2$F1*datos2$F2*datos2$F3)
if (ncol(factores)==4) modelo<-lm(datos2$valores~datos2$F1*datos2$F2*datos2$F3*datos2$F4)
Resumenmodelo<-car::Anova(modelo,type=SS)
residuos<-residuals(modelo)
datos3<-data.frame(residuos,datos2)

Factores<-c("Factors of the ANOVA:",list(Factor1,Factor2,Factor3,Factor4))

#Size effect
Efectos<-summary.lm(modelo)

#prueba de normalidad en los residuos.
PruebaNormLillie<-nortest::lillie.test(residuos)

residshapiro<-length(residuos)
if(3 < residshapiro & residshapiro <5000){
PruebaNormShapiro<-shapiro.test(residuos)
}
else{
PruebaNormShapiro<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}

##Prueba de heterocedasticidad en los residuos.
if (ncol(factores)==1) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-NULL
                        PruebaHetF3M<-NULL
                        PruebaHetF4M<-NULL
}
if (ncol(factores)==2) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3$F2)
                        PruebaHetF3M<-NULL
                        PruebaHetF4M<-NULL
}
if (ncol(factores)==3) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3$F2)
                        PruebaHetF3M<-lawstat::levene.test(datos3$residuos,datos3$F3)
                        PruebaHetF4M<-NULL
}
if (ncol(factores)==4) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3$F2)
                        PruebaHetF3M<-lawstat::levene.test(datos3$residuos,datos3$F3)
                        PruebaHetF4M<-lawstat::levene.test(datos3$residuos,datos3$F4)
}

PruebaHet<-list("Factor1",PruebaHetF1M,"Factor2",PruebaHetF2M,"Factor3",PruebaHetF3M,"Factor4",PruebaHetF4M)

#Sesgo.
Sesgodatos<-c("Skewness",e1071::skewness(datos3$residuos,type=2))
Curtosisdatos<-c("Kurtosis",e1071::kurtosis(datos3$residuos,type=2))

#Pruebas post-hoc
if (ncol(factores)==1){dv<-c(datos2[,"valores"])
                       Factor1<-factor(c(datos2[,"F1"]))
                       modelo2<-lm(dv~Factor1)
                       car::Anova(modelo2,type=SS)
                       PostHoc<-summary(multcomp::glht(modelo2,linfct=multcomp::mcp(Factor1="Tukey")))
}
if (ncol(factores)==2){dv<-c(datos2[,"valores"])
                       Factor1<-factor(c(datos2[,"F1"]))
                       Factor2<-factor(c(datos2[,"F2"]))
                       modelo2<-lm(dv~Factor1*Factor2)
                       car::Anova(modelo2,type=SS)
                       PostHoc<-summary(multcomp::glht(modelo2,linfct=multcomp::mcp(Factor1="Tukey",Factor2="Tukey")))
}
if (ncol(factores)==3){dv<-c(datos2[,"valores"])
                       Factor1<-factor(c(datos2[,"F1"]))
                       Factor2<-factor(c(datos2[,"F2"]))
                       Factor3<-factor(c(datos2[,"F3"]))
                       modelo2<-lm(dv~Factor1*Factor2*Factor3)
                       car::Anova(modelo2,type=SS)
                       PostHoc<-summary(multcomp::glht(modelo2,linfct=multcomp::mcp(Factor1="Tukey",Factor2="Tukey",Factor3="Tukey")))
}
if (ncol(factores)==4){dv<-c(datos2[,"valores"])
                       Factor1<-factor(c(datos2[,"F1"]))
                       Factor2<-factor(c(datos2[,"F2"]))
                       Factor3<-factor(c(datos2[,"F3"]))
                       Factor4<-factor(c(datos2[,"F4"]))
                       modelo2<-lm(dv~Factor1*Factor2*Factor3*Factor4)
                       car::Anova(modelo2,type=SS)
                       PostHoc<-summary(multcomp::glht(modelo2,linfct=multcomp::mcp(Factor1="Tukey",Factor2="Tukey",Factor3="Tukey",Factor4="Tukey")))
}

###############################################
#Seccion que muestra los resultados
###############################################

Resultados<-list(Factores,Resumenmodelo,Efectos,PruebaNormLillie,PruebaNormShapiro,PruebaHet,Sesgodatos,Curtosisdatos,PostHoc)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else x11()
par(mfrow=mfrow)
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else x11()
}


if(!is.null(graph1)){

if(!is.null(COLOR1)){
color<-COLOR1
color1<-as.list(COLOR1)
}
else{
color<-terrain.colors(length(unique(datos[,FF1])))
color1<-as.list(color)
}

datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = unique(datos[,FF1]))

if(!is.null(OrderCat1)){
datos[,FF1]<-factor(datos[,FF1], levels = OrderCat1, labels = LabelCat1)
}
else{
if(!is.null(LabelCat1)) datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = LabelCat1) else datos<-datos
}


if(!is.null(PAR1)){
parexe<-paste("par(new,",toString(x=PAR1), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph1=="Boxplot"){

if(!is.null(BOXPLOT1)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",toString(x=BOXPLOT1), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",
"xlab=FF1,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT1)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",toString(x=BEANPLOT1), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",
"xlab=FF1,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND1)){
legendexe<-paste("legend(",toString(x=LEGEND1), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS1)){
axisexe<-paste("axis(",toString(x=AXIS1), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT1)){
mtextexe<-paste("mtext(",toString(x=MTEXT1), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT1)){
textexe<-paste("text(",toString(x=TEXT1), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}


#Grafico 2


if(!is.null(FF2)){

if(!is.null(graph2)){

if(!is.null(COLOR2)){
color<-COLOR2
color1<-as.list(COLOR2)
}
else{
color<-terrain.colors(length(unique(datos[,FF2])))
color1<-as.list(color)
}

datos[,FF2]<-factor(datos[,FF2], levels = unique(datos[,FF2]), labels = unique(datos[,FF2]))

if(!is.null(OrderCat2)){
datos[,FF2]<-factor(datos[,FF2], levels = OrderCat2, labels = LabelCat2)
}
else{
if(!is.null(LabelCat2)) datos[,FF2]<-factor(datos[,FF2], levels = unique(datos[,FF2]), labels = LabelCat2) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(PAR2)){
parexe<-paste("par(new,",toString(x=PAR2), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph2=="Boxplot"){

if(!is.null(BOXPLOT2)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF2],",toString(x=BOXPLOT2), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT2)){
beanplotexe<-paste("beanplot::beanplot::beanplot(","datos[,variables]~datos[,FF2],",toString(x=BEANPLOT2), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND2)){
legendexe<-paste("legend(",toString(x=LEGEND2), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS2)){
axisexe<-paste("axis(",toString(x=AXIS2), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT2)){
mtextexe<-paste("mtext(",toString(x=MTEXT2), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT2)){
textexe<-paste("text(",toString(x=TEXT2), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 2
else{
}

}
else{
}#Final FF2


#Grafico 3


if(!is.null(FF3)){

if(!is.null(graph3)){

if(!is.null(COLOR3)){
color<-COLOR3
color1<-as.list(COLOR3)
}
else{
color<-terrain.colors(length(unique(datos[,FF3])))
color1<-as.list(color)
}

datos[,FF3]<-factor(datos[,FF3], levels = unique(datos[,FF3]), labels = unique(datos[,FF3]))

if(!is.null(OrderCat3)){
datos[,FF3]<-factor(datos[,FF3], levels = OrderCat3, labels = LabelCat3)
}
else{
if(!is.null(LabelCat3)) datos[,FF3]<-factor(datos[,FF3], levels = unique(datos[,FF3]), labels = LabelCat3) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(PAR3)){
parexe<-paste("par(new,",toString(x=PAR3), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph3=="Boxplot"){

if(!is.null(BOXPLOT3)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF3],",toString(x=BOXPLOT3), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF3],",
"xlab=FF3,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT3)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF3],",toString(x=BEANPLOT3), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF3],",
"xlab=FF3,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND3)){
legendexe<-paste("legend(",toString(x=LEGEND3), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS3)){
axisexe<-paste("axis(",toString(x=AXIS3), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT3)){
mtextexe<-paste("mtext(",toString(x=MTEXT3), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT3)){
textexe<-paste("text(",toString(x=TEXT3), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 3
else{
}

}
else{
}#Final FF3

if(!is.null(FF4)){

if(!is.null(graph4)){

if(!is.null(COLOR4)){
color<-COLOR4
color1<-as.list(COLOR4)
}
else{
color<-terrain.colors(length(unique(datos[,FF4])))
color1<-as.list(color)
}

datos[,FF4]<-factor(datos[,FF4], levels = unique(datos[,FF4]), labels = unique(datos[,FF4]))

if(!is.null(OrderCat4)){
datos[,FF4]<-factor(datos[,FF4], levels = OrderCat4, labels = LabelCat4)
}
else{
if(!is.null(LabelCat4)) datos[,FF4]<-factor(datos[,FF4], levels = unique(datos[,FF4]), labels = LabelCat4) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(PAR4)){
parexe<-paste("par(new,",toString(x=PAR4), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph4=="Boxplot"){

if(!is.null(BOXPLOT4)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF4],",toString(x=BOXPLOT4), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF4],",
"xlab=FF4,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT4)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF4],",toString(x=BEANPLOT4), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF4],",
"xlab=FF4,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND4)){
legendexe<-paste("legend(",toString(x=LEGEND4), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS4)){
axisexe<-paste("axis(",toString(x=AXIS4), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT4)){
mtextexe<-paste("mtext(",toString(x=MTEXT4), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT4)){
textexe<-paste("text(",toString(x=TEXT4), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 4
else{
}

}
else{
}#Final FF4


#Graficos de interaccion

#Factor1-Factor 2

if(INTPLOT1.2==TRUE){
if(!is.null(Factor2)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT1.2)){
interactionexe<-paste("interaction.plot(datos[,FF1],datos[,FF2], datos[,variables],",toString(x=INTERPLOT1.2), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF1],datos[,FF2], datos[,variables],",
"ylab=variables,", "xlab=FF1,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF2),","cex.main=2,","col=rainbow(length(unique(datos[,FF2]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}


#Factor1-Factor 3

if(INTPLOT1.3==TRUE){
if(!is.null(Factor3)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT1.3)){
interactionexe<-paste("interaction.plot(datos[,FF1],datos[,FF3], datos[,variables],",toString(x=INTERPLOT1.3), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF1],datos[,FF3], datos[,variables],",
"ylab=variables,", "xlab=FF1,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF3),","cex.main=2,","col=rainbow(length(unique(datos[,FF3]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}

#Factor1-Factor 4
if(INTPLOT1.4==TRUE){
if(!is.null(Factor4)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT1.4)){
interactionexe<-paste("interaction.plot(datos[,FF1],datos[,FF4], datos[,variables],",toString(x=INTERPLOT1.4), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF1],datos[,FF4], datos[,variables],",
"ylab=variables,", "xlab=FF1,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF4),","cex.main=2,","col=rainbow(length(unique(datos[,FF4]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}

#Factor2-Factor 3
if(INTPLOT2.3==TRUE){
if(!is.null(Factor2)){
if(!is.null(Factor3)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT2.3)){
interactionexe<-paste("interaction.plot(datos[,FF2],datos[,FF3], datos[,variables],",toString(x=INTERPLOT2.3), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF2],datos[,FF3], datos[,variables],",
"ylab=variables,", "xlab=FF2,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF3),","cex.main=2,","col=rainbow(length(unique(datos[,FF3]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}
}


#Factor2-Factor 4
if(INTPLOT2.4==TRUE){
if(!is.null(Factor2)){
if(!is.null(Factor4)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT2.4)){
interactionexe<-paste("interaction.plot(datos[,FF2],datos[,FF4], datos[,variables],",toString(x=INTERPLOT2.4), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF2],datos[,FF4], datos[,variables],",
"ylab=variables,", "xlab=FF2,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF4),","cex.main=2,","col=rainbow(length(unique(datos[,FF4]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}
}


#Factor3-Factor 4
if(INTPLOT3.4==TRUE){
if(!is.null(Factor3)){
if(!is.null(Factor4)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(INTERPLOT3.4)){
interactionexe<-paste("interaction.plot(datos[,FF3],datos[,FF4], datos[,variables],",toString(x=INTERPLOT3.4), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF3],datos[,FF4], datos[,variables],",
"ylab=variables,", "xlab=FF3,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF4),","cex.main=2,","col=rainbow(length(unique(datos[,FF4]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}
}




}
