IX4<-function(data, variables,  Factor1, Factor2=NULL, Factor3=NULL, Covariable1,
Covariable2=NULL, Covariable3=NULL, Covariable4=NULL, SS=3, trans=NULL,
ResetPAR=TRUE, mfrow=NULL,  CEXPCH=1.3, graph1=TRUE, XLAB=NULL,
YLAB=NULL, PAR1=NULL, COLOR1=NULL, PCH1=NULL,  MAIN1=NULL,
LEGEND1=NULL, AXIS1=NULL, MTEXT1= NULL, TEXT1=NULL, graph2=TRUE,
PAR2=NULL, COLOR2=NULL, PCH2 =NULL, MAIN2=NULL, LEGEND2=NULL,
AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL, graph3=TRUE, PAR3=NULL,
COLOR3=NULL,  PCH3=NULL, MAIN3=NULL, LEGEND3=NULL, AXIS3=NULL,
MTEXT3= NULL, TEXT3=NULL, INTPLOT1.2=TRUE, INTPLOT1.3=TRUE,
INTPLOT2.3=TRUE, INTERPLOT1.2=NULL, INTERPLOT1.3=NULL,
INTERPLOT2.3=NULL, OrderCat1=NULL, LabelCat1=NULL,OrderCat2=NULL,
LabelCat2=NULL, file="Output.txt"){



###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=variables), subset(datos, select=Factor1))

if(!is.null(Factor2)){
datosT<-data.frame(datosT, subset(datos, select=Factor2))
}


if(!is.null(Factor3)){
datosT<-data.frame(datosT, subset(datos, select=Factor3))
}

if(!is.null(Covariable1)){
datosT<-data.frame(datosT, subset(datos, select=Covariable1))
}

if(!is.null(Covariable2)){
datosT<-data.frame(datosT, subset(datos, select=Covariable2))
}


if(!is.null(Covariable3)){
datosT<-data.frame(datosT, subset(datos, select=Covariable3))
}

datos<-na.exclude(datosT)

if (missing(LabelCat1)) LabelCat1=OrderCat1 else LabelCat1=LabelCat1
if (missing(LabelCat2)) LabelCat2=OrderCat2 else LabelCat2=LabelCat2


varSeleccion1<-NULL
varSeleccion2<-NULL

FF1<-Factor1
FF2<-Factor2
FF3<-Factor3
CV1<-Covariable1
CV2<-Covariable2
CV3<-Covariable3
CV4<-Covariable4

#Seleccion de un tipo de transformacion para las variables de interes. Si no se transforma la variable debe mantenerse la opcion "NULL".

if(!is.null(trans)){
 if(trans=="1/x2") varInteres1X2<-c(1,1) else varInteres1X2<-NULL
 if(trans=="1/x") varInteres1X<-c(1,1) else varInteres1X<-NULL
 if(trans=="LN") varInteresLN<-c(1,1) else varInteresLN<-NULL
 if(trans=="LOG") varInteresLOG10<-c(1,1) else varInteresLOG10<-NULL
 if(trans=="SQR") varInteresSQR<-c(1,1) else varInteresSQR<-NULL
 if(trans=="x2") varInteresX2<-c(1,1) else varInteresX2<-NULL
 if(trans=="x3") varInteresX3<-c(1,1) else varInteresX3<-NULL
 if(trans=="EXP") varInteresEX<-c(1,1) else varInteresEX<-NULL
 if(trans=="ASN") varInteresASN<-c(1,1) else varInteresASN<-NULL
}
else{
varInteres1X2<-NULL
varInteres1X<-NULL
varInteresLN<-NULL
varInteresLOG10<-NULL
varInteresSQR<-NULL
varInteresX2<-NULL
varInteresX3<-NULL
varInteresEX<-NULL
varInteresASN<-NULL
}


##Organizacion de los datos.
valores<-(datos[,variables])
if (length(varInteres1X2)==2) valores<-1/((datos[,variables])^2)
if (length(varInteres1X)==2) valores<-1/(datos[,variables])
if (length(varInteresLN)==2) valores<-log(datos[,variables])
if (length(varInteresLOG10)==2) valores<-log10(datos[,variables])
if (length(varInteresSQR)==2) valores<-sqrt((datos[,variables]))
if (length(varInteresX2)==2) valores<-(datos[,variables])^2
if (length(varInteresX3)==2) valores<-(datos[,variables])^3
if (length(varInteresEX)==2) valores<-exp(datos[,variables])
if (length(varInteresASN)==2) valores<-asin((datos[,variables]))

#Factores
factores<-data.frame(datos[,c(Factor1,Factor2,Factor3)])
if (ncol(factores)==1) names(factores)<-c("Factor1")
if (ncol(factores)==2) names(factores)<-c("Factor1","Factor2")
if (ncol(factores)==3) names(factores)<-c("Factor1","Factor2","Factor3")
if (ncol(factores)==1) F1<-as.factor(factores[,"Factor1"])
if (ncol(factores)==2) {F1<-as.factor(factores[,"Factor1"])
                        F2<-as.factor(factores[,"Factor2"])
}
if (ncol(factores)==3) {F1<-as.factor(factores[,"Factor1"])
                        F2<-as.factor(factores[,"Factor2"])
                        F3<-as.factor(factores[,"Factor3"])
}

if (ncol(factores)==1) factores2<-data.frame(F1)
if (ncol(factores)==2) factores2<-data.frame(F1,F2)
if (ncol(factores)==3) factores2<-data.frame(F1,F2,F3)

#Covariables
covariables<-data.frame(datos[,c(Covariable1,Covariable2,Covariable3,Covariable4)])
if (ncol(covariables)==1) names(covariables)<-c("Cov1")
if (ncol(covariables)==2) names(covariables)<-c("Cov1","Cov2")
if (ncol(covariables)==3) names(covariables)<-c("Cov1","Cov2","Cov3")
if (ncol(covariables)==4) names(covariables)<-c("Cov1","Cov2","Cov3","Cov4")
if (ncol(covariables)==1) C1<-data.frame(covariables[,"Cov1"])
if (ncol(covariables)==2){C1<-data.frame(covariables[,"Cov1"])
                          C2<-data.frame(covariables[,"Cov2"])
}
if (ncol(covariables)==3){C1<-data.frame(covariables[,"Cov1"])
                          C2<-data.frame(covariables[,"Cov2"])
                          C3<-data.frame(covariables[,"Cov3"])
}
if (ncol(covariables)==4){C1<-data.frame(covariables[,"Cov1"])
                          C2<-data.frame(covariables[,"Cov2"])
                          C3<-data.frame(covariables[,"Cov3"])
                          C4<-data.frame(covariables[,"Cov4"])
}

if (ncol(covariables)==1) {covariables2<-data.frame(C1)
                           names(covariables2)<-c("C1")
}
if (ncol(covariables)==2) {covariables2<-data.frame(C1,C2)
                           names(covariables2)<-c("C1","C2")
}
if (ncol(covariables)==3) {covariables2<-data.frame(C1,C2,C3)
                           names(covariables2)<-c("C1","C2","C3")
}
if (ncol(covariables)==4) {covariables2<-data.frame(C1,C2,C3,C4)
                           names(covariables2)<-c("C1","C2","C3","C4")
}



#Seleccion
if (length(varSeleccion1)!=0){
 w1<-data.frame(row.names=1:dim(datos)[1])
 varBin1<-as.character()
 for (i in 1:length(varSeleccion1)){
   nom1<-varSeleccion1[[i]][1]
   x1<-factor(datos[,nom1])
   if (length(varSeleccion1[[i]])>1){
      sufijo1<-paste(varSeleccion1[[i]][2:3],collapse="_")
      nom1<-paste(nom1,".",sufijo1,sep="")
      x11<-factor(ifelse(x1 %in% varSeleccion1[[i]][2:3],as.character(x1),NA))
      x11<-data.frame(factor(x11))
   }else{
      x11<-x1
      x11<-data.frame(x1)
   }
   names(x11)<-nom1
   varBin1<-c(varBin1,nom1)
   w1<-data.frame(w1,x11)
 }
}

if (length(varSeleccion2)!=0){
 w2<-data.frame(row.names=1:dim(datos)[1])
 varBin2<-as.character()
 for (i in 1:length(varSeleccion2)){
   nom2<-varSeleccion2[[i]][1]
   x2<-factor(datos[,nom2])
   if (length(varSeleccion2[[i]])>1){
      sufijo2<-paste(varSeleccion2[[i]][2:3],collapse="_")
      nom2<-paste(nom2,".",sufijo2,sep="")
      x12<-factor(ifelse(x2 %in% varSeleccion2[[i]][2:3],as.character(x2),NA))
      x12<-data.frame(factor(x12))
   }else{
      x12<-x2
      x12<-data.frame(x2)
   }
   names(x12)<-nom2
   varBin2<-c(varBin2,nom2)
   w2<-data.frame(w2,x12)
 }
}

if ((length(varSeleccion1)!=0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w1,w2)
if ((length(varSeleccion1)!=0)&(length(varSeleccion2)==0)) seleccion<-data.frame(w1)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)!=0)) seleccion<-data.frame(w2)
if ((length(varSeleccion1)==0)&(length(varSeleccion2)==0)) seleccion<-NULL

#Conjunto de datos
if (length(seleccion)==0) datos2<-data.frame(valores,covariables2,factores2)
if (length(seleccion)!=0) datos2<-data.frame(seleccion,valores,covariables2,factores2)
datos2<-na.omit(datos2)

#Modelo lineal univariante y extraccion de residuos.
options(contrasts=c("contr.sum", "contr.poly"))
if ((ncol(factores)==1)&(ncol(covariables)==1)) modelo<-lm(datos2$valores~datos2$C1+datos2$F1)
if ((ncol(factores)==1)&(ncol(covariables)==2)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$F1)
if ((ncol(factores)==1)&(ncol(covariables)==3)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$F1)
if ((ncol(factores)==1)&(ncol(covariables)==4)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$C4+datos2$F1)

if ((ncol(factores)==2)&(ncol(covariables)==1)) modelo<-lm(datos2$valores~datos2$C1+datos2$F1*datos2$F2)
if ((ncol(factores)==2)&(ncol(covariables)==2)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$F1*datos2$F2)
if ((ncol(factores)==2)&(ncol(covariables)==3)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$F1*datos2$F2)
if ((ncol(factores)==2)&(ncol(covariables)==4)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$C4+datos2$F1*datos2$F2)

if ((ncol(factores)==3)&(ncol(covariables)==1)) modelo<-lm(datos2$valores~datos2$C1+datos2$F1*datos2$F2*datos2$F3)
if ((ncol(factores)==3)&(ncol(covariables)==2)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$F1*datos2$F2*datos2$F3)
if ((ncol(factores)==3)&(ncol(covariables)==3)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$F1*datos2$F2*datos2$F3)
if ((ncol(factores)==3)&(ncol(covariables)==4)) modelo<-lm(datos2$valores~datos2$C1+datos2$C2+datos2$C3+datos2$C4+datos2$F1*datos2$F2*datos2$F3)

Resumenmodelo1<-car::Anova(modelo,type=SS)
Resumenmodelo2<-summary.lm(modelo)

residuos<-residuals(modelo)
datos3<-data.frame(residuos,datos2)

Factores<-c("Factors of the analysis:",list(Factor1,Factor2,Factor3))
Covariables<-c("Covariables of the analysis:",list(Covariable1,Covariable2,Covariable3,Covariable4))

#prueba de normalidad en los residuos.
PruebaNormLillie<-nortest::lillie.test(residuos)

residshapiro<-length(residuos)
if(3 < residshapiro & residshapiro <5000){
PruebaNormShapiro<-shapiro.test(residuos)
}
else{
PruebaNormShapiro<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}

#Prueba de heterocedasticidad en los residuos.
if (ncol(factores)==1) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-NULL
                        PruebaHetF3M<-NULL
}
if (ncol(factores)==2) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3$F2)
                        PruebaHetF3M<-NULL
}
if (ncol(factores)==3) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3$F1)
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3$F2)
                        PruebaHetF3M<-lawstat::levene.test(datos3$residuos,datos3$F3)
}


PruebaHet<-list("Factor1",PruebaHetF1M,"Factor2",PruebaHetF2M,"Factor3",PruebaHetF3M)

#Sesgo.
Sesgodatos<-c("Skewness",e1071::skewness(datos3$residuos,type=2))
Curtosisdatos<-c("Kurtosis",e1071::kurtosis(datos3$residuos,type=2))


###############################################
#Seccion que muestra los resultados
###############################################

#Lista de resultados
Resultados<-list("ANCOVA",Factores,Covariables,Resumenmodelo1,Resumenmodelo2,PruebaNormLillie,PruebaNormShapiro,PruebaHet,Sesgodatos,Curtosisdatos)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else x11()
par(mfrow=mfrow,font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else x11()
}

if(graph1==TRUE){

if(!is.null(PAR1)){
parexe<-paste("par(new,",toString(x=PAR1), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

dati<-aggregate(datos[,variables],by=list(datos[,FF1]),mean)
d1<-dim(dati)

if(!is.null(COLOR1)) color<-COLOR1 else color<-rainbow(d1[1])

pcht<-14+1
for (t in 1:d1[1]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
legendt<-paste("' ",dati[t,1],"'")
ltyT<-t
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",dati[t,1],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1

legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

ymax<-max(datos[,variables], na.rm = TRUE)
ymin<-min(datos[,variables], na.rm = TRUE)

xmax<-max(datos[,CV1], na.rm = TRUE)
xmin<-min(datos[,CV1], na.rm = TRUE)



for (t in 1:d1[1]){#Bucle 2

datas<-subset(datos,datos[,FF1]==dati[t,1])



if(!is.null(PCH1)) pch<-PCH1[t] else pch<-14+t

if(t==1){

if(!is.null(XLAB)){
xlabb=XLAB
}
else{
xlabb=CV1
}

if(!is.null(YLAB)){
ylabb=YLAB
}
else{
ylabb=variables
}

if(!is.null(MAIN1)){
mainb=MAIN1
}
else{
mainb=paste('Factor',FF1)
}



plotexe<-paste("plot.default(","datas[,variables]~datas[,CV1],","xlab=xlabb,", "ylab=ylabb,","col=color[t],","pch=pch,",
"main=mainb,","cex.main=2,","xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH", ")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}
else{
plotexe<-paste("points(","datas[,variables]~datas[,CV1],","col=color[t],","pch=pch,",
"xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH",")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}




}#Fin del bucle 2

if(!is.null(PCH1)) pcht<-PCH1 else pcht<-pcht

if(!is.null(LEGEND1)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))

if(!is.null(LEGEND1)){
legendexe<-paste("legend(",toString(x=LEGEND1), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS1)){
axisexe<-paste("axis(",toString(x=AXIS1), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT1)){
mtextexe<-paste("mtext(",toString(x=MTEXT1), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT1)){
textexe<-paste("text(",toString(x=TEXT1), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 1
else{
}


#Grafico 2


if(!is.null(FF2)){

if(graph2==TRUE){

if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(PAR2)){
parexe<-paste("par(new,",toString(x=PAR2), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}



dati<-aggregate(datos[,variables],by=list(datos[,FF2]),mean)
d1<-dim(dati)

if(!is.null(COLOR2)) color<-COLOR2 else color<-rainbow(d1[1])

pcht<-14+1
for (t in 1:d1[1]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
ltyT<-t
legendt<-paste("' ",dati[t,1],"'")
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",dati[t,1],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1

legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

ymax<-max(datos[,variables], na.rm = TRUE)
ymin<-min(datos[,variables], na.rm = TRUE)

xmax<-max(datos[,CV1], na.rm = TRUE)
xmin<-min(datos[,CV1], na.rm = TRUE)

for (t in 1:d1[1]){#Bucle 2

datas<-subset(datos,datos[,FF2]==dati[t,1])



if(!is.null(PCH2)) pch<-PCH2[t] else pch<-14+t


if(t==1){

if(!is.null(XLAB)){
xlabb=XLAB
}
else{
xlabb=CV1
}

if(!is.null(YLAB)){
ylabb=YLAB
}
else{
ylabb=variables
}

if(!is.null(MAIN2)){
mainb=MAIN2
}
else{
mainb=paste('Factor',FF2)
}

plotexe<-paste("plot.default(","datas[,variables]~datas[,CV1],","xlab=xlabb,", "ylab=ylabb,","col=color[t],","pch=pch,",
"cex.lab=1.5,","font.lab=2,","main=mainb,","cex.main=2,","xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH", ")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}
else{
plotexe<-paste("points(","datas[,variables]~datas[,CV1],","col=color[t],","pch=pch,",
"xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH",")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}



}#Fin del bucle 2

if(!is.null(PCH2)) pcht<-PCH2 else pcht<-pcht

if(!is.null(LEGEND2)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))

if(!is.null(LEGEND2)){
legendexe<-paste("legend(",toString(x=LEGEND2), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS2)){
axisexe<-paste("axis(",toString(x=AXIS2), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT2)){
mtextexe<-paste("mtext(",toString(x=MTEXT2), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT2)){
textexe<-paste("text(",toString(x=TEXT2), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 2
else{
}

}
else{
}#Final Factor2


#Grafico 3


if(!is.null(FF3)){

if(graph3==TRUE){

if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(PAR3)){
parexe<-paste("par(new,",toString(x=PAR3), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


dati<-aggregate(datos[,variables],by=list(datos[,FF3]),mean)
d1<-dim(dati)

if(!is.null(COLOR3)) color<-COLOR3 else color<-rainbow(d1[1])

pcht<-14+1
for (t in 1:d1[1]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
ltyT<-t
legendt<-paste("' ",dati[t,1],"'")
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",dati[t,1],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1

legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

ymax<-max(datos[,variables], na.rm = TRUE)
ymin<-min(datos[,variables], na.rm = TRUE)

xmax<-max(datos[,CV1], na.rm = TRUE)
xmin<-min(datos[,CV1], na.rm = TRUE)

for (t in 1:d1[1]){#Bucle 2

datas<-subset(datos,datos[,FF3]==dati[t,1])



if(!is.null(PCH3)) pch<-PCH3[t] else pch<-14+t


if(t==1){

if(!is.null(XLAB)){
xlabb=XLAB
}
else{
xlabb=CV1
}

if(!is.null(YLAB)){
ylabb=YLAB
}
else{
ylabb=variables
}

if(!is.null(MAIN3)){
mainb=MAIN3
}
else{
mainb=paste('Factor',FF3)
}

plotexe<-paste("plot.default(","datas[,variables]~datas[,CV1],","xlab=xlabb,", "ylab=ylabb,","col=color[t],","pch=pch,",
"cex.lab=1.5,","font.lab=2,","main=mainb,","cex.main=2,","xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH", ")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}
else{
plotexe<-paste("points(","datas[,variables]~datas[,CV1],","col=color[t],","pch=pch,",
"xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH",")")
eval(parse(text=plotexe))
reg<-lm(datas[,variables]~datas[,CV1])
abline(reg, col=color[t], lty=t, lwd=2)
}



}#Fin del bucle 2

if(!is.null(PCH3)) pcht<-PCH3 else pcht<-pcht

if(!is.null(LEGEND3)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))


if(!is.null(LEGEND3)){
legendexe<-paste("legend(",toString(x=LEGEND3), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS3)){
axisexe<-paste("axis(",toString(x=AXIS3), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT3)){
mtextexe<-paste("mtext(",toString(x=MTEXT3), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT3)){
textexe<-paste("text(",toString(x=TEXT3), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 3
else{
}

}
else{
}#Final Factor3

#Graficos de interaccion

#Factor1-Factor 2

if(INTPLOT1.2==TRUE){
if(!is.null(Factor2)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(OrderCat1)){
datos[,FF1]<-factor(datos[,FF1], levels = OrderCat1, labels = LabelCat1)
}
else{
if(!is.null(LabelCat1)) datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = LabelCat1) else datos<-datos
}

if(!is.null(INTERPLOT1.2)){
interactionexe<-paste("interaction.plot(datos[,FF1],datos[,FF2], datos[,variables],",toString(x=INTERPLOT1.2), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF1],datos[,FF2], datos[,variables],",
"ylab=variables,", "xlab=FF1,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF2),","cex.main=2,","col=rainbow(length(unique(datos[,FF2]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}


#Factor1-Factor 3

if(INTPLOT1.3==TRUE){
if(!is.null(Factor3)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(OrderCat1)){
datos[,FF1]<-factor(datos[,FF1], levels = OrderCat1, labels = LabelCat1)
}
else{
if(!is.null(LabelCat1)) datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = LabelCat1) else datos<-datos
}


if(!is.null(INTERPLOT1.3)){
interactionexe<-paste("interaction.plot(datos[,FF1],datos[,FF3], datos[,variables],",toString(x=INTERPLOT1.3), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF1],datos[,FF3], datos[,variables],",
"ylab=variables,", "xlab=FF1,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF3),","cex.main=2,","col=rainbow(length(unique(datos[,FF3]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}

#Factor2-Factor 3
if(INTPLOT2.3==TRUE){
if(!is.null(Factor2)){
if(!is.null(Factor3)){
if(!is.null(mfrow)) dfssdfdfs<-1 else x11()

if(!is.null(OrderCat2)){
datos[,FF2]<-factor(datos[,FF2], levels = OrderCat2, labels = LabelCat2)
}
else{
if(!is.null(LabelCat2)) datos[,FF2]<-factor(datos[,FF2], levels = unique(datos[,FF2]), labels = LabelCat2) else datos<-datos
}


if(!is.null(INTERPLOT2.3)){
interactionexe<-paste("interaction.plot(datos[,FF2],datos[,FF3], datos[,variables],",toString(x=INTERPLOT2.3), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos[,FF2],datos[,FF3], datos[,variables],",
"ylab=variables,", "xlab=FF2,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,", "lwd=2,",
"main=paste('Factor',FF3),","cex.main=2,","col=rainbow(length(unique(datos[,FF3]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}
}
}
}



}
