IX5<-function(data, varTime, graph="Boxplot", SS=2, PAR=NULL,
ResetPAR=TRUE, YLAB="Dependent variable", XLAB="Time",
LabelCat=NULL, COLOR=NULL, BOXPLOT=NULL, BEANPLOT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){



datos<-data

datosT<-data.frame(subset(datos, select=varTime))
datos<-na.exclude(datosT)


if (missing(LabelCat)) LabelCat=varTime else LabelCat=LabelCat


options(contrasts=c("contr.sum","contr.poly"))


datos1<-as.matrix(datos[,varTime])

#Modelo lineal
modelo<- lm(datos1 ~ 1)


#ANOVA


Factor <- factor(varTime)


resultado<-car::Anova(modelo, idata = data.frame(Factor), idesign = ~Factor, type=SS)
ANOVA<-summary(resultado, multivariate=FALSE)


Resultados<-list("Comparison t-test among times")


num<-length(varTime)

h<-2
for (i in 1:(num-1)){
for (x in h:(num)){
zz<-t.test(datos1[,i],datos1[,x],paired=TRUE)
anal<-paste("t-test between ",varTime[i]," and ", varTime[x])
Resultados<-list(Resultados,anal,zz)
}
h<-h+1
}


d<-dim(datos1)
list<-d[1]

for (i in 1:(num-1)){
list<-append(list,d[1])
}

zz<-rep(varTime,list)

#Se convierte en una matrix de una columna
m<-matrix(datos1, ncol=1)

datos2<-data.frame(zz,m)




Resultados<-list("ANOVA with repeated measures", ANOVA,Resultados)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}




if(!is.null(graph)){

if(!is.null(COLOR)){
color<-COLOR
color1<-as.list(COLOR)
}
else{
color<-terrain.colors(length(unique(datos2[,1])))
color1<-as.list(color)
}



if(!is.null(LabelCat)) datos2[,1]<-factor(datos2[,1], levels = varTime, labels = LabelCat) else datos2[,1]<-factor(datos2[,1], levels = varTime, labels = varTime)


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph=="Boxplot"){



if(!is.null(BOXPLOT)){
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",toString(x=BOXPLOT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT)){
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",toString(x=BEANPLOT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}





}
