VI2<-function(data, variables, group=NULL, distribution="Normal", combine=TRUE,
graph=TRUE, ni=12, xlab="", col.bar="cyan", col.line="red", lty=2, lwd=2,
legend.pos="topleft", file="Output.csv", na="NA", dec=",", row.names=FALSE){


datos<-data

if(distribution=="Normal"){

# Ajustes de distribucion Normal

# Funcion para colapsar categorias de valores esperados
# inferiores a un limite predeterminado.
 colapsar<-function(p1,f1,lim1=5){
  np1<-p1
  nf1<-f1
  tocollapse<-which((p1*sum(f1))<lim1)
  while(length(tocollapse)>0){
   x<-tocollapse[1]
   if (x<(length(f1)/2)){
    np1[x+1]<-p1[x]+p1[x+1]
    nf1[x+1]<-f1[x]+f1[x+1]
   }else{
    np1[x-1]<-p1[x]+p1[x-1]
    nf1[x-1]<-f1[x]+f1[x-1]
   }
   p1<-np1[-x]
   f1<-nf1[-x]
   np1<-p1
   nf1<-f1
   tocollapse<-which((p1*sum(f1))<lim1)
  }
  return(list(probs=p1,freqs=f1))  
 }

calculos2<-function(x){
 x<-x[!is.na(x)]
 if (length(x)>=3){
 # Calculo del parametro de la distribution utilizando el momento.
 n<-length(x)
 media<-mean(x, na.rm = TRUE)
 desv.est<-sd(x, na.rm = TRUE)
 # Prueba de Kolmogorov-Smirnov.
 pruebaks<-ks.test(x,"pnorm",mean=media,sd=desv.est)
 # Prueba de lilliefors
 pruebaKSlillie<-nortest::lillie.test(x)
 # Prueba de shapiro wilk.
residshapiro<-length(x)
if(3 < residshapiro & residshapiro <5000){
pruebaSW<-shapiro.test(x)
}
else{
pruebaSW<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}
 # Calculo de la asimetria
 asimetria<-e1071::skewness(x)

residshapiro<-length(x)
if(3 < residshapiro & residshapiro <5000){
 respuestas<-c(n,asimetria,pruebaks$statistic,pruebaks$p.value,
               pruebaKSlillie$statistic,pruebaKSlillie$p.value,
               pruebaSW$statistic,pruebaSW$p.value)
}
else{
 respuestas<-c(n,asimetria,pruebaks$statistic,pruebaks$p.value,
               pruebaKSlillie$statistic,pruebaKSlillie$p.value,
              "NA","NA")
}
 }else return( rep(NA,11))
} 

generaGrafica2<-function(i,lista){
  x<-lista[[i]]
  x<-x[!is.na(x)]
  media<-mean(x, na.rm = TRUE)
  desv.est<-sd(x, na.rm = TRUE)
  dev.new()
  MASS::truehist(x,main=distribution, xlab=xlab,ylab="Density",nbins=ni,sub=Names[[i]], col=col.bar)
x<-seq(min(x, na.rm = TRUE)*.8,max(x, na.rm = TRUE)*1.2,l=100)
  lines(x,dnorm(x,mean=media,sd=desv.est), col=col.line, lty=lty, lwd=lwd)
  legend(legend.pos,legend=c("Real dist.","Adjusted dist."),
  lwd=c(lwd,lwd),lty=c(1,lty),col=c(col.bar,col.line))
}



# Organizacion de la base de datos.
valores<-unlist(datos[,variables])
variables1<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),group])
names(agrupaciones)<-group
datos2<-data.frame(agrupaciones,Variable=variables1,valor=valores)
group<-c(group,"Variable")
agrupa<-data.frame(datos2[,group])
if(length(group)==1) names(agrupa)<-group
listadatos2<-split(datos2$valor,as.list(agrupa),drop=TRUE)

Names<-names(listadatos2)
r1<-t(sapply(listadatos2,calculos2))
r1<-data.frame(Names=rownames(r1),r1)
names(r1)<-c("Names","n","Skewness","D of K-S","Value-p K-S","D of K-S Lilliefors","Value-p K-S Lilliefors","W of Shapiro","Value-p Shapiro")
r2<-data.frame(Names=apply(agrupa,1,paste,collapse="."),agrupa)
r2<-r2[!duplicated(r2$Names),]
tablas<-merge(r2,r1,"Names")

cat("Table of categories")
print(tablas)

if (!is.null(file)){

if(dec=="."){
write.csv(x=tablas,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = tablas,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}



if (toupper(graph)==TRUE){
 sapply(1:length(listadatos2),generaGrafica2,listadatos2)  
}

}

else{
# Ajustes de distributiones con el test X^2 y el test de Kolmogorov-Smirnov

# Funcion para colapsar categorias de valores esperados
# inferiores a un limite predeterminado.
colapsar<-function(p1,f1,lim1=5){
  #if (){
  # return(list(probs=NA,freqs=NA))
  #}
  np1<-p1
  nf1<-f1
  tocollapse<-which((np1*sum(nf1))<lim1)
  while(length(tocollapse)>0){
   x<-tocollapse[1]
   if (x<length(np1)){
    np1[x+1]<-p1[x]+p1[x+1]
    nf1[x+1]<-f1[x]+f1[x+1]
   }else{
    np1[x-1]<-p1[x]+p1[x-1]
    nf1[x-1]<-f1[x]+f1[x-1]
   }
   p1<-np1[-x]
   f1<-nf1[-x]
   np1<-p1
   nf1<-f1
   tocollapse<-which((p1*sum(f1))<lim1)
  }
  return(list(probs=p1,freqs=f1))  
 }


calculos<-function(x){
 x<-x[!is.na(x)]
 if(length(x)>2 & length(table(x))>1){
 if(distribution=="Binomial"){
   n<-max(x, na.rm = TRUE)
   media<-mean(x, na.rm = TRUE)
   prob1<-media/n
  # Prueba de Kolmogorov-Smirnov.
   pruebaks<-ks.test(x,"pbinom",size=n,prob=prob1)
  # Prueba de chi-cuadrado.
   frecObs<-table(x)
   print(frecObs)
   probEsp<-dbinom(0:n,size=n,prob=prob1)
   frecObs2<-rep(0,length(probEsp))
   frecObs2[as.integer(names(frecObs))+1]<-as.vector(unlist(frecObs))
   frecObs<-frecObs2
   frecEsp<-probEsp*sum(frecObs)
   tablas<-data.frame(frecObs=as.vector(frecObs),frecEsp=frecEsp,probEsp=probEsp)
   # Colapsar categorias con frecuencias esperadas inferiores a 5.
   if (toupper(combine)==TRUE){
       r1<-colapsar(probEsp,frecObs)
       frecObsC<-r1$freqs
       probEspC<-r1$probs
      if(length(frecObsC)>1) pruebaChisq<-chisq.test(frecObsC,p=probEspC) else pruebaChisq<-NA
   }else{
   pruebaChisq<-chisq.test(frecObs,p=probEsp)
   }
   if (!is.na(pruebaChisq[1]) & pruebaChisq$parameter > 1 ){
       r<-c(pruebaks$statistic,pruebaks$p.value,pruebaChisq$statistic,
           pruebaChisq$parameter-1,1-pchisq(pruebaChisq$statistic,pruebaChisq$parameter-1))
      }else{
       r<-c(pruebaks$statistic,pruebaks$p.value,rep(NA,3))
     }
  } else if(distribution=="Poisson"){
    # Clculo del parametro de la distribution utilizando el momento.
    lambda<-mean(x, na.rm = TRUE)
    # Prueba de Kolmogorov-Smirnov.
    pruebaks<-ks.test(x,"ppois",lambda=lambda)
    # Prueba de chi-cuadrado.
    frecObs<-table(x)
    #probEsp<-dpois(as.integer(names(frecObs)[-length(frecObs)]),lambda=lambda)
    probEsp<-dpois(0:as.integer(names(frecObs)[length(frecObs)]),lambda=lambda)
    probEsp[length(probEsp)]<-probEsp[length(probEsp)]+(1-ppois(as.integer(names(frecObs)[length(frecObs)]),lambda=lambda))
    frecObs2<-rep(0,length(probEsp))
    frecObs2[as.integer(names(frecObs))+1]<-as.vector(unlist(frecObs))
    frecObs<-frecObs2    
    frecEsp<-probEsp*sum(frecObs)
    tablas<-data.frame(frecObs=as.vector(frecObs),frecEsp=frecEsp,probEsp=probEsp)
    # Colapsar categorias con frecuencias esperadas inferiores a 5.
    if (toupper(combine)==TRUE){
    r1<-colapsar(probEsp,frecObs)
    frecObsC<-r1$freqs
    probEspC<-r1$probs
     if(length(frecObsC)>1) pruebaChisq<-chisq.test(frecObsC,p=probEspC) else pruebaChisq<-NA
    }else{
    pruebaChisq<-chisq.test(frecObs,p=probEsp)
    }
    if (!is.na(pruebaChisq[1]) & pruebaChisq$parameter > 1 ){
	r<-c(pruebaks$statistic,pruebaks$p.value,pruebaChisq$statistic,
            pruebaChisq$parameter-1,1-pchisq(pruebaChisq$statistic,pruebaChisq$parameter-1))
	}else{
	r<-c(pruebaks$statistic,pruebaks$p.value,rep(NA,3))
      }
  } else r<-rep(NA,7)
  return(r)
}
}


generaGrafica<-function(i,lista,distribution="Binomial"){
     x<-lista[[i]]
     x<-x[!is.na(x)]
     maxD<-max(density(x)$y, na.rm = TRUE)
     if (distribution=="Poisson"){
      lambda<-mean(x, na.rm = TRUE)
      probEspG<-dpois(0:(max(x, na.rm = TRUE)+2),lambda=lambda)
      dev.new()
      MASS::truehist(x,main=distribution,
		xlab=xlab,ylab="Density",sub=Names[[i]], col=col.bar,
		xlim=c((min(x, na.rm = TRUE)-1),(max(x, na.rm = TRUE)+2)),ymax=max(max(probEspG, na.rm = TRUE),maxD)*1.2)
      lines(0:(max(x, na.rm = TRUE)+2),probEspG,type="s",col=col.line,lty=lty,lwd=lwd)
      legend(legend.pos,legend=c("Real dist.","Adjusted dist."),
		      lwd=c(lwd,lwd),lty=c(1,lty),col=c(col.bar,col.line))
     } else if(distribution=="Binomial") {
      n<-max(x, na.rm = TRUE)
      media<-mean(x, na.rm = TRUE)
      prob1<-media/n
      probEspG<-dbinom(0:(max(x, na.rm = TRUE)+2),size=n,prob=prob1)
      dev.new()
      MASS::truehist(x,main=distribution,
		xlab=xlab,ylab="Density",sub=Names[[i]],col=col.bar,
		xlim=c((min(x, na.rm = TRUE)-1),(max(x, na.rm = TRUE)+2)),ymax=max(max(probEspG, na.rm = TRUE),maxD)*1.2)
      lines(0:(max(x, na.rm = TRUE)+2),probEspG,type="s",col=col.line,lty=lty,lwd=lwd)
      legend("topleft",legend=c("Real dist.","Adjusted dist."),
		      lwd=c(lwd,lwd),lty=lty,col=c(col.bar,col.line))
     }
     invisible()
  }

# Seleccion del nombre de la distribucion


# Organizacion de la base de datos.
valores<-unlist(datos[,variables])
variables1<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),group])
names(agrupaciones)<-group

datos2<-data.frame(agrupaciones,Variable=variables1,valor=valores)

group<-c(group,"Variable")

agrupa<-data.frame(datos2[,group])
if(length(group)==1) names(agrupa)<-group

listadatos2<-split(datos2$valor,as.list(agrupa),drop=TRUE)

Names<-names(listadatos2)
r1<-t(sapply(listadatos2,calculos))
r1<-data.frame(Names=rownames(r1),r1)
if (toupper(combine)==TRUE) {
names(r1)<-c("Names","D of K-S","Value-p K-S","X Chisq2","Degrees of freedom adjusted","Value-p Chisq2 adjusted")
}else{
names(r1)<-c("Names","D of K-S","Value-p K-S","X Chisq2","Degrees of freedom","Value-p Chisq2")
}
r2<-data.frame(Names=apply(agrupa,1,paste,collapse="."),agrupa)
r2<-r2[!duplicated(r2$Names),]
tablas<-merge(r2,r1,"Names")


cat("Table of categories")
print(tablas)


if (!is.null(file)){

if(dec=="."){
write.csv(x=tablas,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = tablas,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}

if (toupper(graph)==TRUE){
  sapply(1:length(listadatos2),generaGrafica,listadatos2,distribution)  
}

}#Fin del bucle de Binomial y Poisson

}
