X2<-function(data, varX,  varY, varZ,
test=c("Pearson","Kendall"), group=NULL,
ResetPAR=TRUE, PAR=NULL,
YLAB=NULL, XLAB=NULL, CEXPCH=1.3, COLOR=NULL, PCH=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
file="Output.txt"){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varX), subset(datos, select=varY), subset(datos, select=varZ))

if(!is.null(group)){
datosT<-data.frame(datosT, subset(datos, select=group))
}

datos<-na.exclude(datosT)


#Organizacin de los datos
valoresX<-unlist(datos[,varX])
valoresY<-unlist(datos[,varY])
varZZ<-data.frame(datos[,varZ])
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(varX)),group])
if(length(group)==1) names(agrupaciones)<-group
datos2<-data.frame(agrupaciones,varind=valoresX,vardep=valoresY, varZZ)

if(!is.null(group)) colnames(datos2)<-c(agrupaciones, varX,varY, varZ) else colnames(datos2)<-c(varX,varY, varZ)


FF1<-group
CV1<-varX


Pearson<-"No information"
Kendall<-"No information"

if(!is.null(group)){
for (i in test){
    if (i=="Pearson") Pearson<-c(by(datos2[,c(varX,varY)],agrupaciones,function(x)ltm::rcor.test(x,method="pearson",use="complete.obs")))
    if (i=="Spearman") Spearman<-c(by(datos2[,c(varX,varY)],agrupaciones,function(x)ltm::rcor.test(x,method="spearman",use="complete.obs")))
    if (i=="Kendall") Kendall<-c(by(datos2[,c(varX,varY)],agrupaciones,function(x)ltm::rcor.test(x,method="kendall",use="complete.obs")))
    }
}

if(is.null(group)){
  for (i in test){
    if (i=="Pearson") Pearson<-ltm::rcor.test(datos2,method="pearson",use="complete.obs")
    if (i=="Spearman") Spearman<-ltm::rcor.test(datos2,method="spearman",use="complete.obs")
    if (i=="Kendall") Kendall<-ltm::rcor.test(datos2,method="kendall",use="complete.obs")
    }
}

PearsonP<-"No information"
KendallP<-"No information"

if(!is.null(group)){
for (i in test){
    if (i=="Pearson") PearsonP<-c(by(datos2[,c(varX,varY,varZ)],agrupaciones,function(x)ppcor::pcor(x,method="pearson")))
    if (i=="Kendall") KendallP<-c(by(datos2[,c(varX,varY,varZ)],agrupaciones,function(x)ppcor::pcor(x,method="kendall")))
    }
}

if(is.null(group)){
  for (i in test){
    if (i=="Pearson") PearsonP<-ppcor::pcor(datos2,method="pearson")
    if (i=="Kendall") KendallP<-ppcor::pcor(datos2,method="kendall")
    }
}


Resultados<-list("Pearson", Pearson, "Kendall", Kendall,"Pearson partial correlation", PearsonP, "Kendall partial correlation", KendallP)

Resultados


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

if(!is.null(group)) colnames(datos2)<-c(group, varX,varY) else colnames(datos2)<-c(varX,varY)

grafico<-"Dispersion"
IPLOT<-NULL
if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(grafico)){

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(grafico=="Dispersion"){

pcht<-14+1

if(!is.null(FF1)){
dati<-aggregate(datos2[,varY],by=list(datos2[,FF1]),mean)
d1<-dim(dati)



for (t in 1:d1[1]){#Bucle 1
pch<-14+t
if(t==1){
pcht<-pcht
legendt<-paste("' ",dati[t,1],"'")
ltyT<-t
}
else{
pcht<-append(pcht,pch)
legendt<-paste(legendt,",","'",dati[t,1],"'")
ltyT<-append(ltyT,t)
}
}#Fin bucle 1


legendT<-scan(what=character(0), sep=",", file=textConnection(legendt)) 

}
else{
d1<-c(1,1)
}

if(!is.null(COLOR)) color<-COLOR else color<-rainbow(d1[1])



ymax<-max(datos2[,varY], na.rm = TRUE)
ymin<-min(datos2[,varY], na.rm = TRUE)

xmax<-max(datos2[,CV1], na.rm = TRUE)
xmin<-min(datos2[,CV1], na.rm = TRUE)



for (t in 1:d1[1]){#Bucle 2

if(!is.null(FF1)) datas<-subset(datos2,datos2[,FF1]==dati[t,1]) else datas<-datos2


if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-varX
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-varY



if(!is.null(PCH)) pch<-PCH[t] else pch<-14+t

if(t==1){
plotexe<-paste("plot.default(","datas[,varY]~datas[,CV1],","xlab=Xlab,", "ylab=Ylab,","col=color[t],","pch=pch,",
"main=paste(FF1),","cex.main=2,","xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH", ")")
eval(parse(text=plotexe))

}
else{
plotexe<-paste("points(","datas[,varY]~datas[,CV1],","col=color[t],","pch=pch,",
"xlim=c(xmin,xmax),","ylim=c(ymin,ymax),", "cex=CEXPCH",")")
eval(parse(text=plotexe))
}




}#Fin del bucle 2

if(!is.null(PCH)) pcht<-PCH else pcht<-pcht

if(!is.null(FF1)){
if(!is.null(LEGEND)) xcxcddf<-1 else  legend(x = "topleft" , legend=legendT, bty = "n", pch=c(pcht),
col=color,pt.cex=1.5, lty=c(ltyT))
}
else{
}

}

else{#Comienza Iplot
if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-varX
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-varY

if(!is.null(IPLOT)){
iplotexe<-paste("IDPmisc::iplot(","datos[,varX],datos[,varY],",toString(x=IPLOT), ")")
zmax<-eval(parse(text=iplotexe))
iplotexe<-paste("IDPmisc::iplot(","datos[,varX],datos[,varY], zmax=zmax,",toString(x=IPLOT), ")")
eval(parse(text=iplotexe))
}
else{
iplotexe<-paste("IDPmisc::iplot(","datos2[,varX],datos2[,varY],","pixs=3,", "xlab=Xlab,", "ylab=Ylab", ")")
zmax<-eval(parse(text=iplotexe))
iplotexe<-paste("IDPmisc::iplot(","datos2[,varX],datos2[,varY],","zmax=zmax,", "border=T,", "pixs=3,",
"xlab=Xlab,", "ylab=Ylab", ")")
eval(parse(text=iplotexe))
}

}




if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final grafico

else{
}



}