X3<-function(data, variables, ResetPAR=TRUE, 
PAR=NULL, CORRPLOT=NULL, PAIRS=NULL,  colhist="#00FFFFFF", file="Output.txt"){

datos<-subset(data, select=variables)

datos1<-na.exclude(datos)


rcort<-ltm::rcor.test(datos1)

panel.hist <- function(x, ...)
{
	usr <- par("usr"); on.exit(par(usr))
	par(usr = c(usr[1:2], 0, 1.5));h <- hist(x, plot = FALSE)
	breaks <- h$breaks; nB <- length(breaks)
	y <- h$counts; y <- y/max(y)
	rect(breaks[-nB], 0, breaks[-1], y, col=colhist, ...)
}

panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor, ...)
{
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(0, 1, 0, 1))
    r <- abs(cor(x, y))
    txt <- format(c(r, 0.123456789), digits = digits)[1]
    txt <- paste0(prefix, txt)
    if(missing(cex.cor)) cex.cor <- 0.8/strwidth(txt)
    text(0.5, 0.5, txt, cex = cex.cor * r)
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()

#Grfico CORRPLOT
#Los datos se preparan usando la seleccin datos1 para poder calcular 
#las correlaciones y las probabilidades de significacin
cor.mtest <- function(datos1, conf.level = 0.95){
datos1 <- as.matrix(datos1)
n <- ncol(datos1)
p.mat <- lowCI.mat <- uppCI.mat <- matrix(NA, n, n)
diag(p.mat) <- 0
diag(lowCI.mat) <- diag(uppCI.mat) <- 1
for(i in 1:(n-1)){
for(j in (i+1):n){
tmp <- cor.test(datos1[,i], datos1[,j], conf.level = conf.level)
p.mat[i,j] <- p.mat[j,i] <- tmp$p.value
lowCI.mat[i,j] <- lowCI.mat[j,i] <- tmp$conf.int[1]
uppCI.mat[i,j] <- uppCI.mat[j,i] <- tmp$conf.int[2]
}
}
return(list(p.mat, lowCI.mat, uppCI.mat))
}

#Se calculan las correlaciones y las probabilidades de significacin
corr<-cor(datos1)
res1<-cor.mtest(datos1,0.95)


#Se representa el grfico ordenando las variables con en un anlisis de componentes principales
dev.new()
if(!is.null(CORRPLOT)){
splomtexe<-paste("corrplot::corrplot(","corr=corr,", "p.mat = res1[[1]],",toString(x=CORRPLOT), ")")
eval(parse(text=splomtexe))
}
else{
corrplot::corrplot(corr=corr, type="full",method="circle",order="FPC",p.mat = res1[[1]], sig.level=0.05)
}


smc<-psych::smc(corr) 

Resultados<-list("Correlation and p-values", rcort, "Squared Multiple Correlation (SMC)", smc)


dev.new()
#Grfico PAIRS

if(!is.null(PAIRS)){
exe<-paste("pairs(","x=datos1,", toString(x=PAIRS), ")")
eval(parse(text=exe))
}
else{
exe<-paste("pairs(","x=datos1,",  "main=NULL,", "cex.main=2,", "lower.panel=SciViews::panel.reg,",
"upper.panel=panel.cor,", "diag.panel=panel.hist,", "cex.labels=1,", "font.labels=2,", 
"cex =1.2,","pch=24,", "bg='#B2DFEEFF',", "col.smooth='red',", "line.col='red'", ")")
eval(parse(text=exe))
}


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}




}
