XI1<-function(data, varY, varX, 
model=c("Linear","Log", "S-curve", "Power", "Exp",  "Quadratic", "Cubic", "Inverse"),
outliers=NULL, quant1=0.05, quant2 = 0.95, ResetPAR=TRUE, mfrow=c(2,4), 
PAR=NULL,  PLOT=NULL, PLOTR=NULL, YLAB=NULL, XLAB=NULL, CEXPCH=1.3,
COLABLINE="#48D1CCFF", COLOR="#C0FF3EFF", PCH=15, resPlot=TRUE,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL, file1="Output.txt",
file2="Coefficients.csv", file3="Residuals.csv", na="NA", dec=",", row.names=FALSE){



###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))
datos<-na.exclude(datosT)

pch<-PCH
color<-COLOR

CV1<-varX
codres<-"YES"

###############################################
#Seccin que muestra los resultados
###############################################

if(!is.null(outliers)){
remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}

if(outliers=="Linear"){
datos2<-data.frame(datos[,varY],datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)
}

if(outliers=="Log"){
if(min(datos[,CV1])>=0.01){
datos2<-data.frame(datos[,varY],log(datos[,CV1]))
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)
}
else{
codres<-"NO"
}
}

if(outliers=="S-curve"){
if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),1/datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1]+reg$coefficients[2]/datos[,CV1])
}
else{
codres<-"NO"
}
}

if(outliers=="Power"){
if(min(datos[,varY])>=0.01){
if(min(datos[,CV1])>=0.01){
datos2<-data.frame(log(datos[,varY]),log(datos[,CV1]))
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*datos[,CV1]^reg$coefficients[2]
}
else{
codres<-"NO"
}
}
else{
codres<-"NO"
}
}

if(outliers=="Exp"){
if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*exp(datos[,CV1]*reg$coefficients[2])
}
else{
codres<-"NO"
}
}


if(outliers=="Quadatric"){
datos2<-data.frame(datos[,varY],datos[,CV1],datos[,CV1]^2)
colnames(datos2)<-c(varY,CV1,paste(CV1,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
res<-residuals(reg)
}

if(outliers=="Cubic"){
datos2<-data.frame(datos[,varY],datos[,CV1],datos[,CV1]^2,datos[,CV1]^3)
colnames(datos2)<-c(varY,CV1,paste(CV1,"2",sep=""),paste(CV1,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
res<-residuals(reg)
}

if(outliers=="Inverse"){
datos2<-data.frame(datos[,varY],1/datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)
}

if(codres=="YES"){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)
}

}



residuos<-data.frame(datos[,varY],datos[,CV1])
colnames(residuos)<-c(varY,CV1)

coeficientes<-matrix(data = c(1,1,1,1,1,1) , ncol = 6)
colnames(coeficientes)<-c("Model","a","b","c","d", "r2")
coeficientes<-as.data.frame(coeficientes)


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-varX
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-varY


if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
par(mfrow=mfrow)
}

win<-0

ymax<-max(datos[,varY],na.rm=T)
ymin<-min(datos[,varY],na.rm=T)
xmax<-max(datos[,CV1],na.rm=T)
xmin<-min(datos[,CV1],na.rm=T)

#Linear
texto<-"Linear"

i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){


if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

datos2<-data.frame(datos[,varY],datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-residuals(reg)
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Linear")

Re1<-summary(reg)

coeficientes<- rbind(coeficientes, c("Linear", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re1$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie1<-nortest::lillie.test(res)

#Autocorrelation
DW1<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan1<-lmtest::bptest(reg)


i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re1$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re1<-""
Lillie1<-""
DW1<-""
BreuschPagan1<-""
}#Fin Linear


Resultados<-list("Linear",Re)

#Log
texto<-"Log"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}



if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){

plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

if(min(datos[,CV1])>=0.01){
datos2<-data.frame(datos[,varY],log(datos[,CV1]))
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-residuals(reg)
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Log")
Re2<-summary(reg)
coeficientes<- rbind(coeficientes, c("Log", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re2$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*log(cx)
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie2<-nortest::lillie.test(res)

#Autocorrelation
DW2<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan2<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re2$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}
else{
Re2<-""
Lillie2<-""
DW2<-""
BreuschPagan2<-""
}


}
else{
Re2<-""
Lillie2<-""
DW2<-""
BreuschPagan2<-""
}#Fin Log


#S-curve
texto<-"S-curve"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}


if(!is.null(PLOT)){

plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

if(min(datos[,varY])>=0.01 & min(datos[,CV1])>=0.01){
datos2<-data.frame(log(datos[,varY]),1/datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-datos[,varY]-exp(reg$coefficients[1]+reg$coefficients[2]/datos[,CV1])
residuos<-data.frame(residuos,res)

dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"S-curve")
Re8<-summary(reg)
coeficientes<- rbind(coeficientes, c("S-curve", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re8$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1]+reg$coefficients[2]/cx)
lines(cx,cy,  col=COLABLINE,   lwd=3 )



#Normality
Lillie8<-nortest::lillie.test(res)

#Autocorrelation
DW8<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan8<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re8$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}
else{
Re8<-""
Lillie8<-""
DW8<-""
BreuschPagan8<-""
}
}
else{
Re8<-""
Lillie8<-""
DW8<-""
BreuschPagan8<-""
}#Fin S-curve





#Power
texto<-"Power"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

if(min(datos[,varY])>=0.01){
if(min(datos[,CV1])>=0.01){
datos2<-data.frame(log(datos[,varY]),log(datos[,CV1]))
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-datos[,varY]-exp(reg$coefficients[1])*datos[,CV1]^reg$coefficients[2]
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Power")
Re3<-summary(reg)
coeficientes<- rbind(coeficientes, c("Power", format(exp(reg$coefficients[1]),digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re3$r.squared, digits = 2, decimal.mark=dec)))



cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*cx^reg$coefficients[2]
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie3<-nortest::lillie.test(res)

#Autocorrelation
DW3<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan3<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re3$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}

}
else{
Re3<-""
Lillie3<-""
DW3<-""
BreuschPagan3<-""
}
}
else{
Re3<-""
Lillie3<-""
DW3<-""
BreuschPagan3<-""
}
}
else{
Re3<-""
Lillie3<-""
DW3<-""
BreuschPagan3<-""
}#Fin Power



#Exponential
texto<-"Exp"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}
if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-datos[,varY]-exp(reg$coefficients[1])*exp(datos[,CV1]*reg$coefficients[2])
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Exp")

Re4<-summary(reg)
coeficientes<- rbind(coeficientes, c("Exp", format(exp(reg$coefficients[1]),digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re4$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*exp(cx*reg$coefficients[2])
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie4<-nortest::lillie.test(res)

#Autocorrelation
DW4<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan4<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re4$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}
else{
Re4<-""
Lillie4<-""
DW4<-""
BreuschPagan4<-""
}

}
else{
Re4<-""
Lillie4<-""
DW4<-""
BreuschPagan4<-""
}#Fin Exp



#Quadratic
texto<-"Quadratic"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){

plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

datos2<-data.frame(datos[,varY],datos[,CV1],datos[,CV1]^2)
colnames(datos2)<-c(varY,CV1,paste(CV1,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)

res<-residuals(reg)
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Quadratic")
Re5<-summary(reg)
coeficientes<- rbind(coeficientes, c("Quadratic", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),format(reg$coefficients[3], digits=5, decimal.mark=dec),NA,
format(Re5$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie5<-nortest::lillie.test(res)

#Autocorrelation
DW5<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan5<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re5$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re5<-""
Lillie5<-""
DW5<-""
BreuschPagan5<-""
}#Fin Quadratic


#Cubic
texto<-"Cubic"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){

plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

datos2<-data.frame(datos[,varY],datos[,CV1],datos[,CV1]^2,datos[,CV1]^3)
colnames(datos2)<-c(varY,CV1,paste(CV1,"2",sep=""),paste(CV1,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)

res<-residuals(reg)
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Cubic")
Re6<-summary(reg)
coeficientes<- rbind(coeficientes, c("Cubic", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),format(reg$coefficients[3], digits=5, decimal.mark=dec),
format(reg$coefficients[4], digits=5, decimal.mark=dec), format(Re6$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2+reg$coefficients[4]*cx^3
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie6<-nortest::lillie.test(res)

#Autocorrelation
DW6<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan6<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re6$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re6<-""
Lillie6<-""
DW6<-""
BreuschPagan6<-""
}#Fin Cubic



#Inverse
texto<-"Inverse"



i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
if(win==0){
win<-1
}
else{
win<-1
dev.new()
}
}
if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}


if(!is.null(PLOT)){

plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

if(is.na(match(0,datos[,CV1]))){
datos2<-data.frame(datos[,varY],1/datos[,CV1])
colnames(datos2)<-c(varY,CV1)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)

res<-residuals(reg)
residuos<-data.frame(residuos,res)
dit<-dim(residuos)
colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],"Inverse")
Re7<-summary(reg)
coeficientes<- rbind(coeficientes, c("Inverse", format(reg$coefficients[1],digits=5, decimal.mark=dec),
format(reg$coefficients[2], digits=5, decimal.mark=dec),NA, NA,
format(Re7$r.squared, digits = 2, decimal.mark=dec)))

cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*1/cx
lines(cx,cy,  col=COLABLINE,   lwd=3 )

#Normality
Lillie7<-nortest::lillie.test(res)

#Autocorrelation
DW7<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan7<-lmtest::bptest(reg)

i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="topleft", legend=bquote(italic(r)^2 == .(format(Re7$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}

}
else{
Re7<-""
Lillie7<-""
DW7<-""
BreuschPagan7<-""
}

}
else{
Re7<-""
Lillie7<-""
DW7<-""
BreuschPagan7<-""
}#Fin Inverse



if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}




if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}





Resultados<-list("LINEAR REGRESSION", Re1,"Normality", Lillie1, "Autocorrelation", DW1, "Homocedasticity",BreuschPagan1,
"LOGARITHMIC REGRESSION", Re2,"Normality", Lillie2, "Autocorrelation", DW2, "Homocedasticity",BreuschPagan2,
"S-CURVE REGRESSION", Re8, "Normality", Lillie8, "Autocorrelation", DW8, "Homocedasticity",BreuschPagan8,
"POWER REGRESSION", Re3,"Normality", Lillie3, "Autocorrelation", DW3, "Homocedasticity",BreuschPagan3,
"EXPONENTIAL REGRESSION", Re4,"Normality", Lillie4, "Autocorrelation", DW4, "Homocedasticity",BreuschPagan4,
"QUADRATIC REGRESSION", Re5,"Normality", Lillie5, "Autocorrelation", DW5, "Homocedasticity",BreuschPagan5,
"CUBIC REGRESSION", Re6, "Normality", Lillie6, "Autocorrelation", DW6, "Homocedasticity",BreuschPagan6,
"INVERSE REGRESSION", Re7, "Normality", Lillie7, "Autocorrelation", DW7, "Homocedasticity",BreuschPagan7)



coeficientes<-coeficientes[-1,]


print(Resultados)

if(!is.null(file)){
sink(file1)
print(Resultados)
sink()
}


if(resPlot==TRUE){

if(!is.null(mfrow)){
dev.new()
par(mfrow=mfrow)
}

dires<-dim(residuos)
minres<-min(residuos[,3:dires[2]],na.rm=T)
maxres<-max(residuos[,3:dires[2]],na.rm=T)

for(z in 3:dires[2]){

if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()
if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOTR)){
plotexe<-paste("plot.default(","residuos[,z]~(residuos[,1]-residuos[,z]),", toString(x=PLOTR), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","residuos[,z]~(residuos[,1]-residuos[,z]),", 
"main=names(residuos)[z],", "col='red',", "pch=16,", "xlab='Typified predictions',",
"ylab='Typified residuals',", "ylim=c(minres,maxres)",")")
eval(parse(text=plotexe))
abline(h=0)
}

}
}




if(dec=="."){
write.csv(x=residuos,file = file3, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = residuos,file = file3, fileEncoding = "", row.names=row.names,na=na)
}



if(dec=="."){
write.csv(x=coeficientes,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coeficientes,file = file2, fileEncoding = "", row.names=row.names,na=na)
}


}