XI2<-function(data, varY, varX, 
model=c("Clench", "Nexponential", "Saturation", "Rational", "Bertalanffy", "Gompertz", "Logistic"),
outliers=NULL, quant1=0.05, quant2 = 0.95, ResetPAR=TRUE, mfrow=c(2,4), 
PAR=NULL,  PLOT=NULL, YLAB=NULL, XLAB=NULL, CEXPCH=1.3,
COLABLINE="#48D1CCFF", COLOR="#C0FF3EFF", PCH=15, resPlot=TRUE,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL, file1="Output.txt",
file2="Coefficients.csv", file3="Residuals.csv", na="NA", dec=",", row.names=FALSE){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))
datos<-na.exclude(datosT)

pch<-PCH
color<-COLOR

CV1<-varX

ymax<-max(datos[,varY],na.rm=T)
ymin<-min(datos[,varY],na.rm=T)
xmax<-max(datos[,CV1],na.rm=T)
xmin<-min(datos[,CV1],na.rm=T)


###############################################
#Seccin que muestra los resultados
###############################################

datos2<-data.frame(datos[,varY],datos[,CV1])
colnames(datos2)<-c(varY,CV1)
datos2<-na.exclude(datos2)


if(!is.null(outliers)){
remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}



if(outliers=="Clench"){
fo<-paste(names(datos2)[1], "~a*", names(datos2)[2],"/(1+b*",names(datos2)[2],")")
reg<-try(nls(fo, data=datos2, trace=T), silent=TRUE)
Re1<-summary(reg)
if (is.character(Re1[1])==T) {Re1<-"It was not possible to fit the function"}

if (is.character(Re1)==FALSE){res<-datos[,varY]-(Re1$coefficients[1,1]*datos[,CV1])/(Re1$coefficients[2,1]+datos[,CV1])}
if (is.character(Re1)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re1)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re1)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Clench


if(outliers=="Nexponential"){
fo<-paste(names(datos2)[1], "~a*(1-exp(-b*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=(ymax-ymin)/(xmax-xmin))), silent=TRUE)
Re3<-summary(reg)

if (is.character(Re3[1])==T) {Re3<-"It was not possible to fit the function"}

if (is.character(Re3)==FALSE){res<-datos[,varY]-Re3$coefficients[1,1]*(1-exp(-Re3$coefficients[2,1]*datos[,CV1]))}
if (is.character(Re3)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re3)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re3)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Nexponential


if(outliers=="Saturation"){
fo<-paste(names(datos2)[1], "~a*(1-exp(-b*(",names(datos2)[2],"-c)))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=(ymax-ymin)/(xmax-xmin), c=0)), silent=TRUE)
Re4<-summary(reg)

if (is.character(Re4[1])==T) {Re4<-"It was not possible to fit the function"}

if (is.character(Re4)==FALSE){res<-datos[,varY]-Re4$coefficients[1,1]*(1-exp(-Re4$coefficients[2,1]*(datos[,CV1]-Re4$coefficients[3,1])))}
if (is.character(Re4)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re4)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re4)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Saturation



if(outliers=="Rational"){
fo<-paste(names(datos2)[1], "~(a+b*",names(datos2)[2],")/(1+c*",names(datos2)[2] ,")")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=1, b=(ymax-ymin)/(xmax-xmin), c=0)), silent=TRUE)
Re5<-summary(reg)

if (is.character(Re5[1])==T) {Re5<-"It was not possible to fit the function"}

if (is.character(Re5)==FALSE){res<-datos[,varY]-(Re5$coefficients[1,1]+Re5$coefficients[2,1]*datos[,CV1])/(1+Re5$coefficients[3,1]*datos[,CV1])}
if (is.character(Re5)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re5)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re5)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Rational


if(outliers=="Bertalanffy"){
fo<-paste(names(datos2)[1], "~a*(1-exp(-b*(",names(datos2)[2],"-c)))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=(ymax-ymin)/(xmax-xmin), c=0)), silent=TRUE)
Re7<-summary(reg)

if (is.character(Re7[1])==T) {Re7<-"It was not possible to fit the function"}

if (is.character(Re7)==FALSE){res<-datos[,varY]-Re7$coefficients[1,1]*(1-exp(-Re7$coefficients[2,1]*(datos[,CV1]-Re7$coefficients[3,1])))}
if (is.character(Re7)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re7)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re7)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Bertalanffy


if(outliers=="Gompertz"){
fo<-paste(names(datos2)[1], "~a*exp(-b*exp(-c*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=(ymax-ymin)/(xmax-xmin),c=ymax/1000)), silent=TRUE)
Re6<-summary(reg)

if (is.character(Re6[1])==T) {Re6<-"It was not possible to fit the function"}

if (is.character(Re6)==FALSE){res<-datos[,varY]-Re6$coefficients[1,1]*exp(-Re6$coefficients[2,1]*exp(-Re6$coefficients[3,1]*datos[,CV1]))}
if (is.character(Re6)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re6)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re6)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Gompertz

if(outliers=="Logistic"){
fo<-paste(names(datos2)[1], "~a/(1+exp(b-c*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=floor(ymax), b=floor((xmax-xmin)/2),c=1)), silent=TRUE)
Re8<-summary(reg)

if (is.character(Re8[1])==T) {Re8<-"It was not possible to fit the function"}

if (is.character(Re8)==FALSE){res<-datos[,varY]-(Re8$coefficients[1,1]/(1+exp(Re8$coefficients[2,1]-Re8$coefficients[3,1]*datos[,CV1])))}
if (is.character(Re8)==FALSE){resOut<- remove_outliers(res)}
if (is.character(Re8)==FALSE){datosOut<-data.frame(datos,resOut)}
if (is.character(Re8)==FALSE){datos<-na.exclude(datosOut)}

}#Fin Logistic


}#Fin outliers



residuos<-data.frame(datos[,varY],datos[,CV1])
colnames(residuos)<-c(varY,CV1)

coeficientes<-matrix(data = c(1,1,1,1,1) , ncol = 5)
colnames(coeficientes)<-c("Model","a","b","c", "r2")
coeficientes<-as.data.frame(coeficientes)


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(XLAB)) Xlab<-XLAB else Xlab<-varX
if(!is.null(YLAB)) Ylab<-YLAB else Ylab<-varY


if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
par(mfrow=mfrow)
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}


#Clench
texto<-"Clench"



i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

fo<-paste(names(datos2)[1], "~a*", names(datos2)[2],"/(1+b*",names(datos2)[2],")")
reg<-try(nls(fo, data=datos2, start=list(a=1, b=0.01)), silent=T)
Re2<-summary(reg)
res<-""
R2<-""
Lillie2<-""
if (is.character(Re2[1])==T) {Re2<-"It was not possible to fit the function"}

if (is.character(Re2)==FALSE){res<-datos[,varY]-(Re2$coefficients[1,1]*datos[,CV1])/(1+Re2$coefficients[2,1]*datos[,CV1])}
if (is.character(Re2)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re2)==FALSE){Lillie2<-nortest::lillie.test(res)}


if (is.character(Re2)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re2)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re2)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re2$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re2$coefficients[2,1], digits=5, decimal.mark=dec), NA,
format(R2, digits = 2, decimal.mark=dec)))}



cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re2)==FALSE){cy<-(Re2$coefficients[1,1]*cx)/(1+Re2$coefficients[2,1]*cx)}
if (is.character(Re2)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re2<-""
Lillie2<-""
}#Fin Clench



#Nexponential

texto<-"Nexponential"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}


fo<-paste(names(datos2)[1], "~a*(1-exp(-b*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=0.01)), silent=TRUE)
Re3<-summary(reg)
res<-""
R2<-""
Lillie3<-""
if (is.character(Re3[1])==T) {Re3<-"It was not possible to fit the function"}

if (is.character(Re3)==FALSE){res<-datos[,varY]-Re3$coefficients[1,1]*(1-exp(-Re3$coefficients[2,1]*datos[,CV1]))}
if (is.character(Re3)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}

if (is.character(Re3)==FALSE){Lillie3<-nortest::lillie.test(res)}


if (is.character(Re3)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re3)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re3)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re3$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re3$coefficients[2,1], digits=5, decimal.mark=dec), NA,
format(R2, digits = 2, decimal.mark=dec)))}

cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re3)==FALSE){cy<-Re3$coefficients[1,1]*(1-exp((-Re3$coefficients[2,1]*cx)))}
if (is.character(Re3)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re3<-""
Lillie3<-""
}#Fin Nexponential


#Saturation

texto<-"Saturation"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}


fo<-paste(names(datos2)[1], "~a*(1-exp(-b*(",names(datos2)[2],"-c)))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=0.01, c=0)), silent=TRUE)
Re4<-summary(reg)
res<-""
R2<-""
Lillie4<-""
if (is.character(Re4[1])==T) {Re4<-"It was not possible to fit the function"}

if (is.character(Re4)==FALSE){res<-datos[,varY]-Re4$coefficients[1,1]*(1-exp(-Re4$coefficients[2,1]*(datos[,CV1]-Re4$coefficients[3,1])))}
if (is.character(Re4)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re4)==FALSE){Lillie4<-nortest::lillie.test(res)}




if (is.character(Re4)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re4)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re4)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re4$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re4$coefficients[2,1], digits=5, decimal.mark=dec), format(Re4$coefficients[3,1], digits=5, decimal.mark=dec),
format(R2, digits = 2, decimal.mark=dec)))}


cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re4)==FALSE){cy<-Re4$coefficients[1,1]*(1-exp(-Re4$coefficients[2,1]*(cx-Re4$coefficients[3,1])))}
if (is.character(Re4)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re4<-""
Lillie4<-""
}#Fin Saturation


#Rational

texto<-"Rational"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}


fo<-paste(names(datos2)[1], "~(a+b*",names(datos2)[2],")/(1+c*",names(datos2)[2] ,")")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=1, b=1, c=0)), silent=TRUE)
Re5<-summary(reg)
res<-""
R2<-""
Lillie5<-""


if (is.character(Re5[1])==T) {Re5<-"It was not possible to fit the function"}

if (is.character(Re5)==FALSE){res<-datos[,varY]-(Re5$coefficients[1,1]+Re5$coefficients[2,1]*datos[,CV1])/(1+Re5$coefficients[3,1]*datos[,CV1])}
if (is.character(Re5)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re5)==FALSE){Lillie5<-nortest::lillie.test(res)}



if (is.character(Re5)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re5)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re5)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re5$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re5$coefficients[2,1], digits=5, decimal.mark=dec), format(Re5$coefficients[3,1], digits=5, decimal.mark=dec),
format(R2, digits = 2, decimal.mark=dec)))}


cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re5)==FALSE){cy<-(Re5$coefficients[1,1]+Re5$coefficients[2,1]*cx)/(1+Re5$coefficients[3,1]*cx)}
if (is.character(Re5)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re5<-""
Lillie5<-""
}#Fin Rational


#Bertalanffy


texto<-"Bertalanffy"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}


fo<-paste(names(datos2)[1], "~Li*(1-exp(-k*(",names(datos2)[2],"-t0)))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(Li=ymax, k=(ymax-ymin)/(xmax-xmin), t0=0)), silent=TRUE)
Re7<-summary(reg)
res<-""
R2<-""
Lillie7<-""
if (is.character(Re7[1])==T) {Re7<-"It was not possible to fit the function"}

if (is.character(Re7)==FALSE){res<-datos[,varY]-Re7$coefficients[1,1]*(1-exp(-Re7$coefficients[2,1]*(datos[,CV1]-Re7$coefficients[3,1])))}
if (is.character(Re7)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re7)==FALSE){Lillie7<-nortest::lillie.test(res)}




if (is.character(Re7)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re7)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re7)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re7$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re7$coefficients[2,1], digits=5, decimal.mark=dec), format(Re7$coefficients[3,1], digits=5, decimal.mark=dec),
format(R2, digits = 2, decimal.mark=dec)))}


cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re7)==FALSE){cy<-Re7$coefficients[1,1]*(1-exp(-Re7$coefficients[2,1]*(cx-Re7$coefficients[3,1])))}
if (is.character(Re7)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re7<-""
Lillie7<-""
}#Fin Bertalanffy




#Gompertz

texto<-"Gompertz"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

fo<-paste(names(datos2)[1], "~a*exp(-b*exp(-c*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=ymax, b=(ymax-ymin)/(xmax-xmin),c=ymax/1000)), silent=TRUE)
Re6<-summary(reg)
res<-""
R2<-""
Lillie6<-""


if (is.character(Re6[1])==T) {Re6<-"It was not possible to fit the function"}

if (is.character(Re6)==FALSE){res<-datos[,varY]-Re6$coefficients[1,1]*exp(-Re6$coefficients[2,1]*exp(-Re6$coefficients[3,1]*datos[,CV1]))}
if (is.character(Re6)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re6)==FALSE){Lillie6<-nortest::lillie.test(res)}



if (is.character(Re6)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re6)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re6)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re6$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re6$coefficients[2,1], digits=5, decimal.mark=dec), format(Re6$coefficients[3,1], digits=5, decimal.mark=dec),
format(R2, digits = 2, decimal.mark=dec)))}


cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re6)==FALSE){cy<-Re6$coefficients[1,1]*exp(-Re6$coefficients[2,1]*exp(-Re6$coefficients[3,1]*cx))}
if (is.character(Re6)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re6<-""
Lillie6<-""
}#Fin Gompertz



#Logistic

texto<-"Logistic"


i<-0
sad<-regexpr(pattern = texto, text=model) > 0 
i<-sum(sad)
if (i==1){

if(!is.null(mfrow)){
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}



if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

if(!is.null(PLOT)){
plotexe<-paste("plot.default(","x=datos[,varY]~datos[,CV1],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,CV1],", "xlab=Xlab,", "ylab=Ylab,","col=color,","pch=pch,",
"cex=CEXPCH,", "main=texto", ")")
eval(parse(text=plotexe))
}

fo<-paste(names(datos2)[1], "~a/(1+exp(b-c*",names(datos2)[2],"))")
reg<-try(nls(fo, data=datos2, trace=T, start=list(a=floor(ymax), b=floor((xmax-xmin)/2),c=1)), silent=TRUE)
Re8<-summary(reg)
res<-""
R2<-""
Lillie8<-""


if (is.character(Re8[1])==T) {Re8<-"It was not possible to fit the function"}

if (is.character(Re8)==FALSE){res<-datos[,varY]-(Re8$coefficients[1,1]/(1+exp(Re8$coefficients[2,1]-Re8$coefficients[3,1]*datos[,CV1])))}
if (is.character(Re8)==FALSE){R2<-1-var(res, na.rm=T)/var(datos[,varY], na.rm=T)}
#Normality
if (is.character(Re8)==FALSE){Lillie8<-nortest::lillie.test(res)}



if (is.character(Re8)==FALSE){residuos<-data.frame(residuos,res)}
dit<-dim(residuos)
if (is.character(Re8)==FALSE){colnames(residuos)<-c(colnames(residuos)[1:dit[2]-1],texto)}

if (is.character(Re8)==FALSE){coeficientes<- rbind(coeficientes, c(texto, format(Re8$coefficients[1,1],digits=5, decimal.mark=dec),
format(Re8$coefficients[2,1], digits=5, decimal.mark=dec), format(Re8$coefficients[3,1], digits=5, decimal.mark=dec),
format(R2, digits = 2, decimal.mark=dec)))}


cx<-seq(xmin,xmax, length.out = 100)
if (is.character(Re8)==FALSE){cy<-Re8$coefficients[1,1]/(1+exp(Re8$coefficients[2,1]-Re8$coefficients[3,1]*cx))}
if (is.character(Re8)==FALSE){lines(cx,cy,  col=COLABLINE,   lwd=3 )}



i<-0
if(!is.null(LEGEND)){
xcxcddf<-1
}
else{
legend(x="bottomright", legend=bquote(italic(r)^2 == .(format(R2, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}


}
else{
Re8<-""
Lillie8<-""
}#Fin Logistic


if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}




Resultados<-list("CLENCH",Re2,"Normality", Lillie2, "NEGATIVE EXPONENTIAL", Re3,"Normality", Lillie3,
"SATURATION", Re4,"Normality", Lillie4, "RATIONAL", Re5, "Normality", Lillie5,
"BERTALANFFY", Re7, "Normality", Lillie7, "GOMPERTZ", Re6, "Normality", Lillie6,
"LOGISTIC", Re8, "Normality", Lillie8)



coeficientes<-coeficientes[-1,]


print(Resultados)

if(!is.null(file)){
sink(file1)
print(Resultados)
sink()
}


if(resPlot==TRUE){

if(!is.null(mfrow)){
dev.new()
par(mfrow=mfrow)
}

dires<-dim(residuos)
minres<-min(residuos[,3:dires[2]],na.rm=T)
maxres<-max(residuos[,3:dires[2]],na.rm=T)

for(z in 3:dires[2]){

if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()
if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5, font.main=2, cex.main=1.7)
}

plot((residuos[,1]-residuos[,z]),residuos[,z], main=names(residuos)[z], col="red", pch=16,
xlab="Typified predictions",ylab="Typified residuals", ylim=c(minres,maxres))
abline(h=0)
}
}




if(dec=="."){
write.csv(x=residuos,file = file3, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = residuos,file = file3, fileEncoding = "", row.names=row.names,na=na)
}



if(dec=="."){
write.csv(x=coeficientes,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coeficientes,file = file2, fileEncoding = "", row.names=row.names,na=na)
}


}