XI5<-function(data, varY, varX, outliers=FALSE, quant1=0.05, quant2 = 0.95,
stepwise=FALSE, direction="both", deplog=FALSE, indlog=FALSE,
method="hier.part", threshold=10, CoVa=FALSE, typeV="lmg", rela=TRUE, b=1000, names.abbrev=15,
ylimV=NULL, mainV=NULL, cex.title=1.5,  PAIRS=TRUE, lower.panel=panel.smooth,
upper.panel=panel.reg, diag.panel=panel.hist, main=NULL, cex.main=2, cex=1.2, pch=24,
colhist="#00FFFFFF", bg="#B2DFEEFF", cex.labels=1, font.labels=2,  file1="Output.txt",
file2="Residuals.csv", na="NA", dec=",", row.names=FALSE){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))
datos<-na.exclude(datosT)


## Obtained form the package SciViews
panel.reg <- function (x, y, col = par("col"), bg = par("bg"), pch = par("pch"),
cex = par("cex"), lwd = par("lwd"), line.reg = lm, line.col = "red",
line.lwd = lwd, untf = TRUE, ...) 
{
    points(x, y, col = col, bg = bg, pch = pch, cex = cex)
    if (is.function(line.reg)) 
        abline(reg = line.reg(y ~ x), col = line.col, lwd = line.lwd,
			untf = untf, ...)
}

## Obtained form the package SciViews
panel.hist <- function(x, ...)
{
	usr <- par("usr"); on.exit(par(usr))
	par(usr = c(usr[1:2], 0, 1.5));h <- hist(x, plot = FALSE)
	breaks <- h$breaks; nB <- length(breaks)
	y <- h$counts; y <- y/max(y)
	rect(breaks[-nB], 0, breaks[-1], y, col=colhist, ...)
}


ZZ<-matrix(c("","","","","","","",""), nrow=4)

#Outliers
if(outliers==TRUE){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Removing outliers...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)

remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}


datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)
zz<-dim(datos2)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
for(i in 3:zz[2]){
fo<-paste(fo, "+", names(datos2)[i])
}
reg<-lm(fo,data=datos2)
res<-residuals(reg)


resOut<- remove_outliers(res)

datosOut<-data.frame(datos,resOut)

datosOut<-na.exclude(datosOut)
dif<-dim(datosOut)
vex<-apply(datosOut[,-dif[2]],2,sd)
if(any(vex == 0)) datos<-na.exclude(datos) else datos<-na.exclude(datosOut)
}

datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)

if(deplog==TRUE){
YLN<-log(datos2[,varY]-(min(datos2[,varY])-1))
datos2<-data.frame(YLN, datos2[,varX])
colnames(datos2)<-c(paste("LN", varY, sep=""),varX)
}

if(indlog==TRUE){
datosLN<-datos2[, varX]
dimT<-dim(datos2[, varX])
for(i in 1:dimT[2]){
datosLN[,i]<-log(datos2[,varX[i]]-(min(datos2[,varX[i]])-1))
}
colLN<-colnames(datosLN)
lenLN<-length(colnames(datosLN))
for(i in 1:lenLN){
colLN[i]<-paste("LN", colLN[i], sep="")
}
colnames(datosLN)<-colLN
datos2<-data.frame(datos2,datosLN)
}


datos<-na.exclude(datos2)

datos2<-na.exclude(datos2)

#Colinearity
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Estimating VIF and removing auto-correlated variables (be patient)...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)

VIF1<-usdm::vif(datos2)

if(deplog==TRUE) VIF1<-VIF1[VIF1$Variables!=paste("LN", varY, sep=""),] else VIF1<-VIF1[VIF1$Variables!=varY,]

VIF2<-"No estimated"

CT<-"No estimated"

hjkl<-0

if(!is.null(method)){


if(method=="vif"){
write.csv2(datos2,"VIF_variables.csv",row.names=FALSE)
write.table(threshold,"threshold.txt", row.names=FALSE,col.names=FALSE)
write.table(threshold,"VIF.txt", row.names=FALSE,col.names=FALSE)
while(file.exists("VIF_Created.txt") ==FALSE){
}
file.remove("VIF_Created.txt")
if(file.exists("VIF.txt") ) {file.remove("VIF.txt")}
VIF<-read.csv2(file = "VIF_Result.csv", header=TRUE, encoding="latin1")
VIF2<-VIF
}



if(method=="vifcor"){
VIF2<-usdm::vifcor(datos2)
VIF2<-attributes(VIF2)
VIF2<-VIF2$results
}

if(method=="vifstep"){
VIF2<-usdm::vifstep(datos2, th=threshold)
VIF2<-attributes(VIF2)
VIF2<-VIF2$results
}



if(method=="hier.part"){
dit<-dim(datos2)
if(dit[2]>13){
VIF2<-usdm::vifstep(datos2, th=threshold)
VIF2<-attributes(VIF2)
VIF2<-VIF2$results

}
else{
hjkl<-1
hie1<-hier.part::hier.part(datos2[,1], datos2[,-1], barplot = FALSE)
VIF2<-usdm::vif(datos2[,-1])
CT<-hie1$I.perc
if(max(VIF2[,2])>threshold){
while(max(VIF2[,2])>threshold){ 
hie<-hier.part::hier.part(datos2[,1], datos2[,-1], barplot = FALSE)
VIFmatriz<-cbind(hie$I.perc,VIF2[,2])
VIFmatriz1<-VIFmatriz[which(VIFmatriz[,2]>threshold),]
eliminar<-rownames(which(VIFmatriz1 == min(VIFmatriz1[,1]), arr.ind = TRUE))
datos2<-datos2[ , -which(names(datos2) %in% eliminar)]
VIF2<-usdm::vif(datos2[,-1])
}
}

VIF2<-usdm::vifstep(datos2, th=threshold)
VIF2<-attributes(VIF2)
VIF2<-VIF2$results

CTT<-hie1$I.perc
CTT<-data.frame(Variables=rownames(CTT), CTT)
CTT<-CTT[order(CTT$I, decreasing = TRUE), ]
dev.new()
barplot(CTT$I, names.arg=CTT$Variables, ylab="% Independent effects (%I)", main="All variables", font.lab=2, font.axis=2, cex.lab=1.2)




}

}




VIF2<-data.frame(VIF2, VIF2)


dimT<-dim(VIF2)

VIF2[,3]<-gsub("LN","",VIF2[,3])

for(i in 1:dimT[1]){
fo<-paste(names(datos2)[1], "~", VIF2[i,1])
reg<-lm(fo, data=datos2)
mod<-summary(reg)
VIF2[i,4]<-mod$r.squared
}

VIF2<-VIF2[order(VIF2[,4], decreasing = TRUE), ]

VIF2<-VIF2[!duplicated(VIF2[,3]),]

if(deplog==TRUE) VIF2<-VIF2[VIF2$Variables!=paste("LN", varY, sep=""),] else VIF2<-VIF2[VIF2$Variables!=varY,]



VIF2<-VIF2[,1:2]

datos2<-subset(datos2, select=as.character(unique(VIF2[,1])))

if(deplog==TRUE) datos3<-data.frame(datos[,paste("LN", varY, sep="")],datos2) else datos3<-data.frame(datos[,varY],datos2)

if(deplog==TRUE) colnames(datos3)<-c(paste("LN", varY, sep=""), colnames(datos2)) else colnames(datos3)<-c(varY, colnames(datos2))
datos2<-datos3
remove(datos3)



}



if(hjkl==1){

dit2<-dim(datos2)
if(dit[2]==dit2[2]){
dev.new()
barplot(CTT$I, names.arg=CTT$Variables, ylab="% Independent effects (%I)",main="Selected variables", font.lab=2, font.axis=2, cex.lab=1.2)
}
else{
hie<-hier.part::hier.part(datos2[,1], datos2[,-1], barplot = FALSE)
CTT<-hie$I.perc
CTT<-data.frame(Variables=rownames(CTT), CTT)
CTT<-CTT[order(CTT$I, decreasing = TRUE), ]
dev.new()
barplot(CTT$I, names.arg=CTT$Variables, ylab="% Independent effects (%I)",main="Selected variables", font.lab=2, font.axis=2, cex.lab=1.2)
}


hjkl<-0
}



#Modelo de regresin
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Multivariate regression analysis...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)


zz<-dim(datos2)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
for(i in 3:zz[2]){
fo<-paste(fo, "+", names(datos2)[i])
}
reg<-lm(fo,data=datos2)

if(stepwise==TRUE){
reg<-step(reg)
}

Re1<-summary(reg)
res<-residuals(reg)

if(deplog==TRUE){
residuos<-data.frame(datos2[,paste("LN", varY, sep="")],res)
colnames(residuos)<-c(paste("LN", varY, sep=""),"Residuals")
}
else{
residuos<-data.frame(datos2[,varY],res)
colnames(residuos)<-c(varY,"Residuals")
}

#Normality
Lillie1<-nortest::lillie.test(res)

#Autocorrelation
DW1<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan1<-lmtest::bptest(reg)


#Colinearity of model
VIFModel<-car::vif(reg)



if(PAIRS==TRUE){
#Grficos
dev.new()

lent<-length(reg$coefficients)
selec<-names(reg$coefficients)[2:lent]
selec<-unlist(strsplit(selec, split=","))
selec<-subset(datos2, select=selec)


if(deplog==TRUE){
logth<-paste("LN", varY, sep="")
selec1<-data.frame(datos2[,logth],selec)
colnames(selec1)<-c(logth,colnames(selec))
}
else{
selec1<-data.frame(datos2[,varY],selec)
colnames(selec1)<-c(varY,colnames(selec))
}

pairs(selec1, main=main,cex.main=cex.main, lower.panel=lower.panel, upper.panel=upper.panel,
cex =cex, pch =pch, bg=bg, diag.panel=diag.panel, cex.labels = cex.labels, font.labels=font.labels)
}

#Contribution of each variable
dimd<-dim(datos2)
Contr<-"No estimated"
if(CoVa==TRUE){
if(dimd[2]>3){

begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[1,1]<-"Relative contribution of each variable (be patient)...."
ZZ[2,1]<-begin.times
ZZ[3,1]<-""
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)

imprel<-relaimpo::calc.relimp(reg,type=typeV,rela=rela)
boot <-relaimpo::boot.relimp(reg, b = b, type = typeV, rela = rela)
Contr<-relaimpo::booteval.relimp(boot)
dev.new()
plot(relaimpo::booteval.relimp(boot,sort=T), names.abbrev=names.abbrev, ylim=ylimV, main=mainV, cex.title=cex.title)

}
}



Resultados<-list("VIF FOR ALL VARIABLES", VIF1, 
"CONTRIBUTION OF VARIABLES ESTIMATED",
"BY USING HIERARCHICHAL PARTITIONING (I)",CT,
"VIF FOR SELECTED VARIABLES", VIF2,"VIF of model", VIFModel, "Normality", Lillie1, "Autocorrelation", DW1, "Homocedasticity",
BreuschPagan1, "Contribution of the variables", Contr,"MULTIPLE REGRESSION", Re1)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}




if(dec=="."){
write.csv(x=residuos,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = residuos,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(file.exists("threshold.txt")){
file.remove("threshold.txt")
}

if(file.exists("VIF_Created.txt")){
file.remove("VIF_Created.txt")
}


}
