XI6<-function(data, cat, var, resp, stepwise=TRUE, cart=TRUE,
minsplit=2, minbucket=2, cp=0.0001, surrogatestyle=0, type=0, extra=2,
varlen=0, ycompress= TRUE, main=NULL, cex.main=2, cex=1.2,
model="Model.rda", file1="Coefficients.csv", file2="Predictions.csv", 
na="NA", dec=",", row.names=FALSE, file="Output.txt"){


########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data

datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))
datos<-na.exclude(datosT)


#La otra clase
vector<-datos[,cat]
vector<-vector[!vector == resp] 
cod<-as.character(unique(vector))


#Crear variable binaria
varbin<-datos[,cat]
varbinaria<-ifelse(varbin==resp,1,0)

#nuevo conjunto de datos
datos4<-datos[ , -which(names(datos) %in% cat)]

datos3<-data.frame(varrespuesta=varbinaria,datos4)

colnames(datos3)<-c(cat,colnames(datos4))



#Modelo de regresin logstica.
leng<-length(var)
fo<-var[1]
for(i in 2:leng){
fo<-paste(fo,var[i],sep="+")
}

formula<-as.formula(paste(cat,"~",fo))
modelo<-glm(formula,family=binomial("logit"), data=datos3)

if(stepwise==TRUE){
modelo.2<-MASS::stepAIC(modelo, data=datos3)
}
else {
modelo.2<-modelo
}

ModelB<-modelo.2
save(ModelB,file=model)

Resumenmodelo<-(summary(modelo.2))

#Aciertos totales
pred1<-round(predict(modelo.2, type="response"))
prob2<-data.frame(datos3,pred1,pred1)
colnames(prob2)<-c(colnames(datos3),"Probability","Predictions")

dimty<-dim(prob2)
for(i in 1:dimty[1]){
if(prob2[i,"Probability"]>0.4999){
prob2[i, "Predictions"]<-1
}
else{
prob2[i, "Predictions"]<-0
}
}
prctacierto<-sum(prob2[,cat]==prob2[,"Predictions"])/ dim(prob2)[1]*100


#Aciertos grupo referencia
datos1<-subset(datos3, datos3[,cat]==1)
pred1<-round(predict(modelo.2, type="response", newdata=datos1))
prob2<-data.frame(datos1,pred1,pred1)

colnames(prob2)<-c(colnames(datos1),"Probability","Predictions")
dimty<-dim(prob2)
for(i in 1:dimty[1]){
if(prob2[i,"Probability"]>0.4999){
prob2[i, "Predictions"]<-1
}
else{
prob2[i, "Predictions"]<-0
}
}
prctacierto1<-sum(prob2[,cat]==prob2[,"Predictions"])/ dim(prob2)[1]*100

#Aciertos grupo no referencia
datos1<-subset(datos3, datos3[,cat]==0)
pred1<-round(predict(modelo.2, type="response", newdata=datos1))
prob2<-data.frame(datos1,pred1,pred1)
colnames(prob2)<-c(colnames(datos1),"Probability","Predictions")
dimty<-dim(prob2)
for(i in 1:dimty[1]){
if(prob2[i,"Probability"]>0.4999){
prob2[i, "Predictions"]<-1
}
else{
prob2[i, "Predictions"]<-0
}
}
prctacierto0<-sum(prob2[,cat]==prob2[,"Predictions"])/ dim(prob2)[1]*100

resultadocls<-c("Percentage of cases correctly identified: All cases",prctacierto)

resultadocls1<-c(paste("Percentage of cases correctly identified:",cat,resp,collapse=""),prctacierto1)

resultadocls0<-c(paste("Percentage of cases correctly identified:",cat, cod,collapse=""),prctacierto0)


########################################################
# Seccin que muestra los resultados
########################################################

coef<-as.data.frame(modelo.2$coefficients)

coef<-data.frame(Variables=rownames(coef), coef)

colnames(coef)<-c("Variables","Coefficients")

prob<-(predict(modelo.2, type="response"))

prob2<-data.frame(datos,prob,prob)

colnames(prob2)<-c(colnames(datos),"Probability","Predictions")

dimty<-dim(prob2)


for(i in 1:dimty[1]){
if(prob2[i,"Probability"]>0.4999){
prob2[i, "Predictions"]<-as.character(resp)
}
else{
prob2[i, "Predictions"]<-cod
}


}

if(cart==TRUE){
leng<-length(var)
fo<-var[1]
for(i in 2:leng){
fo<-paste(fo,var[i],sep="+")
}
formula<-as.formula(paste(cat,"~",fo))

CART<- rpart::rpart(formula,method="class",control=rpart::rpart.control(minsplit=minsplit, minbucket =minbucket,
cp = cp, surrogatestyle = surrogatestyle), data=datos)

rpart.plot::rpart.plot(CART,type=type, extra=extra, varlen=varlen, ycompress=ycompress, main=main, cex.main=cex.main,cex=cex)
}


print(Resumenmodelo)
print(resultadocls)
print(resultadocls1)
print(resultadocls0)


if(dec=="."){
write.csv(x=coef,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef,file = file1, fileEncoding = "", row.names=row.names,na=na)
}


if(dec=="."){
write.csv(x=prob2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = prob2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}


if(!is.null(file)){
sink(file)
 print(Resumenmodelo)
 print(resultadocls)
 print(resultadocls1)
 print(resultadocls0)
sink()
}

}
