XIII3<-function(data, var, cat=NULL, ellipse=FALSE, convex=FALSE, dim=c(1,2), ResetPAR=TRUE, PAR=NULL,
METAMDS=NULL, SCATTERPLOT=NULL, COLOR=NULL,
PCH=NULL, XLIM=NULL, YLIM=NULL,  XLAB=NULL, YLAB=NULL, TEXT=NULL, LEGEND=NULL, 
AXIS=NULL, MTEXT= NULL,  arrows=TRUE, larrow=0.95, colArrows="black",
file1="Var loadings.csv", file2="Cat loadings.csv", na="NA", dec=",", row.names=TRUE){



datos<-data

datosT<-data.frame(subset(datos, select=var))


if(!is.null(cat)){
datosT<-data.frame(subset(datos, select=cat), datosT)
}

datos<-na.exclude(datosT)

if(!is.null(cat)){
datos[,1]<-as.character(datos[,1])
}

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


datos1<-data.frame(subset(datos, select=var))

if(!is.null(METAMDS)){
metaexe<-paste("vegan::metaMDS(","comm=datos1,", toString(x=METAMDS), ")")
datos.mds<-eval(parse(text=metaexe))
}
else{
metaexe<-paste("vegan::metaMDS(","comm=datos1,","k=6", ")")
datos.mds<-eval(parse(text=metaexe))
}

if(!is.null(cat)){
datos2<-data.frame(datos[,cat],datos.mds$points)
colnames(datos2)<-c("Group",colnames(datos.mds$points))
}
else{
datos2<-data.frame(datos.mds$points)
colnames(datos2)<-colnames(datos.mds$points)
}

if(!is.null(cat)){
datos2<-datos2[order(datos2[,1]), ]
}

if(!is.null(XLIM)){
Xmin<-XLIM[1]
Xmax<-XLIM[2]
}
else{

if(!is.na(datos.mds$species)){
Xmax<-max(datos.mds$points[,dim[1]], datos.mds$species[,dim[1]])
Xmin<-min(datos.mds$points[,dim[1]], datos.mds$species[,dim[1]])
}
else{
Xmax<-max(datos.mds$points[,dim[1]])
Xmin<-min(datos.mds$points[,dim[1]])
}

}

if(!is.null(YLIM)){
Ymin<-YLIM[1]
Ymax<-YLIM[2]
}
else{

if(!is.na(datos.mds$species)){
Ymin<-min(datos.mds$points[,dim[2]], datos.mds$species[,dim[2]])
Ymax<-max(datos.mds$points[,dim[2]], datos.mds$species[,dim[2]])
}
else{
Ymin<-min(datos.mds$points[,dim[2]])
Ymax<-max(datos.mds$points[,dim[2]])
}

}





if(!is.null(COLOR)){
color1<-COLOR
}
else{
if(!is.null(cat)){
if(convex==TRUE) color1<-rainbow(length(unique(datos2[,"Group"])), alpha=0.4) else color1<-rainbow(length(unique(datos2[,"Group"])))
}
else{
color1<-"black"
}
}
if(!is.null(cat)){
catn<-length(unique(datos2[,"Group"]))
}

if(!is.null(cat)){
pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}
}
else{
pch1<-15
}

if(!is.null(PCH)) pcht<-PCH else pcht<-pch1


if(!is.null(XLAB)){
xlab=XLAB
}
else{
xlab=paste("MDS",dim[1])
}

if(!is.null(YLAB)){
ylab=YLAB
}
else{
ylab=paste("MDS",dim[2])
}


if(!is.null(cat)){
by=TRUE
if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(","x=datos2[,dim[1]+1],","y=datos2[,dim[2]+1],","group=datos2[,'Group'],",   toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(","x=datos2[,dim[1]+1],","y=datos2[,dim[2]+1],","group=datos2[,'Group'],", "regLine=FALSE,",
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),",
"boxplots=FALSE,", "by.groups=by,", "ellipse=ellipse,", "col=color1,", "pch=pcht,",
"xlab=xlab,","ylab=ylab,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}
}
else{
by=FALSE
if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(","x=datos2[,dim[1]],","y=datos2[,dim[2]],", toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(","x=datos2[,dim[1]],","y=datos2[,dim[2]],", "regLine=FALSE,",
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),",
"boxplots=FALSE,", "by.groups=by,", "ellipse=ellipse,", "col=color1,", "pch=pcht,",
"xlab=xlab,","ylab=ylab,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}

}

if(!is.null(cat)){
if(convex==TRUE){
dati<-as.character(unique(datos2[,1]))
for(zz in 1:catn){
datis<-subset(datos2,(Group == dati[zz]))
hpts <- chull(x=datis[,dim[1]+1], y=datis[,dim[2]+1])
hpts <- c(hpts, hpts[1])
datiss<-datis[hpts,]
polygon(datiss[,dim[1]+1],datiss[,dim[2]+1], col=color1[zz], border=NA)
}
}
}

if(!is.null(cat)) num<-0 else num<-1

if(!is.na(datos.mds$species)){
if(!is.null(TEXT)){
textexe<-paste("text(","x=datos.mds$species[,dim[1]],", "y=datos.mds$species[,dim[2]]," ,"labels = colnames(datos1),", toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=datos.mds$species[,dim[1]],", "y=datos.mds$species[,dim[2]]," ,"labels = colnames(datos1),",
"xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),", "col='black',","cex=1", ")")
eval(parse(text=textexe))
}
}

meanx<-(Xmin+Xmax)/2
meany<-(Ymin+Ymax)/2

minar<-min((Ymax-Ymin),(Xmax-Xmin))/4

dima<-length(colnames(datos1))



if(arrows==TRUE){
for(aa in 1:dima){

x2<-datos.mds$species[aa, dim[1]]*larrow
y2<-datos.mds$species[aa, dim[2]]*larrow

IDPmisc::Arrows(x1=meanx, y1=meany, x2=x2, y2=y2, h.col=colArrows, sh.col=colArrows, h.col.bo=colArrows, open=FALSE)




}#END BUCLE arrows


}#END arrows TRUE


Resultados<-list("Stress", datos.mds$stress)

print(Resultados)

if(!is.null(cat)){
if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=unique(datos2[,1]),", "bty='n',", "col=color1,",
"pch=pcht", ")")
eval(parse(text=legendexe))
}
}



if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}


colnames(datos2)<-c(cat,colnames(datos.mds$points))

if(dec=="."){
write.csv(x= datos2,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos2 ,file = file1, fileEncoding = "", row.names=row.names,na=na)
}

if(!is.na(datos.mds$species)){
if(dec=="."){
write.csv(x= datos.mds$species,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos.mds$species ,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}


}
