XIII4<-function(data, varX,  varY,  labels=NULL, labelsvar="varX", log=FALSE,
dim=c(1,2), expand=TRUE, ellipse=FALSE, convex=FALSE, ResetPAR=TRUE,
PAR=NULL, CANCOR=NULL, SCATTERPLOT=NULL, COLOR=NULL, PCH=NULL,
XLIM=NULL, YLIM=NULL,  XLAB=NULL, YLAB=NULL, TEXTX=NULL,
TEXTY=NULL, LEGEND=NULL, AXIS=NULL, MTEXT= NULL, arrows=TRUE,
larrow=0.95, colAX="black", colAY="blue", file1="Output.txt", file2="xcoef.csv", file3="ycoef.csv",
file4="xscores.csv", file5="yscores.csv", na="NA", dec=",", row.names=TRUE){



if(is.null(labels) & (ellipse==TRUE | convex==TRUE)) {
stop("It is necessary to specify the labels")
}


datos<-data

datosT<-data.frame(subset(datos, select=varX), subset(datos, select=varY))

if(log==TRUE){
dimT<-dim(datosT)
for(i in 1:dimT[2]){
datosT[,i]<-log(datosT[,i]-(min(datosT[,i], na.rm=TRUE)-1))
}
}

if(!is.null(labels)){
datosT<-data.frame(subset(datos, select=labels), datosT)
lenf1<-length(unique(datos[,labels]))
}

datos<-na.exclude(datosT)

if(!is.null(labels)){
datos[,1]<-as.character(datos[,1])
}

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

#Correlacin cannica

if(!is.null(CANCOR)){
cancorexe<-paste("candisc::cancor(","x=datos[,varX],","y=datos[,varY],", toString(x=CANCOR), ")")
res<-eval(parse(text=cancorexe))
}
else{
cancorexe<-paste("candisc::cancor(","x=datos[,varX],","y=datos[,varY]", ")")
res<-eval(parse(text=cancorexe))
}


Resultados<-list("CANONICAL CORRELATIONS", res,"OBSERVED WEIGHTS",
res$weights, "STRUCTURE CORRELATIONS", res$structure)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}

yy<-res$coef$Y[,dim]
xx<-res$coef$X[,dim]

sxx<-res$scores$X[,dim]
syy<-res$scores$Y[,dim]


Xmax<-max(xx[,1],yy[,1], syy[,1])
Xmin<-min(xx[,1],yy[,1], syy[,1])
Ymin<-min(xx[,2],yy[,2], syy[,2])
Ymax<-max(xx[,2],yy[,2], syy[,2])

if(labelsvar=="varX"){
Xmax<-max(xx[,1],yy[,1], sxx[,1])
Xmin<-min(xx[,1],yy[,1], sxx[,1])
Ymin<-min(xx[,2],yy[,2], sxx[,2])
Ymax<-max(xx[,2],yy[,2], sxx[,2])
}



facX1<-((Xmax-Xmin)/(max(xx[,1])-min(xx[,1])))/2
facX2<-((Ymax-Ymin)/(max(xx[,2])-min(xx[,2])))/2

facY1<-((Xmax-Xmin)/(max(yy[,1])-min(yy[,1])))/2
facY2<-((Ymax-Ymin)/(max(yy[,2])-min(yy[,2])))/2

facsX1<-((Xmax-Xmin)/(max(sxx[,1])-min(sxx[,1])))/2
facsX2<-((Ymax-Ymin)/(max(sxx[,2])-min(sxx[,2])))/2

facsY1<-((Xmax-Xmin)/(max(syy[,1])-min(syy[,1])))/2
facsY2<-((Ymax-Ymin)/(max(syy[,2])-min(syy[,2])))/2


conX1<-xx[,1]*(facX1)
conX2<-xx[,2]*(facX2)

conY1<-yy[,1]*(facY1)
conY2<-yy[,2]*(facY2)

consX1<-sxx[,1]*(facsX1)
consX2<-sxx[,2]*(facsX2)

consY1<-syy[,1]*(facsY1)
consY2<-syy[,2]*(facsY2)

if(expand==TRUE) xx[,1]<-conX1 else xx[,1]<-xx[,1]
if(expand==TRUE) xx[,2]<-conX2 else xx[,2]<-xx[,2]

if(expand==TRUE) yy[,1]<-conY1 else yy[,1]<-yy[,1]
if(expand==TRUE) yy[,2]<-conY2 else yy[,2]<-yy[,2]

if(expand==TRUE) sxx[,1]<-consX1 else sxx[,1]<-sxx[,1]
if(expand==TRUE) sxx[,2]<-consX2 else sxx[,2]<-sxx[,2]

if(expand==TRUE) syy[,1]<-consY1 else syy[,1]<-syy[,1]
if(expand==TRUE) syy[,2]<-consY2 else syy[,2]<-syy[,2]

Xmax<-max(xx[,1],yy[,1], syy[,1])
Xmin<-min(xx[,1],yy[,1], syy[,1])
Ymin<-min(xx[,2],yy[,2], syy[,2])
Ymax<-max(xx[,2],yy[,2], syy[,2])

if(labelsvar=="varX"){
Xmax<-max(xx[,1],yy[,1], sxx[,1])
Xmin<-min(xx[,1],yy[,1], sxx[,1])
Ymin<-min(xx[,2],yy[,2], sxx[,2])
Ymax<-max(xx[,2],yy[,2], sxx[,2])
}



if(!is.null(XLAB)){
xlab=XLAB
}
else{
xlab=paste("CC",dim[1])
}

if(!is.null(YLAB)){
ylab=YLAB
}
else{
ylab=paste("CC",dim[2])
}


if(!is.null(XLIM)){
Xmax<-XLIM[2]
Xmin<-XLIM[1]
}

if(!is.null(YLIM)){
Ymax<-YLIM[2]
Ymin<-YLIM[1]
}

pcht<-PCH
color1<-COLOR

if(labelsvar=="varX") datos2<-sxx else datos2<-syy
colnames(datos2)<-c("A1","A2")

if(!is.null(labels)){
if(labelsvar=="varX") datos2<-data.frame(datos[,labels],sxx) else datos2<-data.frame(datos[,labels],syy)
colnames(datos2)<-c("Group","A1","A2")

if(!is.null(COLOR)){
color1<-COLOR
}
else{
if(convex==TRUE) color1<-rainbow(length(unique(datos2[,"Group"])), alpha=0.4) else color1<-rainbow(length(unique(datos2[,"Group"])))
}

catn<-length(unique(datos2[,"Group"]))

pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}

if(!is.null(PCH)) pcht<-PCH else pcht<-pch1
}



if(!is.null(labels)) formula<-"A2~A1 | Group," else formula<-"A2~A1,"


if(!is.null(labels)){
lrt<-length(color1)
dif<-lenf1-lrt

if(dif>0){
for(pp in 1:dif){
color1<-append(color1,color1[lrt])
pcht<-append(pcht,pcht[lrt])
}

}
}

if(is.null(labels) & is.null(COLOR)){
color1<-"black"
}


if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(",formula, "data=datos2,", toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(",formula, "data=datos2,", "regLine=FALSE,",
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),",
"boxplots=FALSE,", "by.groups=TRUE,", "ellipse=ellipse,", "col=color1,", "pch=pcht,",
"xlab=xlab,","ylab=ylab,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}


if(!is.null(labels)){
if(convex==TRUE){
dati<-as.character(unique(datos2[,1]))
for(zz in 1:catn){
datis<-subset(datos2,(Group == dati[zz]))
hpts <- chull(x=datis[,"A1"], y=datis[,"A2"])
hpts <- c(hpts, hpts[1])
datiss<-datis[hpts,]
polygon(datiss[,2],datiss[,3], col=color1[zz], border=NA)
}
}
}

if(!is.null(labels)){
if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=unique(datos2[,1]),", "bty='n',", "col=color1,",
"pch=pcht", ")")
eval(parse(text=legendexe))
}
}


if(!is.null(TEXTX)){
textexe<-paste("text(","x=xx[,1],", "y=xx[,2]," ,"labels = rownames(xx),", toString(x=TEXTX), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=xx[,1],", "y=xx[,2]," ,"labels = rownames(xx),",
"xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),", "col='black',","cex=1", ")")
eval(parse(text=textexe))
}



if(!is.null(TEXTY)){
textexe<-paste("text(","x=yy[,1],", "y=yy[,2]," ,"labels = rownames(yy),", toString(x=TEXTY), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=yy[,1],", "y=yy[,2]," ,"labels = rownames(yy),",
"xlim=c(Xmin,Xmax),", "ylim=c(Ymin,Ymax),", "col='blue',","cex=1", ")")
eval(parse(text=textexe))
}


meanx<-(Xmin+Xmax)/2
meany<-(Ymin+Ymax)/2

minar<-min((Ymax-Ymin),(Xmax-Xmin))/4
dimX<-length(varX)
minar<-min((Ymax-Ymin),(Xmax-Xmin))/4
dimX<-length(varX)
dimY<-length(varY)

if(arrows==TRUE){
for(aa in 1:dimX){

x2<-xx[aa, 1]*larrow
y2<-xx[aa, 2]*larrow
IDPmisc::Arrows(x1=meanx, y1=meany, x2=x2, y2=y2, h.col=colAX, sh.col=colAX, h.col.bo=colAX,open=FALSE)


}#END BUCLE arrows X

for(aa in 1:dimY){

x2<-yy[aa, 1]*larrow
y2<-yy[aa, 2]*larrow

IDPmisc::Arrows(x1=meanx, y1=meany, x2=x2, y2=y2, h.col=colAY, sh.col=colAY, h.col.bo=colAY, open=FALSE)


}#END BUCLE arrows Y

}#END arrows TRUE



if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}





if(dec=="."){
write.csv(x=res$coef$X,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = res$coef$X,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(dec=="."){
write.csv(x=res$coef$Y,file = file3, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = res$coef$Y,file = file3, fileEncoding = "", row.names=row.names,na=na)

if(dec=="."){
write.csv(x=res$scoresf$X,file = file4, fileEncoding = "", row.names=FALSE,na=na)
}
else{
write.csv2(x = res$scores$X,file = file4, fileEncoding = "", row.names=FALSE,na=na)
}

if(dec=="."){
write.csv(x=res$scoresf$Y,file = file5, fileEncoding = "", row.names=FALSE,na=na)
}
else{
write.csv2(x = res$scores$Y,file = file5, fileEncoding = "", row.names=FALSE,na=na)
}

}


}
