XIV3<-function(data, cat, var, labels=NULL, dimS=c(1,2), ResetPAR=TRUE, PAR=NULL,
DAPC=NULL, SCATTERDAPC=NULL, COLOR=NULL,TEXT=NULL,
LEGEND=NULL, AXIS=NULL, MTEXT= NULL,  file="Output.txt"){



###############################################
#Seccin que realiza el procedimiento
###############################################


datos<-data

if(!is.null(labels)){
datosT<-data.frame(subset(datos, select=cat), subset(datos, select=labels),subset(datos, select=var))
}
else{
datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))
}

datos<-na.exclude(datosT)

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2), cex.lab=1.5)
}


if(!is.null(COLOR)){
color1<-COLOR
}
else{
color1<-rainbow(length(unique(datos[,cat])))
}



if(!is.null(DAPC)){
dapcexe<-paste("adegenet::dapc(","x=datos[,var],","grp=datos[,cat],", toString(x=DAPC), ")")
dapc1<-eval(parse(text=dapcexe))
}
else{
dapcexe<-paste("adegenet::dapc(","x=datos[,var],","grp=datos[,cat],","n.pca=60,","n.da=30", ")")
dapc1<-eval(parse(text=dapcexe))
}



if(!is.null(SCATTERDAPC)){
dapcexe<-paste("adegenet::scatter.dapc(","x=dapc1,","xax=dimS[1],","yax=dimS[2],", toString(x=SCATTERDAPC), ")")
eval(parse(text=dapcexe))
}
else{
dapcexe<-paste("adegenet::scatter.dapc(","x=dapc1,","xax=dimS[1],","yax=dimS[2],","col=color1,",
"solid=1,", "scree.da=FALSE,", "scree.pca=FALSE,", "legend=TRUE,","posi.leg='topright',",
"cex.lab=2,", "labels=NULL",  ")")
eval(parse(text=dapcexe))
}


if(!is.null(labels)){
if(!is.null(TEXT)){
textexe<-paste("text(","x=dapc1$ind.coord[,dimS[1]],", "y=dapc1$ind.coord[,dimS[2]]," ,"labels = datos[,labels],", toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=dapc1$ind.coord[,dimS[1]],", "y=dapc1$ind.coord[,dimS[2]]," ,"labels = datos[,labels],",
"pos=4,","str=0", ")")
eval(parse(text=textexe))
}
}



if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

Resultados<-list("Matrix of retained principal components of PCA", dapc1$tab,
"Proportion of variance conserved by PCA principal components", dapc1$var,
"Principal axes of DAPC, giving coefficients of the linear combination of retained PCA axes", dapc1$loadings,
"Coordinates of cases onto discriminant functions", dapc1$ind.coord, 
"Coordinates of groups onto discriminant functions", dapc1$grp.coord,
"A data.frame giving posterior membership probabilities for all cases and all clusters", dapc1$posterior,
"A factor giving posterior group assignment", dapc1$assign,
"Contribution of variables to PCA principal components", dapc1$pca.loadings,
"Variance explained by each PCA principal components", dapc1$pca.eig,
"Contribution of variables to discriminant functions", dapc1$var.contr)



print(Resultados)


if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

}
