XV1<-function(data, varY,  varX=NULL, frequency, start, order=NULL, seasonal=NULL,
ResetPAR=TRUE, PAR=NULL,  TS=NULL, PLOTFORECAST1=NULL,
PLOTFORECAST2=NULL, TSDISPLAY=NULL, NDIFFS=NULL, ARIMA=NULL, 
AUTOARIMA=NULL, FORECAST=NULL, LINES=NULL, SEASONPLOT=NULL,
file="Output.txt"){



########################################################
# Seccin que realiza el procedimiento
########################################################


datos<-data

if(!is.null(varX)){
datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))
datos<-datosT
}
else{
datosT<-data.frame(subset(datos, select=varY))
datos<-datosT
}

if (missing(start)) start=1 else start=start
if (missing(frequency)) frequency=1 else frequency=frequency


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}


if(!is.null(TS)){
tsexe<-paste("ts(","data=datos,","frequency=frequency,","start=start,",toString(x=TS), ")")
serie1<-eval(parse(text=tsexe))
}
else{
tsexe<-paste("ts(","data=datos,","frequency=frequency,","start=start",")")
serie1<-eval(parse(text=tsexe))
}

serie1 <- zoo::na.approx(serie1)

devi<-as.numeric(length(dev.list()))

if(devi<=1) asss<-1 else dev.new()


if(!is.null(varX)){
if(!is.null(PLOTFORECAST1)){
plotexe<-paste("plot(","x=serie1,",toString(x=PLOTFORECAST1), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot(","x=serie1,","main=''",")")
eval(parse(text=plotexe))
}

dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}
}#end varX


if(!is.null(TSDISPLAY)){
plotexe<-paste("forecast::tsdisplay(","x=serie1[,1],",toString(x=TSDISPLAY), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::tsdisplay(","x=serie1[,1],","main=''",")")
eval(parse(text=plotexe))
}

#Stationary/non-stationary time series


if(!is.null(NDIFFS)){
plotexe<-paste("forecast::ndiffs(","x=serie1[,1],",toString(x=NDIFFS), ")")
ndiffs<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::ndiffs(","x=serie1[,1]",")")
ndiffs<-eval(parse(text=plotexe))
}

#Augmented Dickey-Fuller test (ADF)
adf<-tseries::adf.test(serie1[,1], alternative="explosive")

if(!is.null(order)){
if(!is.null(varX)){
if(!is.null(ARIMA)){
plotexe<-paste("forecast::Arima(","y=serie1[,1],", "order=order,", "seasonal=seasonal,", "xreg =serie1[,varX],", toString(x=ARIMA), ")")
t1<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::Arima(","y=serie1[,1],", "order=order,", "seasonal=seasonal,", "xreg =serie1[,varX]", ")")
t1<-eval(parse(text=plotexe))
}
}
else{
if(!is.null(ARIMA)){
plotexe<-paste("forecast::Arima(","y=serie1[,1],", "order=order,", "seasonal=seasonal,",  toString(x=ARIMA), ")")
t1<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::Arima(","y=serie1[,1],","order=order,", "seasonal=seasonal", ")")
t1<-eval(parse(text=plotexe))
}
}
}#primer order
else{
if(!is.null(varX)){
if(!is.null(AUTOARIMA)){
plotexe<-paste("forecast::auto.arima(","y=serie1[,1],", "stepwise=TRUE,", "xreg =serie1[,varX],", toString(x=AUTOARIMA), ")")
t1<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::auto.arima(","y=serie1[,1],", "stepwise=TRUE,", "xreg =serie1[,varX]", ")")
t1<-eval(parse(text=plotexe))
}
}
else{
if(!is.null(AUTOARIMA)){
plotexe<-paste("forecast::auto.arima(","y=serie1[,1],", "stepwise=TRUE,", toString(x=AUTOARIMA), ")")
t1<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::auto.arima(","y=serie1[,1],", "stepwise=TRUE", ")")
t1<-eval(parse(text=plotexe))
}
}
}#end order

if(!is.null(varX)){
if(!is.null(order)){
if(!is.null(FORECAST)){
plotexe<-paste("forecast::forecast(","object=t1,", "xreg=t1$xreg,", toString(x=FORECAST), ")")
forecast<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::forecast(","object=t1,", "xreg=t1$xreg", ")")
forecast<-eval(parse(text=plotexe))
}
}
else{
if(!is.null(FORECAST)){
plotexe<-paste("forecast::forecast(","object=t1,", "xreg=t1$xreg,", toString(x=FORECAST), ")")
forecast<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::forecast(","object=t1,", "xreg=t1$xreg", ")")
forecast<-eval(parse(text=plotexe))
}
}
}

else{
if(!is.null(order)){
if(!is.null(FORECAST)){
plotexe<-paste("forecast::forecast(","object=t1,", toString(x=FORECAST), ")")
forecast<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::forecast(","object=t1", ")")
forecast<-eval(parse(text=plotexe))
}
}
else{
if(!is.null(FORECAST)){
plotexe<-paste("forecast::forecast(","object=t1,", toString(x=FORECAST), ")")
forecast<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::forecast(","object=t1", ")")
forecast<-eval(parse(text=plotexe))
}
}

}



dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}



if(!is.null(PLOTFORECAST2)){
plotexe<-paste("plot(","x=forecast,",toString(x=PLOTFORECAST2), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot(","x=forecast,", "shaded=TRUE,","main='Predictions'",")")
eval(parse(text=plotexe))
}

if(!is.null(LINES)){
plotexe<-paste("lines(","x=serie1[,1]-t1$residuals,",toString(x=LINES), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("lines(","x=serie1[,1]-t1$residuals,","col='blue'",")")
eval(parse(text=plotexe))
}



dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

tsdiag(t1)

box<-Box.test(t1$resid, 12, type="Ljung")

residshapiro<-length(residuals(t1))
if(3 < residshapiro & residshapiro <5000){
Shapiro<-shapiro.test(residuals(t1))
}
else{
Shapiro<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}

Lillie<-nortest::lillie.test(residuals(t1))

#Desestacionalizacin


if(frequency>1){
dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}


if(!is.null(SEASONPLOT)){
plotexe<-paste("forecast::seasonplot(","x=serie1[,1],",toString(x=SEASONPLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("forecast::seasonplot(","x=serie1[,1],","main='Seasonal plot'",")")
eval(parse(text=plotexe))
}



dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

s3 <- zoo::na.approx(serie1[,1])
plot(forecast::seasadj(decompose(s3,"multiplicative")), main="Seasonally adjusted", ylab="")

}

Resultados<-list("SERIE", serie1, "STATIONARY/NON-STATIONARY TIME SERIES:","d VALUE", ndiffs, adf,"ARIMA MODEL", t1,
"PREDICTIONS OF ARIMA MODEL", forecast, "Box-Ljung TEST", box, "NORMALITY", "Shapiro-Wilk TEST", Shapiro,
"Kolmogorov-Smirnov TEST WITH Lilliefors CORRECTION", Lillie)



print(Resultados)


if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

}
