XV9<-function(data, var, cat=NULL, varCode=NULL,  remove=FALSE,
Nan=FALSE, quant = 0.95,   file="Outliers.csv",  na="NA", dec=",", row.names=FALSE){


#Selection of data
datosT<-subset(data, select=var)



if(!is.null(cat)){
datosT<-data.frame(datosT, subset(data, select=cat))
}

if(!is.null(varCode)){
datosT<-data.frame(datosT, subset(data, select=varCode))
varCode<-append(varCode,var)
}
else{
varCode<-var
}

datos<-na.exclude(datosT)

####Mahalanobis distance

datos1<-subset(datos, select=var)

md<-mahalanobis(datos1,colMeans(datos1),cov(datos1))

nombres<-names(datos)
datos<-data.frame(datos, md)
names(datos)<-c(nombres,"Mahalanobis")


####Q-Q plot

if(is.null(cat)){

dimvar<-dim(datos)
seq<-seq(1,dimvar[1],1)
chi<-qchisq((seq-0.5)/dimvar[1], df=length(var))

lenchiz<-length(chi)

orden<-datos[order(datos[,"Mahalanobis"]),]

par(mar=c(5,5,2,2))
plot(chi,orden[,"Mahalanobis"], ylab=expression(paste("Mahalanobis ", "D"^"2")), xlab=expression(paste("Quantiles of ",chi^"2")), cex.lab=1.5)

segments(chi[1],chi[1], chi[lenchiz], chi[lenchiz], lty=2)

StatR::XV7(data=orden, var="Mahalanobis", cat=cat, varCode=varCode,  remove=FALSE,
Nan=FALSE, quant1=0, quant2 = quant,   file=file,  na=na, dec=dec, row.names=row.names)

if(dec=="."){
temp<-read.csv(file, dec=dec)
}
else{
temp<-read.csv2(file,dec=dec)
}

out<-(which(temp[,"Mahalanobis"]==-9999))

points(chi[out], orden[out,"Mahalanobis"], pch=16, col="red")

}#End null cat

if(!is.null(cat)){
categ<-as.character(unique(datos[,cat]))
lencat<-length(categ)

div<-ceiling(lencat/2)
if(div>5){
div<-5
}
ini<-ceiling(lencat/div)
par(mfrow=c(ini,div), mar=c(5,5,2,2))


for(hh in 1:lencat){

datos1<-subset(datos,(datos[,cat] == categ[hh]))

datos1<-subset(datos1, select=var)

md<-mahalanobis(datos1,colMeans(datos1),cov(datos1))

nombres<-names(datos1)
datos1<-data.frame(datos1, md)
names(datos1)<-c(nombres,"Mahalanobis")

dimvar<-dim(datos1)
seq<-seq(1,dimvar[1],1)
chi<-qchisq((seq-0.5)/dimvar[1], df=length(var))

lenchiz<-length(chi)

orden<-datos1[order(datos1[,"Mahalanobis"]),]
plot(chi,orden[,"Mahalanobis"], ylab= expression(paste("Mahalanobis ", "D"^"2")), xlab=expression(paste("Quantiles of ",chi^"2")),
cex.lab=1.5, main=categ[hh], font.main=2, cex.main=1.7)

segments(chi[1],chi[1], chi[lenchiz], chi[lenchiz], lty=2)

StatR::XV7(data=orden, var="Mahalanobis", cat=NULL, varCode=NULL,  remove=FALSE,
Nan=FALSE, quant1=0, quant2 = quant,   file=file,  na=na, dec=dec, row.names=row.names)

if(dec=="."){
temp<-read.csv(file, dec=dec)
}
else{
temp<-read.csv2(file,dec=dec)
}

out<-(which(temp[,"Mahalanobis"]==-9999))

points(chi[out], orden[out,"Mahalanobis"], pch=16, col="red")


if(hh==1) Mahalanobis<-md else Mahalanobis<-append(Mahalanobis,md)


}


datos[,"Mahalanobis"]<-Mahalanobis

}####End not NULL cat


####Save Outliers

varCode<-append(varCode,"Mahalanobis")



Outliers<-datos[,"Mahalanobis"]
datos<-data.frame(datos,Outliers)

StatR::XV7(data=datos, var="Outliers", cat=cat, varCode=varCode,  remove=remove,
Nan=Nan, quant1=0, quant2 = quant,   file=file,  na=na, dec=dec, row.names=row.names)


}