\name{III2}
\alias{III2}
\encoding{latin1}
\title{DISTRIBUCION BINOMIAL}
\description{Calculate the probability of a Binomial Distribution.} 
\usage{
III2(n=NULL, x=NULL, p=NULL, option=1)
}
\arguments{
  \item{n}{Total number of individuals.}
  \item{x}{Number of individuals.}
  \item{p}{Probability of success.}
  \item{option}{
1. Exactly the probability p(X=x).

2. Probability that is greater or equal than p(X>=x).

3. Probability that is strictly greater p(X>x).

4. Probability that is less or equal than p(X<=x).

5. Probability that is strictly less p(X<x).}
}
\value{The probability value is obtained considering a Binomial Distribution.}
\details{
\strong{III. DISTRIBUTION}

\strong{III.3. DISTRIBUTIONS FOR DISCRETE VARIABLES}

\strong{III.3.1. Binomial distribution}

A variable has a binomial distribution when only two possible outcomes are possible: success and failure , being the probability of each of them constant in a series of repetitions, that is to say, nor the probability of success or failure of change from one test to another, and in addition each test result is independent of the outcome of the other tests. The probability of success is represented by \emph{p} and the probability of failure is represented by \emph{q} = 1 - \emph{p}.

Discrete variables instead of the density function use the function of probability or amount, giving a probability for each value of the variable. The binomial probability function is expressed by the following formula:

\deqn{f(x)=\frac{n!}{x!(n-x)!}p^xq^{n-x}}

\strong{EXAMPLES}

The application of a specific treatment to a group of individuals presenting a parasite provides an improvement in a 67 \% of the cases. If treatment is applied to 8 individuals:

The value of \emph{p} = 0.67 and, therefore, the value of \emph{q} is 0.33.

\strong{Case 1.} What is the probability that 7 individuals improve in a sample of 8?

\deqn{\frac{8!}{7!(8-7)!}0.67^70.33^{8-7}=0.16}

Result: 0.16

\strong{Case 2.} What is the probability that at least 3 individuals improved?

The probability that at least three individuals improve will be 1 minus the probability that two individuals improve minus the probability that one individual improves minus the probability that anyone improves:

\deqn{1-\frac{8!}{2!(8-2)!}0.67^20.33^{8-2}-\frac{8!}{1!(8-1)!}0.67^10.33^{8-1}-\frac{8!}{0!(8-0)!}0.67^00.33^{8-0}=0.981}

Result: 0.981
}
\examples{

#Case 1
III2(n=8, x=7, p=0.67, option=1)

#Case 2
1-III2(n=8, x=2, p=0.67, option=1)-III2(n=8, x=1, p=0.67, option=1)- III2(n=8,
x=0, p=0.67, option=1)

}
\keyword{III2}
