\name{III4}
\alias{III4}
\encoding{latin1}
\title{POISSON DISTRIBUTION}
\description{Calculate the probability of a Poisson distribution.} 
\usage{
  III4(lambda=NULL, x=NULL, option=1)
}
\arguments{
  \item{lambda}{Value of the lambda parameter.}
  \item{x}{Value on which the probability will be calculated.}
  \item{option}{
1. Exactly the probability of p(X=x).

2. Probability that is greater or equal than p(X>=x).

3. Probability that is strictly greater than p(X>x).

4. Probability that is less or equal than p(X<=x).

5. Probability that is strictly less than p(X<x).}
}
\value{The probability value is obtained considering a Poisson distribution.}
\details{
\strong{III. DISTRIBUTION}

\strong{III.3. DISTRIBUTIONS FOR DISCRETE VARIABLES}

\strong{III.3.3. Poisson Distribution}

A Poisson process is a process of independent events that is characterized by:


1. The number of events in two different intervals is always independent.

2. The probability of an event occurring in an infinitesimal interval is proportional to the length of the interval. 

3. The probability that more than one event occur in a very small interval \emph{h} is 0.

4. The events are expressed per unit of area, time, etc

The Poisson distribution describes the number of events in a time unit of a Poisson process. Many phenomena are modeled as a Poisson process, for example the number of accidents in a particular area of a road.

The most important differences with respect to the binomial distribution are that this distribution is applied to events that may have a very low probability and, in addition, the size of \emph{n} is infinite. In some cases the Poisson distribution is used as an approximation to the binomial when \emph{n} is very large and therefore, it is difficult to calculate the binomial and also when the probability of any of the events is very low. The probability function of the Poisson distribution is expressed by the following formula:

\deqn{f(x)=\frac{\lambda^x}{x!e^\lambda}}

where \eqn{\lambda} is the mean or average of events per unit of time and \emph{x} is the variable that indicates the number of events.

\strong{EXAMPLES}

\strong{Case 1.} The mean species abundance is 23 individuals per 100 \eqn{m^2}. As these are events per unit area a Poisson is used. What is the probability of not finding any individual in 25 \eqn{m^2}?

\deqn{\lambda=\frac{23individuals*25m^2}{100m^2}=5.75}

\deqn{\frac{5,75^0}{0!e^{5,75}}=0.0031}

Result: 0.0031

\strong{Case 2.} The mean number of observed tigers is 120 in 30 days. As these are events per unit time a Poisson is used. What is the probability of seeing 5 tigers in 10 days? 
\deqn{\lambda=\frac{120tigres*10d}{30d}=40}

\deqn{\frac{40^5}{5!e^{40}}=3.63^{-12}}

Result: \eqn{3.63^{-12}}
}
\examples{

#Case 1
III4(lambda=5.75, x=0, option=1)

#Case 2
III4(lambda=40, x=5, option=1)

}
\keyword{III4}
