\name{IX3}
\alias{IX3}
\encoding{latin1}
\title{ANALYSIS OF VARIANCE(ANOVA)}
\description{An analysis of variance is applied
and the data can be displayed with a boxplot or a beanplot.} 
\usage{
IX3(data, variables,  Factor1, Factor2=NULL, Factor3=NULL, Factor4=NULL,
SS=3, trans=NULL, ResetPAR=TRUE, mfrow=NULL, graph1="Boxplot",
PAR1=NULL, OrderCat1=NULL, LabelCat1=NULL, COLOR1=NULL, BOXPLOT1=NULL,
BEANPLOT1=NULL, LEGEND1=NULL, AXIS1=NULL, MTEXT1= NULL, TEXT1=NULL,
graph2="Boxplot", PAR2=NULL, OrderCat2=NULL, LabelCat2=NULL, COLOR2=NULL,
BOXPLOT2=NULL, BEANPLOT2=NULL, LEGEND2=NULL, AXIS2=NULL, MTEXT2= NULL,
TEXT2=NULL, graph3="Boxplot", PAR3=NULL, OrderCat3=NULL, LabelCat3=NULL,
COLOR3=NULL,BOXPLOT3=NULL, BEANPLOT3=NULL, LEGEND3=NULL, AXIS3=NULL,
MTEXT3= NULL, TEXT3=NULL, graph4="Boxplot", PAR4=NULL, OrderCat4=NULL,
LabelCat4=NULL, COLOR4=NULL,BOXPLOT4=NULL, BEANPLOT4=NULL, LEGEND4=NULL,
AXIS4=NULL, MTEXT4= NULL, TEXT4=NULL, INTPLOT1.2=TRUE, INTPLOT1.3=TRUE,
INTPLOT1.4=TRUE, INTPLOT2.3=TRUE, INTPLOT2.4=TRUE, INTPLOT3.4=TRUE,
INTERPLOT1.2=NULL, INTERPLOT1.3=NULL, INTERPLOT1.4=NULL, INTERPLOT2.3=NULL,
INTERPLOT2.4=NULL, INTERPLOT3.4=NULL,file="Output.txt")
}
\arguments{
  \item{data}{Data file.}
  \item{variables}{Dependent variable.}
  \item{Factor1}{First factor.}
  \item{Factor2}{Second factor.}
  \item{Factor3}{Third factor.}
  \item{Factor4}{Fourth factor.}
  \item{SS}{When there are several factors, the decomposition of the sum of squares in parts attributed to each one of the factors is not unique. Four types of sums of squares are commonly used: type I for nested models, type II for balanced models, type III for unbalanced models (also balanced), and type IV for models with empty boxes. The type III is suitable for most applications, so it will be the one used by default. This description is very simplified; interested readers should consult supplementary bibliography for a correct use of the ANOVA models.}
  \item{trans}{Type of transformation that is applied to the data:

1. NULL (untransformed)

2. 1/x2

3. 1/x

4. LN

5. LOG

6. SQR (square root)

7. x2

8. x3

9. EXP (exponential)

10. ASN (arcsine)
}
  \item{ResetPAR}{If FALSE the conditions are not placed by default in the \link{PAR} function and those defined by the user in previous graphics are kept.}
  \item{mfrow}{If it is NULL and there are various graphics, these appear in separate windows. If the graphics go into panels, this argument is a vector with the format c(nr, nc) indicating the number of figures per row (nr) and column (nc), by first filling the rows.}
  \item{graph1}{If NULL, the graphic of factor 1 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR1}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 1.}
  \item{OrderCat1}{It allows to specify a vector with the order in which the categories are shown in graph 1.}
  \item{LabelCat1}{It allows to specify a vector with the names of the categories of graph 1.}
  \item{COLOR1}{Vector with the color of the categories of graph 1.}
  \item{BOXPLOT1}{It allows to specify the characteristics of the boxplot of factor 1.}
  \item{BEANPLOT1}{It allows to specify the characteristics of the beanplot of factor 1.}
  \item{LEGEND1}{It allows to include a legend to the graph of factor 1.}
  \item{AXIS1}{It allows to add axes to the graph of factor 1.}
  \item{MTEXT1}{It allows to add texts on the margins of the graph of factor 1.}
  \item{TEXT1}{It allows to add text in any area of the inner part of the graph of factor 1.}
  \item{graph2}{If NULL, the graphic of factor 2 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR2}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 2.}
  \item{OrderCat2}{It allows to specify a vector with the order in which the categories are shown in graph 2.}
  \item{LabelCat2}{It allows to specify a vector with the names of the categories of graph 2.}
  \item{COLOR2}{Vector with the color of the categories of graph 2.}
  \item{BOXPLOT2}{It allows to specify the characteristics of the boxplot of factor 2.}
  \item{BEANPLOT2}{It allows to specify the characteristics of the beanplot of factor 2.}
  \item{LEGEND2}{It allows to include a legend to the graph of the factor 2.}
  \item{AXIS2}{It allows to add axes to the graph of the factor 2.}
  \item{MTEXT2}{It allows to add text in the margins of the graph of the factor 2.}
  \item{TEXT2}{It allows to add text in any area of the inner part of the graph of the factor 2.}
  \item{graph3}{If NULL, the graphic of factor 3 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR3}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 3.}
  \item{OrderCat3}{It allows to specify a vector with the order in which the categories are shown in graph 3.}
  \item{LabelCat3}{It allows to specify a vector with the names of the categories of graph 3.}
  \item{COLOR3}{Vector with the color of the categories of graph 3.}
  \item{BOXPLOT3}{It allows to specify the characteristics of the boxplot of factor 3.}
  \item{BEANPLOT3}{It allows to specify the characteristics of the beanplot of factor 3.}
  \item{LEGEND3}{It allows to include a legend to the graph of the factor 3.}
  \item{AXIS3}{It allows to add axes to the graph of the factor 3.}
  \item{MTEXT3}{It allows to add text in the margins of the graph of the factor 3.}
  \item{TEXT3}{It allows to add text in any area of the inner part of the graph of the factor 3.}
  \item{graph4}{If NULL, graphic factor 4 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR4}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 4.}
  \item{OrderCat4}{It allows to specify a vector with the order in which the categories are shown in graph 4.}
  \item{LabelCat4}{It allows to specify a vector with the names of the categories of graph 4.}
  \item{COLOR4}{Vector with the color of the categories of graph 4.}
  \item{BOXPLOT4}{It allows to specify the characteristics of the boxplot of factor 4.}
  \item{BEANPLOT4}{It allows to specify the characteristics of the beanplot of factor 4.}
  \item{LEGEND4}{It allows to include a legend to the graph of the factor 4.}
  \item{AXIS4}{It allows to add axes to the graph of the factor 4.}
  \item{MTEXT4}{It allows to add text in the margins of the graph of the factor 4.}
  \item{TEXT4}{It allows to add text in any area of the inner part of the graph of the factor 4.}
  \item{INTPLOT1.2}{If TRUE, it shows the graph of interaction of factor 1 with the factor 2.}
  \item{INTPLOT1.3}{If TRUE, it shows the graph of interaction of factor 1 with the factor 3.}
  \item{INTPLOT1.4}{If TRUE, it shows the graph of interaction of factor 1 with the factor 4.}
  \item{INTPLOT2.3}{If TRUE, it shows the graph of interaction of factor 2 with the factor 3.}
  \item{INTPLOT2.4}{If TRUE, it shows the graph of interaction of factor 2 with the factor 4.}
  \item{INTPLOT3.4}{If TRUE, it shows the graph of interaction of factor 3 with the factor 4.}
  \item{INTERPLOT1.2}{It allows to specify the characteristics of the graph of the interaction of factor 1 with factor 2.}
  \item{INTERPLOT1.3}{It allows to specify the characteristics  of the graph of the interaction of factor 1 with factor 3.}
  \item{INTERPLOT1.4}{It allows to specify the characteristics of the graph of the interaction of factor 1 with factor 4.}
  \item{INTERPLOT2.3}{It allows to specify the characteristics of the graph of the interaction of factor 2 with factor 3.}
  \item{INTERPLOT2.4}{It allows to specify the characteristics of the graph of the interaction of factor 2 with factor 4.}
  \item{INTERPLOT3.4}{It allows to specify the characteristics of the graph of the interaction of factor 3 with factor 4.}
  \item{file}{TXT FILE. Name of the output file with the results.}
}
\value{A TXT file with the results of the ANOVA is obtained, a boxplot or a beanplot for each factor can be displayed, in addition to displaying a graph of interaction between all the factors.}
\details{
\strong{IX. CONTRASTS OF HOMOGENEITY IN QUANTITATIVE VARIABLES}

\strong{IX.1.4. Analysis of variance (ANOVA)}

In general, when performing a research we wonder if our samples, we consider independent, belong to the same population. The values of samples commonly differ, the problem would be determining if in spite of these differences, populations are equal, and  if variations are due to random as a result of the randomness of our sampling.

The most used parametric test to verify if two or more sample means come from the same population is the analysis of variance(ANOVA). The ANOVA is a general method that can be extended to more than two samples and it can be demonstrated that this matches with the \emph{t} of Student if there are only two samples (Salvarrey, 2000; Azzimonti, 2003).

For the application of ANOVA it is necessary to comply with the following assumptions:

 The samples are random and are independent.

 There are no outliers in the dependent variable, which can be detected with the function \link{XV7} of StatR.

 The distribution of the population from which they were extracted is Normal.

 The variances are equal in each group or level of the factors considered. 

The ANOVA calculates the variation of means and estimates the "natural" population change or variation, and thus make a comparison between them. Natural variation is measured by the "intravarianza" or "error variance". If samples are from the same population, the variance of the means is the umpteenth part of the population variance. If that situation is ruled out, it is because, apart from random, something else makes samples different. If these differences are only due to random, the two variances corrected by its degrees of freedom are of the same order and its quotient is worth roughly 1. The ratio of corrected variances has distribution F, so it searches in the F-distribution tables if the obtained relations are acceptable as  close to 1 or not (Salvarrey, 2000).

The analysis of variance can be performed with a dependent variable (univariate ANOVA) or with multiple dependent variables (multivariate ANOVA or MANOVA).  It is also possible to perform the analysis of variance (ANOVA univariate) or with several factors (multifactorial ANOVA).

The so-called  univariate general linear model (MGL) performs a regression analysis and one of variance for a  dependent variable by means of one or more factors or independent variables (factors divide the population into groups). With this procedure the hypotheses about the effects of one or more variables (factors or treatments) on the average of a single dependent variable can be contrasted. This analysis requires that the dependent variable be quantitative and that the categorical factors may have numeric values or string (letters).

\strong{FUNCTIONS}

The function \link[nortest]{lillie.test}of the package nortest (Gross, 2013) is used to make Kolmogorov-Smirnov test for normality with the correction of Lilliefors. The function \link[stats]{shapiro.test} is used to perform the Shapiro-Wilk test, the linear model is done with the function \link[stats]{lm} and the chart of interaction with the function \link[stats]{interaction.plot}, the three of the base stats package. The ANOVA is done with the function \link[car]{Anova} of the package "car" (Fox et al., 2014). For the posthoc tests the function \link[multcomp]{glht} of the multcomp package is used (Hothorn et al. , 2014). For the beanplot, the function \link[beanplot]{beanplot} of the package beanplot is used (Kampstra, 2008;) Kampstra, 2013). The Levene test is done with the function \link[lawstat]{levene.test} of the package lawstat (Gastwirth et al., 2013). The asymmetry and kurtosis are performed with the functions \link[e1071]{skewness} and \link[e1071]{kurtosis}, respectively, of package e1071 (Meyer et al., 2014).

\strong{EXAMPLE}

Biometric data of two species of sharks (\emph{Scyliorhinus canicula} and \emph{Galeus melastomus}), which were taken by two researchers in four areas (two in the Mediterranean and two in the Atlantic).  The objective is to determine if there are significant differences in the length of the anal fin between species, areas and researchers.

In the script the argument \emph{mfrow=c(2,3)} to make a panel in which 6 graphics are put in 2 rows and 3 columns is specified.

Figure IX.4 shows the panel with the medium and distribution of the values of the length of the anal fin among species, researchers and areas, as well as the graphics of interaction between all factors.
\tabular{c}{
\strong{Figure IX.4.} Length of the anal fin among species, researchers\cr
and areas, in addition to the graphics of interaction between factors.\cr
\figure{FIX4}{options: width=5.5in}
}
The residuals fit a Normal distribution: Kolmogorov-Smirnov test with the Lilliefors correction (p = 0.345) and Shapiro-Wilk (p = 0.108), and there is homogeneity of variances for the factor 1 (p = 0.251), for the factor 2 (p = 0.777) and for the factor 3 (p = 0.084). Therefore, it is not necessary to transform the data. 
\tabular{c}{
\figure{RIX5-1}{options: width=4.5in}
}
\tabular{c}{
\figure{RIX5-2}{options: width=5.1in}
}
Despite considering the effect Researcher and Area, there are clear differences in the length of the anal fin among species (ANOVA, \eqn{F_{1,42}} = 35.6, p < 0.001). However, there are no significant differences between researchers (ANOVA, \eqn{F_{1, 42}}= 0.22, p = 0.638), i.e., there are no differences in criteria when taking the measurement. There are differences between zones (ANOVA, \eqn{F_{3, 42}}= 0.97, p = 0.417). The ANOVA table also shows the combined effect of the factors, considered as an additional factor which includes the possibility that - in addition to the effect of the species, researcher and the area, which added - appears another, which also adds to the previous ones, which is the interaction between them. It is noted that some interactions are significant, as Species*Researcher (ANOVA, \eqn{F_{1, 42}}= 7.73, p = 0.008). This is observed in the graph of interaction between the factors species and researcher (Figure IX.4, figure on the left of the second row), since the lines are not parallel, but intersect, which is indicating that the researcher 1 gets a larger size of anal fin for the species \emph{G. melastomus} than the researcher 2, while on the other hand, the researcher 2 gets a larger size of anal fin for the species \emph{S. canicula} than the researcher 1, that is to say, the researchers measured differently the species. However, an interaction should not be taken into account when one of the factors that comprise it are not significant, in this case, a researcher factor.
\tabular{c}{
\figure{RIX6}{options: width=4.5in}
}
As in the case of the factor Area there are 4 levels, this could lead to perform tests \emph{post hoc} to find out what are the different levels. However, it makes no sense to make comparisons with a factor that is not significant, because if a single comparison were significant, it would also be the factor. In any case R shows the \emph{post hoc} results of the Tukey test, even for those factors that have only 2 levels. By observing the Factor 3, which is the Area, as expected, it is noted that there are no significant differences when comparing each of the areas: area 2 with 1 (p = 0.986), area 3 with 1 (p = 0.919), area 4 with 1 (p = 0.952), area 3 with 2 (p = 0.595), area 4 with 2 (p = 0.703), and area 4 with 3 (p = 1).
\tabular{c}{
\figure{RIX7}{options: width=4.5in}
}
}
\references{
Azzimonti, J.C. (2003) \emph{Bioestadstica aplicada a Bioqumica y Farmacia}. Universidad Nacional de Misiones. Editorial Universitaria, Argentina.

Fox, J., Weisberg, S., Adler, D., Bates, D., Baud-Bovy, G., Ellison, S., Firth, D., Friendly, M., Gorjanc, G., Graves, S., Heiberger, R., Laboissiere, R., Monette, G., Murdoch, D., Nilsson, H., Ogle, D., Ripley, B., Venables, W. & Zeileis, A. (2014) Companion to Applied Regression. R package version 2.0-20. Available at: \url{http://CRAN.R-project.org/package=car}.

Gastwirth, J.L., Gel, Y.R., Hui, W.L.W., Lyubchich, V., Miao, W. & Noguchi, K. (2013).  An R package for biostatistics, public policy, and law. R package version 2.4.1. Available at: \url{http://CRAN.R-project.org/package=lawstat}.

Gross, J. (2013) Tests for Normality. R package version 1.0-2. Available at: \url{http://CRAN.R-project.org/package=nortest}.

Hothorn, T., Bretz, F., Westfall, P, Heiberger, R.M. & Schuetzenmeister, A. (2014) Simultaneous Inference in General Parametric Models. R package version 1.3-3. Available at: \url{http://CRAN.R-project.org/package=multcomp}.

Kampstra, P. (2008). Beanplot: A Boxplot Alternative for Visual Comparison of Distributions. \emph{Journal of Statistical Software, Code Snippets}, 28: 1-9.

Kampstra, P (2013) Visualization via Beanplots (like Boxplot/Stripchart/Violin Plot). R package version 1.1. Available at: \url{http://CRAN.R-project.org/package=beanplot}.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., Leisch, F., Chang, C.C. & Lin, C.C (2014) Misc Functions of the Department of Statistics (e1071), TU Wien. R package version 1.6-3. Available at: \url{http://CRAN.R-project.org/package=e1071}.

Salvarrey, L. (2000) \emph{Curso de estadstica bsica}. Universidad de la Repblica del Uruguay.
}
\examples{
\dontrun{

data(ZIX3)

#Comparison of the length of the anal fin between two shark species,
#measured by two researchers and in several sampling areas

IX3(data=ZIX3, variables="Anal.height", Factor1="Species", Factor2="Researcher",
Factor3="Area", mfrow=c(2,3))

}
}
\keyword{IX3}
