\name{IX4}
\alias{IX4}
\encoding{latin1}
\title{ANALYSIS OF COVARIANCE (ANCOVA)}
\description{An analysis of covariance with optional graphics is applied.} 
\usage{
IX4(data, variables,  Factor1, Factor2=NULL, Factor3=NULL, Covariable1,
Covariable2=NULL, Covariable3=NULL, Covariable4=NULL, SS=3, trans=NULL,
ResetPAR=TRUE, mfrow=NULL,  CEXPCH=1.3, graph1=TRUE, XLAB=NULL, YLAB=NULL,
PAR1=NULL, COLOR1=NULL, PCH1=NULL,  MAIN1=NULL, LEGEND1=NULL, AXIS1=NULL,
MTEXT1= NULL, TEXT1=NULL, graph2=TRUE, PAR2=NULL, COLOR2=NULL, PCH2 =NULL,
MAIN2=NULL, LEGEND2=NULL, AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL, graph3=TRUE,
PAR3=NULL, COLOR3=NULL,  PCH3=NULL, MAIN3=NULL, LEGEND3=NULL, AXIS3=NULL,
MTEXT3= NULL, TEXT3=NULL, INTPLOT1.2=TRUE, INTPLOT1.3=TRUE, INTPLOT2.3=TRUE,
INTERPLOT1.2=NULL, INTERPLOT1.3=NULL, INTERPLOT2.3=NULL, OrderCat1=NULL,
LabelCat1=NULL, OrderCat2=NULL, LabelCat2=NULL, file="Output.txt")
}
\arguments{
  \item{data}{Data file.}
  \item{variables}{Dependent variable.}
  \item{Factor1}{First factor.}
  \item{Factor2}{Second factor.}
  \item{Factor3}{Third factor.}
  \item{Covariable1}{First covariate.}
  \item{Covariable2}{Second covariate.}
  \item{Covariable3}{Third covariate.}
  \item{Covariable4}{Fourth covariate.}
  \item{SS}{When there are several factors, the decomposition of the sum of squares in parts attributed to each one of the factors is not unique. Four types of sums of squares are commonly used: type I for nested models, type II for balanced models, type III for unbalanced models (also balanced), and type IV for models with empty boxes. The type III is suitable for most applications, so it will be the one used by default. This description is very simplified; interested readers should consult supplementary bibliography for a correct use of the ANOVA with complex models.}
  \item{trans}{Type of transformation that is applied to the data:

1. NULL (untransformed)

2. 1/x2

3. 1/x

4. LN

5. LOG

6. SQR (square root)

7. x2

8. x3

9. EXP (exponential)

10. ASN (arcsine)
}
  \item{ResetPAR}{If FALSE the conditions are not placed by default in the \link{PAR} function and those defined by the user in previous graphics are kept.}
  \item{mfrow}{If it is NULL and there are various graphics, these appear in separate windows. If the graphics go into panels, this argument is a vector with the format c(nr, nc) indicating the number of figures per row (nr) and column (nc), by first filling the rows.}
  \item{CEXPCH}{Size of the graphic symbols.}
  \item{graph1}{If NULL, the graph of factor 1 is not performed with the covariate 1.}
  \item{XLAB}{Legend of the X axis.}
  \item{YLAB}{Legend of the Y axis.}
  \item{PAR1}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 1.}
  \item{COLOR1}{This allows to modify the colors of the graph 1, but should be as many different groups as the factor 1 has.}
  \item{PCH1}{Vector with the symbols of the graphic 1. If NULL, they are automatically calculated starting with the symbol 15.}
  \item{MAIN1}{Title of the graph of factor 1.}
  \item{LEGEND1}{It allows to modify the legend on the graph of factor 1.}
  \item{AXIS1}{It allows to add axes to the graph of factor 1.}
  \item{MTEXT1}{It allows to add texts on the margins of the graph of factor 1.}
  \item{TEXT1}{It allows to add text in any area of the inner part of the graph of factor 1.}
  \item{graph2}{If NULL, the graph of factor 2 is not performed with the covariate 1.}
  \item{PAR2}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 2.}
  \item{COLOR2}{This allows to modify the colors of the graph 2, but should be as many different groups as the factor 2 has.}
  \item{PCH2}{Vector with the symbols of graphic 2. If NULL, they are automatically calculated starting with the symbol 15.}
  \item{MAIN2}{Title of the graph of the factor 2.}
  \item{LEGEND2}{It allows to modify the legend on the graph of the factor 2.}
  \item{AXIS2}{It allows to add axes to the graph of the factor 2.}
  \item{MTEXT2}{It allows to add text in the margins of the graph of the factor 2.}
  \item{TEXT2}{It allows to add text in any area of the inner part of the graph of the factor 2.}
  \item{graph3}{If NULL, the graph of factor 3 is not performed with the covariate 1.}
  \item{PAR3}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 3.}
  \item{COLOR3}{This allows to modify the colors of the graph 3, but should be as many different groups as the factor 3 has.}
  \item{PCH3}{Vector with the symbols of graphic 3. If NULL, they are automatically calculated starting with the symbol 15.}
  \item{MAIN3}{Title of the graph of the factor 3.}
  \item{LEGEND3}{It allows to modify the legend on the graph of factor 3.}
  \item{AXIS3}{It allows to add axes to the graph of the factor 3.}
  \item{MTEXT3}{It allows to add text in the margins of the graph of the factor 3.}
  \item{TEXT3}{It allows to add text in any area of the inner part of the graph of the factor 3.}
  \item{INTPLOT1.2}{If TRUE, it shows the graph of interaction of factor 1 with the factor 2.}
  \item{INTPLOT1.3}{If TRUE, it shows the graph of interaction of factor 1 with the factor 3.}
  \item{INTPLOT2.3}{If TRUE, it shows the graph of interaction of factor 2 with the factor 3.}
  \item{INTERPLOT1.2}{It allows to specify the characteristics of the graph of the interaction of factor 1 with factor 2.}
  \item{INTERPLOT1.3}{It allows to specify the characteristics  of the graph of the interaction of factor 1 with factor 3.}
  \item{INTERPLOT2.3}{It allows to specify the characteristics of the graph of the interaction of factor 2 with factor 3.}
  \item{OrderCat1}{It allows to specify a vector with the order in which the categories of factor 1 are shown in the graph of interaction.}
  \item{LabelCat1}{It allows to specify a vector with the names of the categories of factor 1 in the graph of interaction.}
  \item{OrderCat2}{It allows to specify a vector with the order in which the categories of factor 2 are shown in the graph of interaction.}
  \item{LabelCat2}{It allows to specify a vector with the names of the categories of factor 2 in the graph of interaction.}
  \item{file}{TXT FILE. Name of the output file with the results.}
}
\value{A TXT file with the results of the ANOVA is obtained,  a graph for each factor with the covariate 1 can be displayed, as well as a graph of interaction of factor 1 with each of the other factors can also be shown.}
\details{
\strong{IX. CONTRASTS OF HOMOGENEITY IN QUANTITATIVE VARIABLES}

\strong{IX.1.5. Analysis of covariance (ANCOVA)}

The analysis of covariance (ANCOVA) is a statistical technique that aims to eliminate the effect of possible variables that can be related to the dependent variable.

To control these variables, a variance analysis is performed, in which the dependent variable is the error in the forecasts, or residual, performing a linear regression analysis with covariates as independent variables and the dependent variable is equal to that of our initial ANOVA.

In ANCOVA, the interpretation of the results, as in the ANOVA, was based on the effects of the factors on our dependent variables and the interactions among the factors studied. According to Steel & Torrie (1985) this analysis can be used for:

1.	Handling errors and increase the accuracy of our analysis.

2.	Adjusting the means of the dependent variables to the differences with the values of the independent variables used.

3.	Assist in the interpretation of our data, especially in regard to the nature of the effects of the treatments.

4.	Partitioning of a total covariance or sum of cross products in components.

5.	Estimating missing data.

In order to interpret an ANCOVA correctly, it is necessary to do the ANOVA first, i.e., do the analysis only taking into account the dependent variable and the factor(s), without considering the covariate(s).  This is due to the fact that the interpretation of the ANCOVA differs depending on whether the results obtained in the ANCOVA are the same or different from those obtained in the ANOVA.

In the ANCOVA any variable that does not have a significant effect can be eliminated from the analysis. If all the covariates used have no significant effects, the conclusions of the ANCOVA and ANOVA should be very similar.

If one or more covariates have significant effects, two situations can occur:

1.	The outcome of ANOVA and ANCOVA is the same. This means that the effect of factors on the dependent variable is not modified and, therefore, the possible effect of the(s) covariate(s) on the dependent variable does not affect the relationship of the latter with the factors.

2.	If the result of the ANOVA and ANCOVA is different, it can be due to two reasons:

2a. It may be because a significant ANOVA effect becomes insignificant and, thus, the effect detected in the ANOVA is due to the effect of the(s) covariate(s) and not to the(s) independent variable(s)(factors).

2b. It can also be because an insignificant effect ANOVA becomes significant, which indicates that the factor, even not being related to the dependent variable globally considered, correlates with the part of the dependent variable not explained or not attributable to the covariate(s).

\strong{FUNCTIONS}

The function \link[nortest]{lillie.test} of the nortest package (Gross, 2013) is used to perform the Normality test of Kolmogorov-Smirnov with Lilliefors' correction.

The function \link[stats]{shapiro.test} is used to perform the Shapiro-Wilk test, the linear model is performed with the function \link[stats]{lm} and the chart of interaction with the function \link[stats]{interaction.plot}, all three of the base stats package.

The ANCOVA is performed with the function \link[car]{Anova} of the car package (Fox et al., 2014). The Levene test is performed with the function \link[lawstat]{levene.test} package of the lawstat package (Gastwirth et al., 2013). The asymmetry and kurtosis are performed with the functions \link[e1071]{skewness} and \link[e1071]{kurtosis}, respectively, of the package e1071 (Meyer et al., 2014).

\strong{EXAMPLE}

This compares the length of the anal fin between two species of sharks, as measured by two researchers and in several areas of sampling considering the total length of the body as a covariate.

\strong{Step 1.}

Figure IX.5 shows the panel with the relationship between total length and the length of the anal fin, differentiating between species, researchers and the areas, as well as the graphics of interaction between factors.
 
First we note the normality of residuals and the homogeneity of variances. It is noted that both the Kolmogorov-Smirnov test with the correction of Lilliefors (p = 0.256 ) as the Shapiro-Wilk (p = 0.34 ) show values of p > 0.05 and, therefore, it is accepted the null hypothesis of goodness of fit and the residuals comply with a Normal distribution.

The Levene test, considering the median, shows that the homogeneity of variances for the factor 1 (p = 0.002), is not fulfilled, but is true for 2 factor (p = 0.725) and factor 3 (p = 0.623). Therefore, it is necessary to transform the data.
\tabular{c}{
\strong{Figure IX.5.} Relationship between the total length and the length of the fin between
\cr species, researchers and areas, along with the graphics of interaction between factors.\cr
\figure{FIX5}{options: width=4.3in}
}
\tabular{c}{
\figure{RIX8-1}{options: width=3.5in}
}
\tabular{c}{
\figure{RIX8-2}{options: width=3.5in}
}
\strong{Step 2.}

The analysis is repeated but transforming data with the \emph{trans="SQR"} argument. Now it is observed that both the Kolmogorov-Smirnov test with correction of Lilliefors (p = 0.576) as the Shapiro-Wilk test (p = 0.361) have values of p > 0.05 and, therefore, the null hypothesis of goodness of fit is accepted and and the residuals comply with a Normal distribution.

The Levene test, considering the median, shows that the homogeneity of variances for the factor 1 (p = 0.263), for the factor 2 (p = 0.202) and for the factor 3 (p = 0.159) is fulfilled.
\tabular{c}{
\figure{RIX9-1}{options: width=4.5in}
}
\tabular{c}{
\figure{RIX9-2}{options: width=4.5in}
}
The ANOVA table shows that there is a clear relationship between the total length and the length of the anal fin(ANCOVA, \eqn{F_{1, 41}} = 576.37, p < 0.001). By considering the effect of total length remain clear differences in the length of the anal fin between species (ANOVA, \eqn{F_{1, 41}} = 24.09, p < 0.001), but not among researchers  (ANOVA, \eqn{F_{1, 41}}= 1.44, p = 0.235) or between zones (ANOVA, \eqn{F_{3, 41}}= 1.06, p = 0.374).
\tabular{c}{
\figure{RIX10}{options: width=4.5in}
}
}
\references{
Fox, J., Weisberg, S., Adler, D., Bates, D., Baud-Bovy, G., Ellison, S., Firth, D., Friendly, M., Gorjanc, G., Graves, S., Heiberger, R., Laboissiere, R., Monette, G., Murdoch, D., Nilsson, H., Ogle, D., Ripley, B., Venables, W. & Zeileis, A. (2014) Companion to Applied Regression. R package version 2.0-20. Available at: \url{http://CRAN.R-project.org/package=car}.

Gastwirth, J.L., Gel, Y.R., Hui, W.L.W., Lyubchich, V., Miao, W. & Noguchi, K. (2013).  An R package for biostatistics, public policy, and law. R package version 2.4.1. Available at: \url{http://CRAN.R-project.org/package=lawstat}.

Gross, J. (2013) Tests for Normality. R package version 1.0-2. Available at: \url{http://CRAN.R-project.org/package=nortest}.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., Leisch, F., Chang, C.C. & Lin, C.C (2014) Misc Functions of the Department of Statistics (e1071), TU Wien. R package version 1.6-3. Available at: \url{http://CRAN.R-project.org/package=e1071}.

Steel, R.G.D. & Torrie, J.H. (1985) \emph{Bioestadstica: Principios y procedimientos}. McGraw-Hill, Bogot.
}
\examples{
\dontrun{

data(ZIX3)

#Step 1
#A single graph for each factor and interaction graph between factors

IX4(data=ZIX3,  variables="Anal.height", Factor1="Species",
Factor2="Researcher", Factor3="Area", Covariable1="Total.length")

#The 6 graphics are combined into one with mfrow, distances of
#margins are specified with PAR (mar =) and the color of graph 2 is changed

IX4(data=ZIX3,  variables="Anal.height", Factor1="Species",
Factor2="Researcher",
Factor3="Area", Covariable1="Total.length", mfrow=c(2,3), PAR1=c("mar=c(5,5,2,1)",
"font.lab=2", "cex.lab=1.5"), COLOR2= c("#00FFFFFF", "#FFFF00FF"))

#Step 2

IX4(data = ZIX3 , variables="Anal.height", Factor1="Species",
Factor2="Researcher",
Factor3="Area", Covariable1="Total.length", trans = "SQR", mfrow = c(2,3),
PAR1 = c("mar=c(5,5,2,1)", "font.lab=2", "cex.lab=1.5"), COLOR2=c("#00FFFFFF","#FFFF00FF"))

}
}
\keyword{IX4}
