\name{IX8}
\alias{IX8}
\encoding{latin1}
\title{NESTED ANOVA}
\description{A nested analysis of variance is applied and the data can be displayed with a boxplot or a  beanplot.} 
\usage{
IX8(data, variables, Factor1, CF1=NULL, Factor2, CF2=1, Factor3=NULL,
CF3=NULL, Factor4=NULL, CF4=NULL, combine=FALSE,  trans=NULL, ResetPAR=TRUE,
mfrow=NULL, graph1="Boxplot", PAR1=NULL,  OrderCat1=NULL, LabelCat1=NULL,
COLOR1=NULL, BOXPLOT1=NULL, BEANPLOT1=NULL, LEGEND1=NULL, AXIS1=NULL,
MTEXT1= NULL, TEXT1=NULL, graph2="Boxplot", PAR2=NULL, OrderCat2=NULL,
LabelCat2=NULL, COLOR2=NULL, BOXPLOT2=NULL, BEANPLOT2=NULL, LEGEND2=NULL,
AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL, graph3="Boxplot", PAR3=NULL,
OrderCat3=NULL, LabelCat3=NULL, COLOR3=NULL, BOXPLOT3=NULL, BEANPLOT3=NULL,
LEGEND3=NULL, AXIS3=NULL, MTEXT3= NULL, TEXT3=NULL, graph4="Boxplot",
PAR4=NULL, OrderCat4=NULL, LabelCat4=NULL, COLOR4=NULL, BOXPLOT4=NULL,
BEANPLOT4=NULL, LEGEND4=NULL, AXIS4=NULL, MTEXT4= NULL, TEXT4=NULL,
file="Output.txt")
}
\arguments{
  \item{data}{Data file.}
  \item{variables}{Dependent variable.}
  \item{Factor1}{First factor.}
  \item{CF1}{Factors of which the factor1 nests. If this factor does not nest any of them, it becomes NULL, which is the default option.}
  \item{Factor2}{Second factor.}
  \item{CF2}{Factors of which the factor2 nests. For example, a value of 1 would mean that nests the factor 1.}
  \item{Factor3}{Third factor.}
  \item{CF3}{Factors of which the factor3 nests. For example, a vector c(2,1) would mean that nests the factors 2 and 1. A value of 2 means that nests only the factor 2.}
  \item{Factor4}{Fourth factor.}
  \item{CF4}{Factors of which the factor4 nests. For example, a vector c(3,2,1) would mean that nests the factors 3, 2 and 1. A vector c(3,1) would mean that nests the factors 3 and 1.}
  \item{combine}{If TRUE, a graphic panel that combines factors is shown. However, if the number of combinations is greater than 12, then it automatically turns itself off and becomes FALSE.}
  \item{trans}{Type of transformation that is applied to the data:

1. NULL (Untransformed)

2. 1/x2

3. 1/x

4. LN

5. LOG

6. SQR (square root)

7. x2

8. x3

9. EXP (exponential)

10. ASN (arcsine)
}
  \item{ResetPAR}{If FALSE, the conditions are not placed by default in the function \link{PAR} and those defined by the user on previous graphs are maintained.}
  \item{mfrow}{If it is NULL and there are various graphics, these appear in separate windows. If the graphics go into panels, this argument is a vector with the format c(nr, nc) indicating the number of figures per row (nr) and column (nc), by first filling the rows.}
  \item{graph1}{If NULL, the graphic of factor 1 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR1}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 1.}
  \item{OrderCat1}{It allows to specify a vector with the order in which the categories of the graph 1 are shown.}
  \item{LabelCat1}{It allows to specify a vector with the names of the categories of the graph of the factor 1.}
  \item{COLOR1}{ A vector with the color of the categories of graph 1.}
  \item{BOXPLOT1}{It allows to specify the characteristics of the boxplot of the factor 1.}
  \item{BEANPLOT1}{It allows to specify the characteristics of the beanplot of the factor 1.}
  \item{LEGEND1}{It allows to include a legend to the graph of the factor 1.}
  \item{AXIS1}{It allows to add axes to the graph of the factor 1.}
  \item{MTEXT1}{It allows to add text in the margins of the factor 1.}
  \item{TEXT1}{It allows to add text in any area of the inner part of the graph of the factor 1.}
  \item{graph2}{If NULL, the graphic of factor 2 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR2}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 2.}
  \item{OrderCat2}{It allows to specify a vector with the order in which the categories of the graph 2 are shown.}
  \item{LabelCat2}{It allows to specify a vector with the names of the categories of the graph 2.}
  \item{COLOR2}{Vector with the color of the categories of graph 2.}
  \item{BOXPLOT2}{It allows to specify the characteristics of the boxplot of the factor 2.}
  \item{BEANPLOT2}{It allows to specify the characteristics of the beanplot of the factor 2.}
  \item{LEGEND2}{It allows to include a legend to the graph of the factor 2.}
  \item{AXIS2}{It allows to add axes to the graph of the factor 2.}
  \item{MTEXT2}{It allows to add text in the margins of the factor 2.}
  \item{TEXT2}{It allows to add text in any area of the inner part of the graph of the factor 2.}
  \item{graph3}{If NULL, the graphic of factor 3 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR3}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 3.}
  \item{OrderCat3}{It allows to specify a vector with the order in which the categories of the graph 3 are shown.}
  \item{LabelCat3}{It allows to specify a vector with the names of the categories of the graph 3.}
  \item{COLOR3}{Vector with the color of the categories of graph 3.}
  \item{BOXPLOT3}{It allows to specify the characteristics of the boxplot of the factor 3.}
  \item{BEANPLOT3}{It allows to specify the characteristics of the beanplot of the factor 3.}
  \item{LEGEND3}{It allows to include a legend to the graph of the factor 3.}
  \item{AXIS3}{It allows to add axes to the graph of the factor 3.}
  \item{MTEXT3}{It allows to add text in the margins of the factor 3.}
  \item{TEXT3}{It allows to add text in any area of the inner part of the graph of the factor 3.}
  \item{graph4}{If NULL, the graphic of factor 4 is not performed and the other options are "Boxplot" or "Beanplot".}
  \item{PAR4}{This accesses the function \link{PAR} which allows to modify many different aspects of the graph of the factor 4.}
  \item{OrderCat4}{It allows to specify a vector with the order in which the categories of the graph 4 are shown.}
  \item{LabelCat4}{It allows to specify a vector with the names of the categories of the graph 4.}
  \item{COLOR4}{Vector with the color of the categories of graph 4.}
  \item{BOXPLOT4}{It allows to specify the characteristics of the boxplot of the factor 4.}
  \item{BEANPLOT4}{It allows to specify the characteristics of the beanplot of the factor 4.}
  \item{LEGEND4}{It allows to include a legend to the graph of the factor 4.}
  \item{AXIS4}{It allows to add axes to the graph of the factor 4.}
  \item{MTEXT4}{It allows to add text in the margins of the factor 4.}
  \item{TEXT4}{It allows to add text in any area of the inner part of the graph of the factor 4.}
  \item{file}{TXT FILE. Output file name with the results.}
}
\value{A TXT file is obtained with the results of the nested ANOVA and a boxplot or beanplot can be represented for each factor or perform a combination of factors.}
\details{
\strong{IX. CONTRASTS OF HOMOGENEITY IN QUANTITATIVE VARIABLES}

\strong{IX.1.8. Nested ANOVA}

The nested ANOVA is an experimental design in which the levels of one or more factors are dependent on the levels of other factors.  It is an extension of a one-way ANOVA, which divides each group into subgroups. It is said that a factor B is nested in another factor (or that their levels are nested in the (A) when all levels of the factor B are associated with a single level of factor A. This is denoted as B included in A. It is possible to have multiple nested factors in the experimental design, i.e., having groups, subgroups for each group, sub-subgroups for each subgroup, etc.

Nested Analysis of Variance has a null hypothesis for each factor. In a two-way nested ANOVA, a null hypothesis would be that the subgroups within each group have the same media, the second null hypothesis would be that groups have the same mean. Nested ANOVA requirements are equal to those of the ANOVA, i.e., it is required that waste will have Normal distribution and homogeneity of variances.

An example of a nested ANOVA is planting a tree species in three different habitats, for example, in the valley, on the slope of the mountain and in the high mountain, and repeat this experimental design in two different areas, for example, an area that is a natural park and, therefore, there is a degree of protection, and another area which does not have any type of control. The objective would be to determine if there are variations in the rate of tree growth (dependent variable) between the two areas (primary factor), and between the habitats within each zone (nested secondary factor).

In another example, it is assumed that you are testing the null hypothesis if monkeys under stress and not subjected to stress have the same amount of antibodies. As the monkeys occupy much space, it is necessary to take them in four different rooms and in each one of them there are monkeys of the two types, those who have been subjected and has not subjected to stress.

It may be the case that the conditions of the rooms (light, temperature, etc. ) can cause some differences in the level of stress and, therefore, perhaps in the level of antibodies.
To eliminate this potential effect of the different rooms in the experimental design, a nested ANOVA in which the first factor would be the rooms (with four levels, the 4 rooms) and nested factor would be the level of stress of the monkeys (with two levels, stress and not stressed) should be performed. With this design it can be observed if there are differences in the amount of antibodies (dependent variable) between rooms and in the amount of antibodies in the group of stressed and unstressed monkeys in each room.

In addition to reporting any differences in means between the levels of each factor, in means between each subfactor level within each factor, etc., the nested ANOVA is very useful for future experimental designs because it indicates the degree of variability within each factor.

For example, imagine that the levels of glycogen in various types of muscles in rats subjected and not subjected to stress are measured. Therefore, the muscle factor would be nested within the stress factor and the dependent variable would be the level of glycogen. It may be the case that the variability between muscle glycogen content is very small, while among rats is high. Therefore, in the next design, the effort should be focused on measuring glycogen in a greater number of rats and only in a muscle within each rat, that is to say, it would no longer be necessary a nested ANOVA as this would be a single factor, the level of stress to which the rats are subjected.

\strong{FUNCTIONS}

The function \link[nortest]{lillie.test} of the package nortest (Gross, 2013) is used to perform the Normality test of Kolmogorov-Smirnov with Lilliefors' correction.

The function \link[stats]{shapiro.test} of the package base stats is used to perform the Shapiro-Wilk test. The ANOVA is performed with the function \link[car]{Anova} of the package car (Fox et al., 2014). For the beanplot the function \link[beanplot]{beanplot} of the package beanplot (Kampstra, 2008; Kampstra, 2013)is used.

The Levene test is performed with the function \link[lawstat]{levene.test} of the packagelawstat (Gastwirth et al., 2013). The asymmetry and the kurtosis  are carried out with the functions \link[e1071]{skewness} and \link[e1071]{kurtosis}, respectively, of the package e1071 (Meyer et al., 2014).

\strong{EXAMPLE 1}

\strong{Step 1.}

Lichens are organisms considered as bioindicators of pollution, since it has been demonstrated that their presence is often lower in most polluted areas.

The data used in the example is the average of lichen species found in two species of tree, \emph{Populus alba} (White poplar) and \emph{Aesculus hippocastanum} (Buckeye), in three cities in Spain (Madrid, Barcelona and Seville), in three types of environments (low, medium and high levels of air pollution) and also showing the researcher who performed the counting of species, by whether this data could be affected depending on the person performing the sampling. The average is the result of counting the lichen species in 40 trees of each species (\emph{Populus alba} and \emph{Aesculus hippocastanum}), in each of the cities, in the three types of environments and and for each of the researchers.

The objective is to determine if the number of lichen species varies depending on the researcher, who recounts. As the number of species of lichens may be affected by the species of tree and/or the degree of pollution of the cities, it is necessary to perform a nested ANOVA.

The most important thing in a nested ANOVA is to nest the factors in a correct way. In this study, the factor 1 (City) is not nest and, therefore, the default conditions are left \emph{CF1=NULL}. Factor 2 (Species) is nested in 1 \emph{CF2=1}.  Factor 3 is nested in factors 2 and 1 \emph{CF3=c(2,1)}. Finally, the researcher factor is nested in the previous three \emph{CF4=c(3,2,1)}.  

Figure IX.9 shows the mean and range of the richness of lichens for each of the categories of the factors analyzed. It is noted that richness is higher in Barcelona and Seville, and lower in Madrid. There is more richness in the species \emph{Aesculus hippocastanum} than in \emph{Populus alba}, although it is necessary to check if the differences are significant. It is clear that the richness decreases with increasing pollution and, in principle, the two researchers made a recount of similar species of lichens.
\tabular{c}{
\strong{Figure IX.9.} Panel showing the average and range of the richness of lichens\cr
between cities, species, degree of contamination and between researchers.\cr
\figure{FIX9}{options: width=5.5in}
}
First, the normality of the residuals is taken into account. It is noted that both the Kolmogorov-Smirnov test with the correction of Lilliefors (p = 0.775), as the Shapiro-Wilk (p = 0.615) show p > 0.05 and, therefore, the residuals comply with a Normal distribution.
\tabular{c}{
\figure{RIX14}{options: width=4.3in}
}
The Levene test considering the median shows that it also meets the homogeneity of variances (p > 0.05) for almost factors, with the exception of the factor 3 (contamination).  Therefore, it is necessary to perform a transformation.
\tabular{c}{
\figure{RIX15}{options: width=5.2in}
}
\strong{Step 2.}

The data is transformed using the square root of the argument \emph{trans = "SQR"}. It is noted that both the Kolmogorov-Smirnov test with the correction of Lilliefors (p = 0.308), 
as the Shapiro-Wilk (p = 0.501) show p > 0.05 and, therefore, the residuals comply with a Normal distribution.
\tabular{c}{
\figure{RIX15-1}
}
In addition, there is homogeneity of variances in all factors, as p > 0.05.
\tabular{c}{
\figure{RIX15-2}
}
\tabular{c}{
\figure{RIX15-3}{options: width=5.2in}
}
The ANOVA results are shown in the following table. There are significant differences between the cities in the number of species of lichens (ANOVA, \eqn{F_{2,130}}= 15.42, p < 0.001), 
and also between the two species of trees (ANOVA, \eqn{F_{3, 130}}= 3.17, p = 0.026). 
There are clear differences in the number of species of lichens observed depending on the degree of contamination (ANOVA, \eqn{F_{12,130}}= 39.343, p < 0.001). In regard to the purpose of the example, the two researchers conducted a count of lichens such as there are no significant differences between them (ANOVA, \eqn{F_{18,30}}= 1.45, p = 0.117).
\tabular{c}{
\figure{RIX16}{options: width=5.2in}
}
\strong{EXAMPLE 2}

In the second example this only works with three factors to determine if the wealth of lichens varies depending on the degree of pollution, thus excluding research factor. 

In addition there is another nesting assumption, in such a way that the factor 2 (species) is nestled in 1 \emph{CF2=1}, but factor 3 only nests the 2 and not the 1 \emph{CF3=2}. 

The argument \emph{combine=TRUE}, which means that a graphical panel that combines the factors (Figure IX.10) is carried out automatically. As the third factor is the pollution, 
which is shown on the X axis of all graphs and combined with each of the categories of the other factors.
 
As the third factor which is combined with other factors, all changes must be made at the level of this third factor. For example, changing the order of the categories with the
argument \emph{OrderCat3=c("Low","Medium","High")}, or modifications to the graph with the argument \emph{PAR3}. 
It is possible that the error. \emph{figure margins too large}, in which case the graph window is maximized and the 
script is run again.
\tabular{c}{
\strong{Figure IX.10.} Panel showing the average and range of the richness of lichens\cr
for each level of pollution combined with categories of other factors.\cr
\cr
\figure{FIX10}{options: width=5.5in}
}
First we look at the normality of the residuals. It is noted that both the Kolmogorov-Smirnov test with Lilliefors correction (p = 0.421), as the Shapiro-Wilk (p = 0.4) shows p > 0.05 and, therefore, the residuals comply with a normal distribution. 
\tabular{c}{
\figure{RIX17}{options: width=5.3in}
}
The Levene test considering the median shows that also meets the homogeneity of variances (p > 0.05) for all factors. Therefore, it is not necessary to transform the data.
\tabular{c}{
\figure{RIX18}{options: width=5.3in}
}
The results of the ANOVA are shown in the following table. There are significant differences between the cities in the number of species of lichens (ANOVA, \eqn{F_{2,156}}= 13.19, p < 0.001), but not between the two species of trees considering the situation in which is nested in the factor city (ANOVA, \eqn{F_{2,156}}= 2.09, p = 0.127). In regard to the purpose of the example, there are significant differences in the observed number of species of lichens depending on the degree of contamination (ANOVA, \eqn{F_{4,156}}= 94.347, p < 0.001).
\tabular{c}{
\figure{RIX19}{options: width=5.4in}
} 

\strong{EXAMPLE 3}

Working with two factors in the last script(Figure IX.11).
\tabular{c}{
\cr
\strong{Figure IX.11.} Panel showing the average and range of the richness of lichens\cr
for each level of pollution combined with the species.\cr
\figure{FIX11}{options: width=5.5in}
}
}
\references{
Fox, J., Weisberg, S., Adler, D., Bates, D., Baud-Bovy, G., Ellison, S., Firth, D., Friendly, M., Gorjanc, G., Graves, S., Heiberger, R., Laboissiere, R., Monette, G., Murdoch, D., Nilsson, H., Ogle, D., Ripley, B., Venables, W. & Zeileis, A. (2014) Companion to Applied Regression. R package version 2.0-20. Available at: \url{http://CRAN.R-project.org/package=car}.

Gastwirth, J.L., Gel, Y.R., Hui, W.L.W., Lyubchich, V., Miao, W. & Noguchi, K. (2013).  An R package for biostatistics, public policy, and law. R package version 2.4.1. Available at: \url{http://CRAN.R-project.org/package=lawstat}.

Gross, J. (2013) Tests for Normality. R package version 1.0-2. Available at: \url{http://CRAN.R-project.org/package=nortest}.

Kampstra, P. (2008). Beanplot: A Boxplot Alternative for Visual Comparison of Distributions. \emph{Journal of Statistical Software, Code Snippets}, 28: 1-9.

Kampstra, P (2013) Visualization via Beanplots (like Boxplot/Stripchart/Violin Plot). R package version 1.1. Available at: \url{http://CRAN.R-project.org/package=beanplot}.

Meyer, D., Dimitriadou, E., Hornik, K., Weingessel, A., Leisch, F., Chang, C.C. & Lin, C.C (2014) Misc Functions of the Department of Statistics (e1071), TU Wien. R package version 1.6-3. Available at: \url{http://CRAN.R-project.org/package=e1071}.
}
\examples{
\dontrun{

data(ZIX6)

#Case 1. Four factors

#Step 1

IX8(data = ZIX6 , variables = "Richness", Factor1 = "City", Factor2 = "Species",
CF2=1, Factor3 = "Contamination", CF3=c(2,1), Factor4 = "Researcher",
CF4=c(3,2,1), mfrow = c(1,4) , PAR1 = c("mar=c(5,5,3,2)", "font.lab=2",
"cex.lab=1.5","cex.axis=1.7"), OrderCat3 = c("Low","Medium","High"))


#Step 2. Data are transformed

IX8(data = ZIX6 , variables = "Richness", Factor1 = "City", Factor2 = "Species",
CF2=1, Factor3 = "Contamination", CF3=c(2,1), Factor4 = "Researcher",
CF4=c(3,2,1), mfrow = c(1,4), PAR1 = c("mar=c(5,5,3,2)", "font.lab=2",
"cex.lab=1.5","cex.axis=1.7"), OrderCat3 = c("Low","Medium","High"), trans = "SQR")

#Case 2.. Three factors (It is necessary a large monitor to
#view the plot)

windows(16,8)

IX8(data=ZIX6, variables="Richness",   Factor1 = "City", Factor2 = "Species",
CF2=1, Factor3 = "Contamination", CF3=2, combine=TRUE, OrderCat3=c("Low", "Medium","High"),
PAR3 = c("mar=c(5,5,3,2)","font.lab=2", "cex.lab=1.7") )

#Case 3. Two factors

IX8(data=ZIX6, variables="Richness", Factor1= "Species",
Factor2="Contamination",
CF2=1, combine=TRUE, OrderCat3=c("Low", "Medium","High"), PAR3 =c("mar=c(5,5,3,2)",
"font.lab=2", "cex.lab=1.7"))
}
}
\keyword{IX8}
