\name{PAR}
\alias{PAR}
\encoding{latin1}
\title{PAR FUNCTION}
\description{This function allows to modify graphs.} 
\usage{
PAR(adj=0.5, ann=TRUE, bg=NULL, bty="o", cex.axis=1, cex.lab=1, cex.main=1,
cex.sub=1, col.axis="black", col.lab="black", col.main="black",
col.sub="black", family="Arial", fg="black", font.axis=1, font.lab=1,
font.main=2, font.sub=1, lab=c(5,5,7), las=0, lend=0, lty= 1, lwd=1, mai=NULL,
mar=NULL, mex=NULL, mgp=c(3,3,0), oma=NULL, omd=NULL, omi=NULL, pch=NULL,
ps=NULL, pty="m", tck=NA, tcl=NA, xaxp=NULL, xaxs="r", xaxt="s", yaxp=NULL,
yaxs="r", yaxt="s")
}
\arguments{
  \item{adj}{It specifies the alignment of the text in graphics. It can take any value between 0 (text to the left) and 1 (text to the right).}
  \item{ann}{If you select FALSE, the legends of the axes and the titles of the graphics are removed when used with the function \link{plot.default}.}
  \item{bg}{Background color of the graph.}
  \item{bty}{It defines the type of the graphics frame:

"o" (full frame)

"c" (the right edge is not shown)

"u" (the upper edge is not shown)

"l" (the top and right edges are not shown)

"7" (left and bottom edges are not shown)

"]" (the left edge is not shown).}
  \item{cex.axis}{Size of the axis labels.}
  \item{cex.lab}{Size of the text of the legends.}
  \item{cex.main}{Size of the graph title text.}
  \item{cex.sub}{Size of the text in the subtitle.}
  \item{col.axis}{It defines the color of the axis labels.}
  \item{col.lab}{It defines the color of the text of legends.}
  \item{col.main}{It defines the color of the text of the title of the graph.}
  \item{col.sub}{It defines the color of the text in the subtitle.}
  \item{family}{It specifies the font of the text.}
  \item{fg}{It defines the frame color and lines of the graph.}
  \item{font.axis}{A numeric value that defines the font of the axis labels. The value 1 is a normal type, 2 is written in bold, 3 is written in italics and 4 is written in italics and bold.}
  \item{font.lab}{A numeric value that defines the font of the legends. The value 1 is a normal type, 2 is written in bold, 3 is written in italics and 4 is written in italics and
bold.}
  \item{font.main}{A numeric value that defines the font of the title of the graph. The value 1 is a normal type, 2 is written in bold, 3 is written in italics and 4 is written in italics and
bold.}
  \item{font.sub}{A numeric value that defines the font of the subtitle of the graph. The value 1 is a normal type, 2 is written in bold, 3 is written in italics and 4 is written in italics and bold.}
  \item{lab}{A numeric value with the format c(x,y,len) that defines the number of axis divisions. The value of len must be specified but R does not use it.}
  \item{las}{It defines the position of the axis labels: 0 is parallel to the shaft, 1 is horizontal, 2 is perpendicular, and 3 is vertical.}
  \item{lend}{It defines the style of the end of the line and it can be specified with a number or letters:

0 or "round" is a rounded end.

1 or "butt" is a thick end.

2 or "square" is a square end.}
  \item{lty}{It defines the type of line:

0 No line.

1 Solid line.

2 Dashed line.

3 Dotted line.

4 Line of dots and dashes.

5 Dash line.

6 Double stripe.}
  \item{lwd}{It defines the line width.}
  \item{mai}{A numeric vector with the format c(down, left, up, right) that defines the margins of the figure in inches.}
  \item{mar}{A numeric vector with the format c(down, left, up, right) that defines the lines of the margins of the figure.}
  \item{mex}{Expansion factor of the size of characters on the margins.}
  \item{mgp}{A numeric vector with the format c(t, e, l) that specifies the position of the legend of the axes (t), the text of the divisions of the axes (e) and the line of axis (l). The default value is (3,1,0).}
  \item{oma}{A numeric vector with the format c(down, left, up, right) that defines the margins of the text in the panel, in number of lines.}
  \item{omd}{A numeric vector with the format c(x1,x2,y1,y2) that defines the internal margins where the graph will be located on a scale from 0 to 1.}
  \item{omi}{A numeric vector with the format c(down, left, up, right) that defines the margins of the panel in inches.}
  \item{pch}{Numeric value between 1 and 25 that defines the type of symbol (the symbol that corresponds to each number is shown in the table below).  It is also possible to put ""
between any character, as shown in the table with a, *, !,  y $.}
  \item{ps}{Text point size (unit of measurement of the characters) in 1/72 inches.}
  \item{pty}{Character that indicates whether the graph is square or stretches laterally when the window is enlarged. With "s" produces a square figure and with "m" the graph is extended to the maximum extent possible.}
  \item{tck}{String value that defines the size of the marks on the axes, in proportion to the area of the region of the figure. A value of 1 puts inner lines in the graph. With tck = NA it leaves the mark by default.}
  \item{tcl}{String value that defines the size of the marks on the axes. It differs from \emph{tc} in which the measures are real and not in proportion. With \emph{tcl=NA} leaves the mark by default.}
  \item{xaxp}{Numeric vector with the format c(x1, x2, n), where x1 and x2 are the ends of the marks of x-axis, and n is the number of intervals or marks on the shaft.}
  \item{xaxs}{"r" (regular) extends 4\% more than the limits given in xlim, and calculates the number of intervals that best fit those limits, and "i" (internal) seeks most appropriate number of intervals to the original data.}
  \item{xaxt}{Logical value that specifies whether to represent the intervals of the x-axis, with the options "s" or "n".}
  \item{yaxp}{Vector numeric format c (x1, x2, n), where x1 and x2 are the extremes axis marks Y, and n the number of intervals or marks on the shaft.}
  \item{yaxs}{r" (regular) extends 4\% more than the limits given in ylim, and calculates the number of intervals that best fit those limits, and "i" (internal) seeks most appropriate number of intervals to the original data.}
  \item{yaxt}{Logical value that specifies whether to represent the intervals of the y-axis, with the options "s" or "n".}
}
\keyword{PAR}
