\name{XI7}
\alias{XI7}
\encoding{latin1}
\title{BINOMIAL LOGISTIC REGRESSION-PREDICTION}
\description{It allows to calculate the category to which a case belongs, being able to carry out the calculation for many cases at the same time, using a logistic regression model estimated with the binomial function \link{XI6}.}
\usage{
XI7(data, cat, resp, model="Model.rda", file="Model predictions.csv",
na="NA", dec=",", row.names=FALSE)
}
\arguments{
  \item{data}{Data file.}
  \item{cat}{Dependent variable.}
  \item{resp}{Category that will be the reference for the dependent variable.}
  \item{model}{The file name with the estimated model using the function \link{XI6}}
  \item{file}{CSV FILE. Filename with the predictions of the binomial logistic model, for each case.}
    \item{na}{CSV FILE. Text that is used in the cells without data.}
  \item{dec}{CSV FILE. It defines whether the comma "," or dot "." are used as decimal separators.}
  \item{row.names}{CSV FILE. Logical value which defines whether there are identifiers on the rows or a vector with a text for each of the rows.}
}
\value{A CSV file is obtained with the predictions of the logistic model for each case.}  
\details{
\strong{XI.2.1. Logistic regression}

\emph{XI.2.1.1. Binomial Logistic Regression}

XI.2.1.1.2. Prediction of the model 

The percentage of cases correctly identified is an important parameter to evaluate the quality of the logistic regression model. However, a better parameter to evaluate the quality of the model is to check the degree of success using some data that had not been included within the original matrix that was used to estimate the model. 

This function allows to easily predict the group to which a case belongs, which in addition to being used to evaluate the quality of the model, it also serves to be able to use the model, i.e., to predict to which category a particular case belongs, which may be of great interest for example in medicine.

In order to use this function, it is necessary, to have first calculated the logistic model with the binomial \link{XI6} function.

\strong{EXAMPLE}

The data must have the same format, that is, the same variables in the same position as the matrix of data used to estimate the model with the \link{XI6} function. In addition, the working directory must be the same that was used when the estimated model with the \link{XI6} function.

The study consisted of examining patients which have been diagnosed a type of cancer, as well as a sample of people who do not have it. However, these data were not included when the original binomial logistic regression model was estimated (see the example of the \link{XI6} function). The objective is to predict whether a person can have that type of cancer.

As mentioned above, in order to use this function, it is necessary to have first calculated the binomial logistic model with the binomial logistic model with the \link{XI6} function. It is also very important that the group of reference, in this case \emph{resp="Yes"}, be equal to the specified one when calculating the binomial logistic model with the \link{XI6} function.

The results show that the success rate is 88.3\%, in these 762 cases that the database comprise.
}
\examples{
\dontrun{

data(ZXI8)

XI7(data=ZXI8, cat="Cancer", resp="Yes")

}
}
\keyword{XI7}
