\name{XI9}
\alias{XI9}
\encoding{latin1}
\title{MULTINOMIAL LOGISTIC REGRESSION-PREDICTION}
\description{It allows to calculate the category to which a case belongs, being able to carry out the calculation for many cases at the same time, using the regression models without steps, by steps or optimized, which are estimated with the \link{XI8} function.}
\usage{
XI9(data, cat, model="Model.rda", file="Model predictions.csv", na="NA",
dec=",", row.names=FALSE)
}
\arguments{
  \item{data}{Data file.}
  \item{cat}{Dependent variable.}
  \item{model}{The file name with the estimated model using the function \link{XI8}.}
  \item{file}{CSV FILE. Filename with the predictions of the multinomial logistic model, for each case.}
  \item{na}{CSV FILE. Text that is used in the cells without data.}
  \item{dec}{CSV FILE. It defines whether the comma "," or dot "." are used as decimal separators.}
  \item{row.names}{CSV FILE. Logical value which defines whether there are identifiers on the rows or a vector with a text for each of the rows.}
}
\value{A CSV file is obtained with the predictions of the logistic model for each case.}  
\details{
\strong{XI.2.1. Logistic regression}

\emph{XI.2.1.2. Multinomial Logistic Regression}

XI.2.1.2.2. Prediction of the model 

The percentage of cases correctly identified is an important parameter to evaluate the quality of the logistic regression model. However, a better parameter to evaluate the quality of the model is to check the degree of success using some data that had not been included within the original matrix used to estimate the model.

This function allows to easily predict the group to which a case belongs, which in addition to being used to evaluate the quality of the model, it also serves to be able to use the model, i.e., to predict to which category a particular case belongs, which may be of great interest for example in medicine.

In order to use this function, it is necessary, to have first calculated the logistic model with the multinomial \link{XI8} function.

\strong{EXAMPLE}

The data must have the same format, that is, the same variables in the same position as the matrix of data used to estimate the model with the \link{XI8} function. In addition, the working directory must be the same that was used when the estimated model with the \link{XI8} function.

The data are body measures of several species of fish (continuous variables), as well as the type of mouth they have (categorical variable), of the same population of the data that were used for the example of the function \link{XI8}. However, these data were not included when the original model was estimated. As it is known to which family each individual belongs, the objective is to evaluate the quality of the model by means of the degree of identification success with these individuals.

As mentioned above, it is necessary to have first calculated the regression models without steps, by steps or optimized, which are estimated with the \link{XI8} function.

The results show that the success rate is 100\%, in these 29 individuals that the database comprise. Therefore, it seems that the model obtained is quite reliable.}
\examples{
\dontrun{

data(ZXI10)

XI9(data=ZXI10, cat="Family")

}
}
\keyword{XI9}
