\name{XIII2}
\alias{XIII2}
\encoding{latin1}
\title{PRINCIPAL COMPONENT ANALYSIS}
\description{An Principal Component Analysis is applied.} 
\usage{
XIII2(data, var, cat=NULL, labels=NULL, ellipse=FALSE, convex=FALSE, dim=c(1,2),
VIF=FALSE, threshold=10, ResetPAR=TRUE, PAR=NULL, PCA=NULL, SCATTERPLOT=NULL,
COLOR=NULL, PCH=NULL, XLIM=NULL, YLIM=NULL, XLAB=NULL, YLAB=NULL, LEGEND=NULL,
AXIS=NULL, MTEXT= NULL, TEXTvar=NULL, TEXTlabels=NULL, arrows=TRUE, larrow=0.7,
colArrows="black", file1="Output.txt", file2="Var loadings.csv",
file3="Cat loadings.csv", na="NA", dec=",", row.names=TRUE)
}
\arguments{
  \item{data}{Data file.}
  \item{var}{Variables that are included in the analysis.}
  \item{cat}{Categories of cases.}
  \item{labels}{Variable that allows to display a label for each case.}
  \item{ellipse}{If it is TRUE, the ellipses with the levels of significance to the 0.5 (inner ellipse) and 0.95 (outer ellipse) of each category of the variable \emph{cat} are depicted. These levels of significance can be modified by entering the function \link[car]{scatterplot} using the argument \emph{SCATTERPLOT} and modifying the argument \emph{levels=c(0.5,0.95)}.}
  \item{convex}{If it is TRUE the convex hull is depicted for each category.}
  \item{dim}{Vector with two values indicating the axes that are shown in the graph.}
  \item{VIF}{If it is TRUE, the inflation factor of the variance (VIF) is used to select the highly correlated variables and, therefore, not correlated variables are excluded from the analysis.}
  \item{threshold}{Cut-off value for the VIF.}
   \item{ResetPAR}{If it is FALSE, the default condition of the function \link{PAR} are not placed and those defined by the user on previous graphics are maintained.}
  \item{PAR}{It accesses the\link{PAR} function that allows to modify many different aspects of the graphs.}
  \item{PCA}{It accesses the \link[stats]{prcomp} function of the stats package.}
  \item{SCATTERPLOT}{It accesses the function \link[car]{scatterplot} of the car package.}
  \item{COLOR}{It allows to modify the colors of the graph, but they must be as many as different groups the variable \emph{cat} has.}
  \item{PCH}{Vector with the symbols on the chart, which must be as many as different groups the variable \emph{cat} has. If it is NULL, they are automatically calculated starting with the symbol 15.}
  \item{XLIM, YLIM}{Vectors with the limits of the axes \emph{X} and \emph{Y}.}
  \item{XLAB, YLAB}{Legends of the axes \emph{X} and \emph{Y}.}
  \item{LEGEND}{It allows to include or to modify a legend.}
  \item{AXIS}{It allows to add axes.}
  \item{MTEXT}{It allows to add text in the margins of the graph.}
  \item{TEXTvar}{It allows to modify the labels of the variables in the graph.}
  \item{TEXTlabels}{It allows to modify the labels of the cases in the graph.}
  \item{arrows}{If it is TRUE the arrows are shown in the scatterplot.}
  \item{larrow}{It modifies the length of the arrows.}
  \item{colArrows}{Colors of the arrows.}
  \item{file1}{TXT FILE. Name of the output file with the results.}
  \item{file2}{CSV FILE. Name of the output file with the coordinates of the variables in the graph.}
  \item{file3}{CSV FILE. Name of the output file with the coordinates of the cases in the graph.}
  \item{na}{CSV FILES. Text that is used in the cells without data.}
  \item{dec}{CSV FILES. It defines if a comma " ," or a dot " ." is used as decimal separator.}
  \item{row.names}{CSV FILES. Logical value that defines if identifiers are put in rows or a vector with a text for each of the rows.}
}
\value{A TXT file with the VIF is obtained, the correlations between variables, and the results of the Analysis of Principal Components. In addition a 2D graph representing the variables and categories is obtained.}
\details{
\strong{XIII. FACTORIAL MULTIVARIATE ANALYSES}

\strong{XIII.2. PRINCIPAL COMPONENT ANALYSIS}

It consists of the transformation of the whole original variables in another set of variables -Principal Components- obtained as a linear combination of those. The new variables in the same number as the old ones still retain all the information -in what refers to the variability of the set of objects- of the primitive variables, but most of the major components have a variability so small that can be ignored, in such a way that a few components -usually three or fewer- allow to represent and reasonably explain the set of objects in the sample without significant loss of information. 

The main virtue of the Principal Component Analysis (PCA) consists precisely in the reduction of the complexity of the data, the passing of many variables to few (often one or two), that can be represented graphically. Against this advantage, the drawback of the new variables is in the partial loss of information (often small) and in the fact that the original variables have a real meaning of lacking basic components, which are a mixture or combination of variables.

The first main component is a linear combination of the original variables that has maximum variance. The second component is the linear combination of the original variables with maximum variance with the added condition to become independent from the first (orthogonal), and thus, all the main components can be obtained, which remaining independent among them, contain different information, since the independence or absence of correlation means that the new variables or components do not share common information. Each principal component explains therefore the maximum possible residual variability (that have not already explained the previous ones).

To find the optimal combinations of the original variables, the eigenvalues and eigenvectors of the matrix communality covariance (or correlation matrix) should be calculated. The eigenvalues, sorted from highest to lowest are the variances of the new components, and eigenvectors express the linear combinations that define the major components.

It should be decided how many components must be preserved: a high number allows to explain a larger proportion of the total variability, and a low number allows to obtain for greater simplicity in the graphical representation. There are several criteria that can help when it comes to rule: 

- Criterion of the variance. The components explaining a sufficient percentage (e.g. 80\% or 90\%) variance are selected. 

- Criterion of Kaiser. The components whose variances (eigenvalues) are higher than the average variance are preserved.

- Graph of sedimentation (Scree plot).  The eigenvalues that generally decrease rapidly at the beginning and slowly after are represented, and only those that are above the elbow of the curve are preserved. 

- Two components. Keeping only the first two allows to build a graph in two dimensions which is usually the most appropriate to describe the dataset. 

The only condition for the Principal Component Analysis can be applied is that variables be quantitative. However, there is another condition or assumptions necessary to make its application to be useful: the original variables should be correlated. The higher the correlation between the variables, the greater the proportion of variance explained by the first components and, therefore, the smaller the loss of information to keep them apart from the rest.

To test if the variables are correlated, there are several procedures: 

- Inspect the matrix of correlations. It could be observed if the majority of the coefficients of linear correlation between the original variables are close to 1 or -1. 

- Inspect the matrix of values of \emph{p} of the contrast of the invalidity of correlation coefficients. It contrasts -for each one of the coefficients of correlation- that the hypothesis is zero. The value \emph{p} must be less than the significance level (usually 0.05) to reject this hypothesis. In this way, the matrix of values of \emph{p}, when there is correlation, must be comprised mostly of zeros or very small values.

- Determinant of the matrix of correlations. Takes a value close to 1 when there is no correlation and next to zero when there is correlation. 

- Test of sphericity Bartlett. It is based on the determinant of the matrix of correlations and tests the hypothesis of "sphericity" or absence of correlation with a single test. A value \emph{p} of the contrast lower than the level of chosen significance allows to reject the hypothesis and conclude that there is a correlation.

When the original variables are heterogeneous, that is to say, are expressed in different units of measure, it happens that the variability is determined by the choice of the unit of measure for each of them, which influences the results of the implementation of the ACP when assigning an arbitrary importance to each variable. To avoid this negative influence, the solution is to use the matrix of correlations in place of the covariance matrix, which is equivalent to typify the original variables. In this way all the variables will have average 0 and standard deviation 1. As this process involves a certain loss of information, in the case of homogeneous variables, the matrix of correlations in replacement of the covariance matrix should not be used.

Once obtained the linear combinations that define the major components, we can interpret the coefficients (saturations or loads): the higher its absolute value, has greater influence that variable in the construction of the component. It is possible to interpret the components, and assign generic meanings, from the set of variables with the greatest weight in its construction.

To facilitate this interpretation of the components and assign them any meaning, the graph of saturations can be useful, because that shows -at the level of the first two components- the coefficients or saturations for each variable, so that each original variable is represented as a point in this plane. The variables that are more remote with respect to the zero of the horizontal axis are the ones that give meaning to the first component (that often expresses a generic idea of "size"), and those that are more distant relative to the zero of the vertical axis are those that give meaning to the second component (often reflects a generic idea of "shape"). The variables near the center of coordinates have no interest, and the variables that are moving away from both axes are common to both components and not helping their interpretation. The graph can also be made for other components different from the first two.

The main result of this technique is in general the chart of the scores. This is the representation, in the plane of the first two components, the coordinates of the points that represent the elements of the set object (rows or cases in our data). This representation allows to describe the set of multi-dimensional data in a relatively easy way. It may be useful to add the chart case labels or brands. The original variables have to be correlated to make the method work well. The use of the inflation factor of the variance (VIF) that is proposed as a criterion for optionally select the variables that must be used in the ACP, allows to exclude those that are poorly correlated with the remaining ones, which in general would appear associated with unimportant principal components (other than the first), but this is not necessarily always the case, for what this automatic selection of variables should be used with caution, only as an aid in the selection of variables to be used.

\strong{FUNCTIONS}

The Principal Components Analysis was performed with the \link[stats]{prcomp} function of the stats package. The \link[usdm]{vif} function of the usdm package was used for the calculation of VIF (Naimi, 2013; Naimi et al., 2014). To perform the \emph{biplot} graph the \link[car]{scatterplot} function of the car package was used (Fox et al., 2014). The arrows are depicted with the function \link[IDPmisc]{Arrows} of the package IDPmisc (Locher & Ruckstuhl, 2014). The convex hull is estimated with the function \link[grDevices]{chull} of the package grDevices. KMO test was performed with the function \link[psych]{KMO} of the package psych (Revelle, 2018). Bartlett's test sphericity was performed with the function \link[REdaS]{bart_spher} of the package REdaS (Maier, 2015). 

\strong{EXAMPLE}

The study was to analyze the demographic parameters of 57 countries in Europe, Africa and America. The variables used were male and female life expectancy at birth (in years of life), the mortality rates, infant mortality, birth, and fertility, the gross domestic product per capita (in thousands of dollars per year) and the literacy rate for men and women (in percentage) in the year 2000. The data were obtained from The World Bank (\url{http://www.worldbank.org/}). The objective is to determine which are the demographic parameters to show greater variability among countries and, therefore, which are responsible for the differences that exist among them. 

\strong{Step 1.}

First, all variables are used \emph{var=c("LifeExpF", "LifeExpM", "Mortinf", "PIB_cap", "Birthrate", "Mortality", "Fertility", "LiteracyM", "LiteracyF")} and as categories or classification variable continent is used \emph{cat="Continent"}. Then the analysis is performed by eliminating the variables that are uncorrelated, for what it is necessary to specify \emph{VIF=TRUE}, which means that it will eliminate those with VIF below the selected threshold, which by default is \emph{threshold= 10}. For this reason, mortality, and the GDP will be deleted automatically.

The first thing that is displayed in the results are the values of VIF. As mentioned above, the original variables must be correlated, to achieve a greater proportion of variance explained by the first components.

The next result is the KMO test, which tells us if the variables are suitable for the Principal Components Analysis. The value must be greater than 0.5. Therefore, all variables that do not have a value greater than 0.5, could be eliminated from the analysis. In the case that the value is exactly 0.5, it means that is not possible to estimate the KMO.

The second statistic is Bartlett's sphericity test. A value \emph{p} of the contrast smaller than 0.05 allows rejecting the hypothesis and concluding that there is correlation. Therefore, for the Principal Components Analysis to be valid, the probability must be less than 0.05, as it is in this case.

As can be seen in the matrix of values of \emph{p}, all are less than 0.05 which indicates that none of the coefficients of correlation seems to be null. Therefore, all variables are correlated. The results also show the relative contribution of each axis. 

The first axis explains 91.1\%, the second 5.2\% and the third 0.2\% of the observed variation. The first two axes explain 96.3\% of the variance. In Figure XIII.5  is observed that in the first axis, the countries of Europe, America and Africa are well differentiated. Those in Europe are characterized by high life expectancy and high literacy, in both men and women. The countries of Africa due to its high infant mortality and high birth rate. The ellipses show the levels of significance to the 0.5 (inner ellipse) and 0.95 (outer ellipse) of each of the sampling sites. It is an indicator of the degree of overlap between the continents. These levels can be modified by entering in the scatterplot function using the argument \emph{SCATTERPLOT} and modifying the argument \emph{levels=c(0.5,0.95)}. With some examples it is observed that it is not possible to estimate the ellipses and this error \emph{Error in svd(sqrt(w/sum(w)) * X, nu = 0):} is obtained or this other \emph{Error in cov.trob(cbind(x[use], y[use]), wt = weights[use]): no positive weights}. In case of obtaining these errors or simply not wanting to show the ellipses, again using the argument \emph{ellipse=FALSE}.
\tabular{c}{
\figure{RXIII4}{options: width=3.7in}
}
\tabular{c}{
\strong{Figure XIII.5.} 2D Principal Component Analysis showing the observed variability\cr
in demographic parameters of the 57 analyzed countries.\cr
\figure{FXIII5}{options: width=2.7in}
}
\strong{Step 2.}

The analysis is done but without deleting any variable, so the option by default \emph{VIF=FALSE} is left. With \emph{labels="Country"}, the cases that are the names of the countries are specified. Convex hull is used instead of the ellipses with the arguments \emph{convex=TRUE} and \emph{ellipse=FALSE}.
\tabular{c}{
\figure{RXIII5}{options: width=3.6in}
}
As expected, there are values of p>0.05 in the correlation matrix, which means that not all variables are correlated. In addition, it is also observed that the first axis explains 81.86\% of the observed variability, the second 10.2\% and the third the 4.77\%. The two first axes explained 92.1\% of the variance, which is lower, as was expected, where only the correlated variables (96.3\%) were used. Again continents (Figure XIII.7) are separated, where Europe is distinguished by a higher GDP. 
\tabular{c}{
\strong{Figure XIII.7.} 2D Principal Component Analysis showing the observed variability in\cr
demographicparameters, without removing uncorrelated ones, of the 57 analyzed countries.\cr
\figure{FXIII7}{options: width=2.7in}
}
}
\references{
Fox, J., Weisberg, S., Adler, D., Bates, D., Baud-Bovy, G., Ellison, S., Firth, D., Friendly, M., Gorjanc, G., Graves, S., Heiberger, R., Laboissiere, R., Monette, G., Murdoch, D., Nilsson, H., Ogle, D., Ripley, B., Venables, W. & Zeileis, A. (2014) Companion to Applied Regression. R package version 2.0-20. Available at: \url{http://CRAN.R-project.org/package=car}.

Locher, R. & Ruckstuhl, A. (2014) Utilities of Institute of Data Analyses and Process Design. R package version 1.1.17. Available at: \url{http://CRAN.R-project.org/package=IDPmisc}.

Maier, M.J. (2015) Companion Package to the Book 'R: Einfhrung durch angewandte Statistik. R package version 0.9.3. Available at: \url{http://CRAN.R-project.org/package=REdaS}.

Naimi, B. (2013) Uncertainty analysis for species distribution models. R package version 3.5-0. Available at: \url{http://CRAN.R-project.org/package=usdm}.

Naimi, B., Hamm, N.A.S., Groen, T.A., Skidmore, A.K., & Toxopeus, A.G. (2014) Where is positional uncertainty a problem for species distribution modelling? \emph{Ecography}, 37: 191-203.

Revelle,W. (2018) Procedures for Psychological, Psychometric, and Personality Research. R package version 1.8.4. Available at: \url{http://CRAN.R-project.org/package=psych}.
}
\examples{
\dontrun{
data(ZXIII2)

#Step 1
XIII2(data=ZXIII2, var=c("LifeExpF", "LifeExpM", "Mortinf", "PIB_cap", "Birthrate",
"Mortality", "Fertility", "LiteracyM", "LiteracyF"), cat="Continent",
VIF=TRUE, ellipse=TRUE)

#Step 2
XIII2(data=ZXIII2, var=c("LifeExpF", "LifeExpM", "Mortinf",
"PIB_cap", "Birthrate",
"Mortality", "Fertility", "LiteracyM", "LiteracyF"), cat="Continent",
labels="Country", convex=TRUE, XLIM=c(-4,6), YLIM=c(-2,1.7))
}
}
\keyword{XIII2}
