\name{XV5}
\alias{XV5}
\encoding{latin1}
\title{DATA STANDARDIZATION}
\description{Variables are standardized to any range defined by the user (by default between 0 and 1) or you can simply standardize all the variables depending on one of them.}
\usage{
XV5(data, var, varRef=NULL, varCode=NULL, min=0, max=1, file="Standardized.csv",
na="NA", dec=",", row.names=FALSE)
}
\arguments{
  \item{data}{Data file.}
  \item{var}{Variables to be standardized.}
  \item{varRef}{If a variable is specified, all are standardized according to it, that is, all are divided by that variable.}
  \item{varCode}{Optionally, variables of the original matrix can be selected, which are not standardized, and are exported in the output file with standardized variables. For example, this allows to choose variables which are codes of rows.}
  \item{min, max}{Minimum and maximum values of the standardization range.}
  \item{file}{CSV FILE. Name of the file with the standardized variables.}
  \item{na}{CSV FILE. Text that is used in the cells without data.}
  \item{dec}{CSV FILE. Defines whether as decimal separator is used the comma "," or the dot ".".}
  \item{row.names}{CSV FILE. Logical value which defines whether there are identifiers on the rows or a vector with a text for each of the rows.}
}
\value{A CSV file is exported with the standardized variables and with the variables included in the argument \emph{varCode} if any variable was included in this argument.}
\details{

\strong{EXAMPLE}

The data are socioeconomic parameters of 57 countries in Europe, Africa and America. The variables used were male and female life expectancy at birth (in years of life), the mortality rates, infant mortality, birth, and fertility, the gross domestic product per capita (in thousands of dollars per year) and the literacy rate for men and women (in percentage) in the year 2000. The data were obtained from The World Bank (\url{http://www.worldbank.org/}). All the variables are standardized to the default range of 0 to 1 and the codes of the continent and the country are added.
}
\examples{
\dontrun{

data(ZXIII2)

XV5(data=ZXIII2, var=c("LifeExpF", "LifeExpM", "Mortinf", "PIB_cap",
"Birthrate", "Mortality", "Fertility", "LiteracyM", "LiteracyF"),
varCode=c("Continent", "Country"))
}
}
\keyword{XV5}